/*
 * $Id: adi.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The adi gauge $
 *
 * $Log: adi.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char adi_gauge_name[]	= 	GAUGE_NAME;
extern PELEMENT_HEADER      adi_list;
extern MOUSERECT            adi_rect[];

/*
 * forward declarations
 */
PELEMENT_HEADER adi_hsi_vertical_list[];
PELEMENT_HEADER adi_hsi_vertical_bg_list[];
PELEMENT_HEADER adi_hsi_horizontal_list[];
PELEMENT_HEADER adi_hsi_horizontal_bg_list[];
PELEMENT_HEADER adi_plane_pitch_list[];
PELEMENT_HEADER adi_plane_pitch_bg_list[];
PELEMENT_HEADER adi_plane_bank_list[];
PELEMENT_HEADER adi_fd_pitch_list[];
PELEMENT_HEADER adi_fd_bank_list[];
PELEMENT_HEADER adi_attitude_sprite_list[];
PELEMENT_HEADER adi_bg_list[];

void FSAPI adigaugeproc(PGAUGEHDR, int, UINT32 );
FLOAT64	FSAPI adi_attitude_sprite_cb( PELEMENT_SPRITE pelement );
FLOAT64	FSAPI adi_fd_bank_cb(PELEMENT_SLIDER pelement);
FLOAT64	FSAPI adi_fd_pitch_cb(PELEMENT_SLIDER pelement);
FLOAT64	FSAPI adi_plane_pitch_cb(PELEMENT_SLIDER pelement);
FLOAT64	FSAPI adi_plane_bank_cb(PELEMENT_NEEDLE pelement);
FLOAT64	FSAPI adi_hsi_horizontal_cb(PELEMENT_SLIDER pelement);
FLOAT64	FSAPI adi_hsi_vertical_cb(PELEMENT_SLIDER pelement);
FLOAT64	FSAPI adi_at_icon_cb(PELEMENT_ICON pelement);
FLOAT64	FSAPI adi_fd_icon_cb(PELEMENT_ICON pelement);
FLOAT64	FSAPI adi_ap_icon_cb(PELEMENT_ICON pelement);

GAUGE_HEADER_FS700( GAUGE_W, adi_gauge_name, &adi_list, \
					adi_rect, adigaugeproc, 0, 0, 0);



FAILURE_RECORD	adi_attitude_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
    {FAIL_GAUGE_ATTITUDE, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD	adi_fd_bank_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};


FAILURE_RECORD	adi_fd_pitch_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD	adi_plane_bank_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD	adi_plane_pitch_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD	adi_hsi_horizontal_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD	adi_hsi_vertical_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};



NONLINEARITY adi_plane_bank_nonlinearity[] =
{
   {{  58,   77}, -60, 0},
   {{  86,   52}, -30, 0},
   {{ 121,   44},   0, 0},
   {{ 152,   56},  30, 0},
   {{ 184,   78},  60, 0}
};


/*
 * flight director icon
 */
MAKE_ICON
(
	adi_fd_icon,
	BMP_ADI_FD_OFF,
	NULL,
	NULL,
	IMAGE_USE_ERASE | transparent,
	0,
	21, 17,
	MODULE_VAR_NONE,
	adi_fd_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)

/*
 * autopilot icon
 */
MAKE_ICON
(
	adi_ap_icon,
	BMP_ADI_AP_OFF,
	NULL,
	NULL,
	IMAGE_USE_ERASE | transparent,
	0,
	43, 17,
	AUTOPILOT_ACTIVE,
	adi_ap_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)

/*
 * autothrottle icon
 */
MAKE_ICON
(
	adi_at_icon,
	BMP_ADI_AT_OFF,
	NULL,
	NULL,
	IMAGE_USE_ERASE | transparent,
	0,
	65, 17,
	AUTOPILOT_AUTO_THROTTLE_ARM,
	adi_at_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)


/*
 * hsi vertical needle indicator
 */
MAKE_SLIDER
(
	adi_hsi_vertical,
	BMP_ADI_HSI_HORIZONTAL,
	&adi_hsi_vertical_list,
	adi_hsi_vertical_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 114, 187 },
	HSI_VERTICAL_NEEDLE, adi_hsi_vertical_cb, 1,
	MODULE_VAR_NONE, NULL, 0
)


/*
 * hsi vertical needle scale
 */
MAKE_STATIC
(
    adi_hsi_vertical_bg,
    BMP_ADI_HSI_VERTICAL_BG,
    &adi_hsi_vertical_bg_list,
    NULL,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	68,200
)


/*
 * hsi horizontal needle indicator
 */
MAKE_SLIDER
(
	adi_hsi_horizontal,
	BMP_ADI_HSI_HORIZONTAL,
	&adi_hsi_horizontal_list,
	adi_hsi_horizontal_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 201, 110 },
	MODULE_VAR_NONE, NULL, 0,
	HSI_HORIZONTAL_NEEDLE, adi_hsi_horizontal_cb, 1
)


/*
 * hsi horizontal needle scale
 */
MAKE_STATIC
(
    adi_hsi_horizontal_bg,
    BMP_ADI_HSI_HORIZONTAL_BG,
    &adi_hsi_horizontal_bg_list,
    NULL,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	212,66
)

/*
 * flight director pitch indicator
 */
MAKE_SLIDER
(
	adi_plane_pitch,
	BMP_ADI_PLANE_PITCH,
	&adi_plane_pitch_list,
	adi_plane_pitch_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 31, 113 },
	MODULE_VAR_NONE, NULL, 0,
	PLANE_PITCH_DEGREES, adi_plane_pitch_cb, 1
)


/*
 * plane pitch scale
 */
MAKE_STATIC
(
    adi_plane_pitch_scale_bg,
    BMP_ADI_PLANE_PITCH_BG,
    &adi_plane_pitch_bg_list,
    NULL,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	14,61
)

/*
 * plane bank needle
 */
MAKE_NEEDLE
(
	adi_plane_bank,
	BMP_ADI_PLANE_BANK,
	&adi_plane_bank_list,
	adi_plane_bank_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 122, 118 },
	{ 5, 118-44 },
	ATTITUDE_INDICATOR_BANK_DEGREES,
	adi_plane_bank_cb,
	adi_plane_bank_nonlinearity,
	6
)


/*
 * flight director pitch indicator
 */
MAKE_SLIDER
(
	adi_fd_pitch,
	BMP_FLIGHT_DIRECTOR_PITCH,
	&adi_fd_pitch_list,
	adi_fd_pitch_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 86, 121 },
	MODULE_VAR_NONE, NULL, 0,
	FLIGHT_DIRECTOR_PITCH, adi_fd_pitch_cb, -1
)


/*
 * flight director bank indicator
 */
MAKE_SLIDER
(
	adi_fd_bank,
	BMP_FLIGHT_DIRECTOR_BANK,
	&adi_fd_bank_list,
	adi_fd_bank_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 121, 83 },
	FLIGHT_DIRECTOR_BANK, adi_fd_bank_cb, 1,
	MODULE_VAR_NONE, NULL, 0
)


/*
 *
 */
#define ADI_ATTITUDE_SCALE 1.5

MAKE_SPRITE
(
	adi_attitude_sprite,
	BMP_ADI_ATTITUDE_SPRITE,
	&adi_attitude_sprite_list,
	adi_attitude_fail,
	IMAGE_USE_TRANSPARENCY,
	0,
    16, 25,
	122, 118,
	ADI_ATTITUDE_SCALE, ADI_ATTITUDE_SCALE,

	MODULE_VAR_NONE, NULL, 0,
	ATTITUDE_INDICATOR_PITCH_DEGREES, adi_attitude_sprite_cb,2.66666,
	ATTITUDE_INDICATOR_BANK_DEGREES, NULL, -1
)



/*
 * card background image
 */
MAKE_STATIC
(
    adi_bg,
    BMP_ADI_BG,
    &adi_bg_list,
    NULL,
	IMAGE_USE_ERASE,
	0,
	0,0
)

/*
 * priority lists
 */
PELEMENT_HEADER adi_hsi_vertical_list[] =
{
    &adi_ap_icon.header,
    &adi_fd_icon.header,
    &adi_at_icon.header,
	NULL
};
PELEMENT_HEADER adi_hsi_vertical_bg_list[] =
{
    &adi_hsi_vertical.header,
	NULL
};
PELEMENT_HEADER adi_hsi_horizontal_list[] =
{
    &adi_hsi_vertical_bg.header,
	NULL
};
PELEMENT_HEADER adi_hsi_horizontal_bg_list[] =
{
    &adi_hsi_horizontal.header,
	NULL
};
PELEMENT_HEADER adi_plane_pitch_list[] =
{
    &adi_hsi_horizontal_bg.header,
	NULL
};
PELEMENT_HEADER adi_plane_pitch_bg_list[] =
{
	&adi_plane_pitch.header,
	NULL
};
PELEMENT_HEADER adi_plane_bank_list[] =
{
	&adi_plane_pitch_scale_bg.header,
	NULL
};
PELEMENT_HEADER adi_fd_pitch_list[] =
{
	&adi_plane_bank.header,
	NULL
};
PELEMENT_HEADER adi_fd_bank_list[] =
{
	&adi_fd_pitch.header,
	NULL
};
PELEMENT_HEADER adi_attitude_sprite_list[] =
{
	&adi_fd_bank.header,
	NULL
};
PELEMENT_HEADER adi_bg_list[] =
{
	&adi_attitude_sprite.header,
	NULL
};


extern PELEMENT_HEADER      adi_list = &adi_bg.header;

////////////////////////////////////////////////////////////////////////////////
// gauge initialization proc
////////////////////////////////////////////////////////////////////////////////
void FSAPI adigaugeproc( PGAUGEHDR pgauge, int service_id, UINT32 extra_data )
{
	switch(service_id)
	{
	case PANEL_SERVICE_PRE_INSTALL:		// install_routine()
		break;

	case PANEL_SERVICE_PRE_INITIALIZE:	// initialize_routine()
		break;

	case PANEL_SERVICE_PRE_UPDATE:		// update_routine()
		if (bPanelLightOn)	// if panel lights, brighten all elements
		{
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]);																					// attitude sprite
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]);																			// fd bank
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]);																	// fd pitch
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);															// plane bank
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);													// plane pitch scale
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);											// plane pitch
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);									// hsi horizontal bg
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);							// hsi horizontal
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);					// hsi vertical bg
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);			// hsi vertical
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	// icons
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[1]);	// icons
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[2]);	// icons
		}
		else							// otherwise darken them
		{
			DARK_IMG(pgauge->elements_list[0]->N_E[0]);																					// attitude sprite
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]);																			// fd bank
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]);																	// fd pitch
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);															// plane bank
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);													// plane pitch scale
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);											// plane pitch
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);									// hsi horizontal bg
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);							// hsi horizontal
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);					// hsi vertical bg
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);			// hsi vertical
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	// icons
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[1]);	// icons
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[2]);	// icons
    	}
		lookup_var(&flight_director_active);
		if (flight_director_active.var_value.n!=0)	// if fd active, show fd axis
		{
			SHOW_IMAGE(pgauge->elements_list[0]->next_element[0]->next_element[0]);
			SHOW_IMAGE(pgauge->elements_list[0]->next_element[0]->next_element[0]->next_element[0]);
		}
		else										// otherwise hide
		{
			HIDE_IMAGE(pgauge->elements_list[0]->next_element[0]->next_element[0]);
			HIDE_IMAGE(pgauge->elements_list[0]->next_element[0]->next_element[0]->next_element[0]);
		}


		lookup_var(&glideslope_active);
		if ((int)glideslope_active.var_value.n!=0) // if we have gs, show gs slider
		{
			SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);									// hsi horizontal bg
			SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);							// hsi horizontal
		}
		else										// otherwise hide
		{
			HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);									// hsi horizontal bg
			HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);							// hsi horizontal
		}

		lookup_var(&deviation_active);
		if ((int)deviation_active.var_value.n!=0) // if we have deviation, show deviation slider
		{
			SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);					// hsi vertical bg
			SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);			// hsi vertical
		}
		else									// otherwise hide
		{
			HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);					// hsi vertical bg
			HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);			// hsi vertical
		}

		break;
	case PANEL_SERVICE_PRE_DRAW:		// draw_routine()
		break;

	case PANEL_SERVICE_PRE_KILL:		// kill_routine()
		break;
	}
}


MOUSERECT adi_rect[] =
{
    MOUSE_PARENT_BEGIN( 0, 0, 0, 0, HELPID_GAUGE_ATTITUDE_INDICATOR )
    MOUSE_PARENT_END
    { MOUSE_RECT_EOL, { 0, 0, 0, 0 }, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL }
};


#undef		GAUGE_NAME
#undef		GAUGEHDR_VAR_NAME
#undef		GAUGE_W

/*
 * adi attitude sprite update
 */
FLOAT64	FSAPI	adi_attitude_sprite_cb( PELEMENT_SPRITE pelement )
{
	FLOAT64		val = pelement->source_var_y.var_value.n;

	if( val > ATTITUDE_PITCH_LIMIT )
		val = ATTITUDE_PITCH_LIMIT;
	else if( val < -ATTITUDE_PITCH_LIMIT )
		val = -ATTITUDE_PITCH_LIMIT;
	return val;
}

/*
 * adi fd bank update
 */
FLOAT64	FSAPI adi_fd_bank_cb(PELEMENT_SLIDER pelement)
{
	FLOAT64 f = pelement->source_var_x.var_value.n;
	if (f>45)
		f = 45;
	else if (f< -45)
		f = -45;
	return f;

}

/*
 * adi fd pitch update
 */
FLOAT64	FSAPI adi_fd_pitch_cb(PELEMENT_SLIDER pelement)
{
	FLOAT64 f = pelement->source_var_y.var_value.n;
	if (f>45)
		f = 45;
	else if (f< -45)
		f = -45;
	return f;

}

/*
 * plane bank update
 */
FLOAT64	FSAPI adi_plane_bank_cb(PELEMENT_NEEDLE pelement)
{
	FLOAT64 f = pelement->source_var.var_value.n;
	if (f>60)
		f = 60;
	else if (f< -60)
		f = -60;
	return f+90;
}

/*
 * adi fd pitch update
 */
FLOAT64	FSAPI adi_plane_pitch_cb(PELEMENT_SLIDER pelement)
{
	FLOAT64 f = pelement->source_var_y.var_value.n;
	if (f>45)
		f = 45;
	else if (f< -45)
		f = -45;
	return f;

}

/*
 * hsi horizontal needle (glideslope)
 */
FLOAT64	FSAPI adi_hsi_horizontal_cb(PELEMENT_SLIDER pelement)
{
	FLOAT64 f = pelement->source_var_y.var_value.n;
	return f*45;

}

/*
 * hsi vertical needle update
 */
FLOAT64	FSAPI adi_hsi_vertical_cb(PELEMENT_SLIDER pelement)
{
	FLOAT64 f = pelement->source_var_x.var_value.n;
	return f*45;

}


/*
 * auto throttle icon update
 */
FLOAT64	FSAPI adi_at_icon_cb(PELEMENT_ICON pelement)
{
	return (0!=pelement->source_var.var_value.n) ? 1 : 0;
}

/*
 * flight director icon update
 */
FLOAT64	FSAPI adi_fd_icon_cb(PELEMENT_ICON pelement)
{
	lookup_var(&flight_director_active);
	return (0!=flight_director_active.var_value.n) ? 1 : 0;
}

/*
 * auto pilot master update
 */

FLOAT64	FSAPI adi_ap_icon_cb(PELEMENT_ICON pelement)
{
	return (0!=pelement->source_var.var_value.n) ? 1 : 0;
}
