/*
 * $Id: airspeed.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The airspeed gauge $
 *
 * $Log: airspeed.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char airspeed_gauge_name[]	= GAUGE_NAME;
extern PELEMENT_HEADER      airspeed_list;
extern MOUSERECT            airspeed_rect[];
static UINT nAirspeed = 0;

/*
 * forward declarations
 */
PELEMENT_HEADER airspeed_airspeed_list[];
PELEMENT_HEADER airspeed_autopilot_speed_lock_list[];
PELEMENT_HEADER airspeed_mach_10_icon_list[];
PELEMENT_HEADER airspeed_mach_1_icon_list[];
PELEMENT_HEADER airspeed_airspeed_speed_100_icon_list[];
PELEMENT_HEADER airspeed_airspeed_speed_10_icon_list[];
PELEMENT_HEADER airspeed_airspeed_speed_1_icon_list[];
PELEMENT_HEADER airspeed_card_list[];

void FSAPI airspeedgaugeproc(PGAUGEHDR, int, UINT32);
FLOAT64 FSAPI airspeed_airspeed_speed_1_icon_update(PELEMENT_ICON pelement);
FLOAT64 FSAPI airspeed_airspeed_speed_10_icon_update(PELEMENT_ICON pelement);
FLOAT64 FSAPI airspeed_airspeed_speed_100_icon_update(PELEMENT_ICON pelement);
FLOAT64 FSAPI airspeed_mach_speed_1_icon_update(PELEMENT_ICON pelement);
FLOAT64 FSAPI airspeed_mach_speed_10_icon_update(PELEMENT_ICON pelement);
FLOAT64 FSAPI airspeed_airspeed_hold_var_needle_cb(PELEMENT_NEEDLE pelement);
FLOAT64 FSAPI airspeed_barber_pole_cb(PELEMENT_NEEDLE pelement);
FLOAT64 FSAPI airspeed_airspeed_cb(PELEMENT_NEEDLE pelement);

GAUGE_HEADER_FS700( GAUGE_W, airspeed_gauge_name, &airspeed_list, \
					airspeed_rect, airspeedgaugeproc, 0, 0, 0);

NONLINEARITY airspeed_airspeed_hold_var_needle_nonlinearity[] =
{
   {{  90,   12}, 60, 0},
   {{ 131,   22}, 80, 0},
   {{ 158,   51}, 100, 0},
   {{ 168,   89}, 120, 0},
   {{ 158,  128}, 140, 0},
   {{ 130,  156}, 160, 0},
   {{ 110,  165}, 180, 0},
   {{  85,  167}, 200, 0},
   {{  32,  141}, 250, 0},
   {{  15,  109}, 300, 0},
   {{  14,   73}, 350, 0},
   {{  30,   40}, 400, 0},
   {{  57,   19}, 450, 0}
};

NONLINEARITY airspeed_barber_pole_nonlinearity[] =
{
   {{  91,   15}, 60, 0},
   {{ 128,   26}, 80, 0},
   {{ 155,   51}, 100, 0},
   {{ 163,   89}, 120, 0},
   {{ 153,  124}, 140, 0},
   {{ 129,  152}, 160, 0},
   {{ 108,  161}, 180, 0},
   {{  85,  164}, 200, 0},
   {{  36,  137}, 250, 0},
   {{  22,  107}, 300, 0},
   {{  21,   73}, 350, 0},
   {{  36,   45}, 400, 0},
   {{  61,   25}, 450, 0}
};

NONLINEARITY airspeed_airspeed_nonlinearity[] =
{
   {{  91,   15}, 60, 0},
   {{ 128,   26}, 80, 0},
   {{ 155,   51}, 100, 0},
   {{ 163,   89}, 120, 0},
   {{ 153,  124}, 140, 0},
   {{ 129,  152}, 160, 0},
   {{ 108,  161}, 180, 0},
   {{  85,  164}, 200, 0},
   {{  36,  137}, 250, 0},
   {{  22,  107}, 300, 0},
   {{  21,   73}, 350, 0},
   {{  36,   45}, 400, 0},
   {{  61,   25}, 450, 0}
};
/*
 * FAILURE RECORDS
 */
FAILURE_RECORD airspeed_bg_fail[] =
{
   {FAIL_GAUGE_AIRSPEED, FAIL_ACTION_NONE},
   {FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD airspeed_airspeed_speed_1_icon_fail[] =
{
   {FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
   {FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
   {FAIL_GAUGE_AIRSPEED, FAIL_ACTION_FREEZE},
   {FAIL_SYSTEM_PITOT_STATIC, FAIL_ACTION_FREEZE},
   {FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD airspeed_airspeed_speed_10_icon_fail[] =
{
   {FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
   {FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
   {FAIL_GAUGE_AIRSPEED, FAIL_ACTION_FREEZE},
   {FAIL_SYSTEM_PITOT_STATIC, FAIL_ACTION_FREEZE},
   {FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD airspeed_airspeed_speed_100_icon_fail[] =
{
   {FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
   {FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
   {FAIL_GAUGE_AIRSPEED, FAIL_ACTION_FREEZE},
   {FAIL_SYSTEM_PITOT_STATIC, FAIL_ACTION_FREEZE},
   {FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD airspeed_mach_speed_1_icon_fail[] =
{
   {FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
   {FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
   {FAIL_GAUGE_AIRSPEED, FAIL_ACTION_FREEZE},
   {FAIL_SYSTEM_PITOT_STATIC, FAIL_ACTION_FREEZE},
   {FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD airspeed_mach_speed_10_icon_fail[] =
{
   {FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
   {FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
   {FAIL_GAUGE_AIRSPEED, FAIL_ACTION_FREEZE},
   {FAIL_SYSTEM_PITOT_STATIC, FAIL_ACTION_FREEZE},
   {FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD airspeed_barber_pole_fail[] =
{
   {FAIL_GAUGE_AIRSPEED, FAIL_ACTION_FREEZE},
   {FAIL_SYSTEM_PITOT_STATIC, FAIL_ACTION_FREEZE},
   {FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD airspeed_airspeed_fail[] =
{
   {FAIL_GAUGE_AIRSPEED, FAIL_ACTION_FREEZE},
   {FAIL_SYSTEM_PITOT_STATIC, FAIL_ACTION_FREEZE},
   {FAIL_NONE, FAIL_ACTION_NONE}
};


/*
 * barber pole airspeed needle
 */
MAKE_NEEDLE
(
	airspeed_barber_pole,
	BMP_BARBER_POLE_AIRSPEED,
	NULL,
	airspeed_barber_pole_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 90, 89 },
	{ 5, 5 },
	BARBER_POLE_ASPD,
	airspeed_barber_pole_cb,
	airspeed_barber_pole_nonlinearity,
	6
)

/*
 * airspeed needle
 */
MAKE_NEEDLE
(
	airspeed_airspeed,
	BMP_AIRSPEED_AIRSPEED,
	&airspeed_airspeed_list,
	airspeed_airspeed_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 90, 89 },
	{ 5, 5 },
	MODULE_VAR_NONE,
	airspeed_airspeed_cb,
	airspeed_airspeed_nonlinearity,
	6
)

/*
 * airspeed hold var needle
 */
MAKE_NEEDLE
(
	airspeed_airspeed_hold_var_needle,
	BMP_AIRSPEED_AIRSPEED_HOLD_VAR_NEEDLE,
	&airspeed_autopilot_speed_lock_list,
	NULL,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 91, 90 },
	{ 78, 6 },
    //{ 30, 30 },
	AUTOPILOT_AIRSPEED_HOLD_VAR,
	airspeed_airspeed_hold_var_needle_cb,
	airspeed_airspeed_hold_var_needle_nonlinearity,
	6
)

/*
 * mach_10 icon
 */
MAKE_ICON
(
	airspeed_mach_speed_10_icon,
	BMP_AIRSPEED_SPEED10_0,
	&airspeed_mach_10_icon_list,
	airspeed_mach_speed_10_icon_fail,
	IMAGE_USE_ERASE,
	0,
	95, 57,
	MODULE_VAR_NONE,
	airspeed_mach_speed_10_icon_update,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	10,
	0.000000,
	0
)



/*
 * mach_1 icon
 */
MAKE_ICON
(
	airspeed_mach_speed_1_icon,
	BMP_AIRSPEED_SPEED10_0,
	&airspeed_mach_1_icon_list,
	airspeed_mach_speed_1_icon_fail,
	IMAGE_USE_ERASE,
	0,
	109, 57,
	MODULE_VAR_NONE,
	airspeed_mach_speed_1_icon_update,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	10,
	0.000000,
	0
)

/*
 * airspeed_100 icon
 */
MAKE_ICON(
	airspeed_airspeed_speed_100_icon,
	BMP_AIRSPEED_SPEED100_0,
	&airspeed_airspeed_speed_100_icon_list,
	airspeed_airspeed_speed_100_icon_fail,
	IMAGE_USE_ERASE,
	0,
	69, 107,
	MODULE_VAR_NONE,
	airspeed_airspeed_speed_100_icon_update,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	10,
	0.000000,
	0
)


/*
 * airspeed_10 icon
 */
MAKE_ICON(
	airspeed_airspeed_speed_10_icon,
	BMP_AIRSPEED_SPEED10_0,
	&airspeed_airspeed_speed_10_icon_list,
	airspeed_airspeed_speed_10_icon_fail,
	IMAGE_USE_ERASE,
	0,
	83, 107,
	MODULE_VAR_NONE,
	airspeed_airspeed_speed_10_icon_update,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	10,
	0.000000,
	0
)

/*
 * airspeed_1 icon
 */
MAKE_ICON
(
	airspeed_airspeed_speed_1_icon,
	BMP_AIRSPEED_SPEED1_0,
	&airspeed_airspeed_speed_1_icon_list,
	airspeed_airspeed_speed_1_icon_fail,
	IMAGE_USE_ERASE,
	0,
	97, 103,
	MODULE_VAR_NONE,
	airspeed_airspeed_speed_1_icon_update,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	10,
	0.000000,
	0
)


/*
 * priority lists
 */
PELEMENT_HEADER airspeed_airspeed_list[] =
{
	&airspeed_barber_pole.header,
	NULL
};

PELEMENT_HEADER airspeed_autopilot_speed_lock_list[] =
{
	&airspeed_airspeed.header,
	NULL
};

PELEMENT_HEADER airspeed_mach_10_icon_list[] =
{
	&airspeed_airspeed_hold_var_needle.header,
	NULL
};

PELEMENT_HEADER airspeed_mach_1_icon_list[] =
{
    &airspeed_mach_speed_10_icon.header,
	NULL
};

PELEMENT_HEADER airspeed_airspeed_speed_100_icon_list[] =
{
    &airspeed_mach_speed_1_icon.header,
	NULL
};

PELEMENT_HEADER airspeed_airspeed_speed_10_icon_list[] =
{
    &airspeed_airspeed_speed_100_icon.header,
	NULL
};

PELEMENT_HEADER airspeed_airspeed_speed_1_icon_list[] =
{
    &airspeed_airspeed_speed_10_icon.header,
	NULL
};

PELEMENT_HEADER      airspeed_card_list[] =
{
    &airspeed_airspeed_speed_1_icon.header,
	NULL
};


/*
 * card background image
 */
MAKE_STATIC
(
    airspeed_bg,
    BMP_AIRSPEED_BG,
    &airspeed_card_list,
    airspeed_bg_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	0,0
)


extern PELEMENT_HEADER      airspeed_list = &airspeed_bg.header;

////////////////////////////////////////////////////////////////////////////////
// tooltip stuff
static FLOAT64 FSAPI AirspeedToolTipGetMachIndicator(FLOAT64 number, ID id,
	PCSTRINGZ string, MODULE_VAR *source_var, PGAUGEHDR gauge)
{
	// input is in meters per second
	return (source_var->var_value.n/1000)*60;
}

MOUSE_TOOLTIP_ARGS (AirspeedToolTipMachIndicator)
	MOUSE_TOOLTIP_ARG(GPS_GROUND_SPEED, 0, NULL, NULL, NULL, AirspeedToolTipGetMachIndicator, NULL, NULL)
MOUSE_TOOLTIP_ARGS_END

MOUSERECT airspeed_rect[] =
{
	MOUSE_PARENT_BEGIN( 0, 0, 0, 0, HELP_NONE )
		MOUSE_PARENT_BEGIN( 29, 16, 150, 150, HELP_NONE )
			MOUSE_TOOLTIP_TEXT_ID(TOOLTIPTEXT_AIRSPEED_KILOS, AirspeedToolTipMachIndicator)
		MOUSE_PARENT_END
        MOUSE_PARENT_BEGIN( 8, 143, 32, 32, HELPID_CONCORDE_SPEED_SELECT )
        	MOUSE_CHILD_EVENT( 0, 0, 16, 32, CURSOR_DOWNARROW, MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, KEY_AP_SPD_VAR_DEC )
        	MOUSE_CHILD_EVENT( 16, 0, 16, 32, CURSOR_UPARROW, MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, KEY_AP_SPD_VAR_INC )
    	MOUSE_PARENT_END
	MOUSE_PARENT_END
	{
		MOUSE_RECT_EOL, { 0, 0, 0, 0 }, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL
	}
};


////////////////////////////////////////////////////////////////////////////////
// gauge initialization proc
////////////////////////////////////////////////////////////////////////////////
void FSAPI airspeedgaugeproc( PGAUGEHDR pgauge, int service_id, UINT32 extra_data )
{
	UINT f;
	switch(service_id)
	{
	case PANEL_SERVICE_PRE_INSTALL:		// install_routine()
		break;

	case PANEL_SERVICE_PRE_INITIALIZE:	// initialize_routine()
		break;

	case PANEL_SERVICE_PRE_UPDATE:		// update_routine()
		lookup_var(&airspeed);			// update and decompose airspeed number
		f = (UINT)airspeed.var_value.n;
		if (f>999)						// clip the value
			f = 999;
		nAirspeed = f;
		speed_1 =  f % 10;
		speed_10 =  f / 10 % 10;
		speed_100 =  f / 100 % 10;



		lookup_var(&mach_speed);		// update and decompose mach
		fMach = (mach_speed.var_value.n*3.2)/(double)0xffff;
		fMachSpeed = fMach;				// store current mach numbers

		if (fMach>0.9999)
			fMach = 0.9999;
		fMach*=100;

		f = (UINT)fMach;
		mach_1 = f % 10;
		mach_10 =   f / 10 % 10;

		if (bPanelLightOn)	// if panel lights, brighten all elements
		{
			BRIGHT_IMG(pgauge->elements_list[0]);																			// bg
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]);																	// speed_1
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]);															// speed_10
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]);													// speed_100
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);											// mach_1
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);									// mach_10
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);							// autopilot needle
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);					// barber pole
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);			// airspeed
		}
		else							// otherwise darken them
		{
			DARK_IMG(pgauge->elements_list[0]);																			// bg
			DARK_IMG(pgauge->elements_list[0]->N_E[0]);																	// speed_1
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]);															// speed_10
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]);													// speed_100
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);											// mach_1
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);									// mach_10
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);							// autopilot needle
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);					// barber pole
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);			// airspeed
    	}
		break;

	case PANEL_SERVICE_PRE_DRAW:		// draw_routine()
		break;

	case PANEL_SERVICE_PRE_KILL:		// kill_routine()
		break;
	}
}

#undef GAUGE_NAME
#undef GAUGEHDR_VAR_NAME
#undef GAUGE_W


/*
 * speed_1 icon update
 */
FLOAT64 FSAPI airspeed_airspeed_speed_1_icon_update(PELEMENT_ICON pelement)
{
	return (FLOAT64)speed_1;
}

/*
 * speed_10 icon update
 */
FLOAT64 FSAPI airspeed_airspeed_speed_10_icon_update(PELEMENT_ICON pelement)
{
	return (FLOAT64)speed_10;
}

/*
 * speed_100 icon update
 */
FLOAT64 FSAPI airspeed_airspeed_speed_100_icon_update(PELEMENT_ICON pelement)
{
	return (FLOAT64)speed_100;
}

/*
 * mach_1 icon update
 */
FLOAT64 FSAPI airspeed_mach_speed_1_icon_update(PELEMENT_ICON pelement)
{
	return (FLOAT64)mach_1;
}

/*
 * mach_10 icon update
 */
FLOAT64 FSAPI airspeed_mach_speed_10_icon_update(PELEMENT_ICON pelement)
{
	return (FLOAT64)mach_10;
}

/*
 * AUTOPILOT speed var update
 */
FLOAT64 FSAPI airspeed_airspeed_hold_var_needle_cb(PELEMENT_NEEDLE pelement)
{
	FLOAT64 f = pelement->source_var.var_value.n;
	if (f>450) f = 450;		// clip the value
	else if (f<60) f = 60;
	return f;
}

/*
 * barber pole airspeed callback
 */
FLOAT64 FSAPI airspeed_barber_pole_cb(PELEMENT_NEEDLE pelement)
{
	FLOAT64	dir = pelement->source_var.var_value.n/128;
	if (dir>450)
		dir = 450;
	else if (dir<60)
		dir=60;
	return dir;
}

/*
 * airspeed callback
 */
FLOAT64 FSAPI airspeed_airspeed_cb(PELEMENT_NEEDLE pelement)
{
	FLOAT64	dir;
    lookup_var(&airspeed);
	dir = airspeed.var_value.n;
	if (dir>450)
		dir = 450;
	else if (dir<60)
		dir=60;
	return dir;
}

