/*
 * $Id: altimet.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The altimeter gauge $
 *
 * $Log: altimet.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char altimeter_gauge_name[]	= 	GAUGE_NAME;
extern PELEMENT_HEADER      altimeter_list;
extern MOUSERECT            altimeter_rect[];

/*
 * forward declarations
 */
void FSAPI altimetergaugeproc(PGAUGEHDR, int, UINT32 );

//
PELEMENT_HEADER altimeter_altitude_lock_list[];
PELEMENT_HEADER altimeter_10000_icon_list[];
PELEMENT_HEADER altimeter_1000_icon_list[];
PELEMENT_HEADER altimeter_hund_tape_list[];
PELEMENT_HEADER altimeter_tenths_tape_list[];
PELEMENT_HEADER altimeter_tenths_tape_list[];
PELEMENT_HEADER altimeter_baro_pressure_string_list[];

FLOAT64 FSAPI altimeter_tenths_tape_cb(PELEMENT_MOVING_IMAGE pelement);
FLOAT64 FSAPI altimeter_hund_tape_cb(PELEMENT_MOVING_IMAGE pelement);
FLOAT64 FSAPI altimeter_1000_icon_update(PELEMENT_ICON pelement);
FLOAT64 FSAPI altimeter_10000_icon_update(PELEMENT_ICON pelement);
FLOAT64 FSAPI altimeter_baro_pressure_string_cb(PELEMENT_STRING pelement);
FLOAT64 FSAPI altimeter_altitude_lock_var_cb(PELEMENT_NEEDLE pelement);
FLOAT64 FSAPI altimeter_needle_cb(PELEMENT_NEEDLE pelement);

GAUGE_HEADER_FS700( GAUGE_W, altimeter_gauge_name, &altimeter_list, \
					altimeter_rect, altimetergaugeproc, 0, 0, 0);

FAILURE_RECORD altimeter_bg_fail[] =
{
   {FAIL_GAUGE_ALTIMETER, FAIL_ACTION_NONE},
   {FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD altimeter_needle_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_FREEZE},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_FREEZE},
	{FAIL_GAUGE_ALTIMETER, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD altimeter_tenths_tape_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_ALTIMETER, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD altimeter_hund_tape_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_ALTIMETER, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD altimeter_1000_icon_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_ALTIMETER, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD altimeter_10000_icon_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_ALTIMETER, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD altimeter_baro_pressure_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

NONLINEARITY altimeter_altitude_lock_var_nonlinearity[] =
{
   {{  73,    13},	0,		0	},
   {{  105,   23},	10,		0	},
   {{  128,   51},	20,		0	},
   {{  128,   89},	30,		0	},
   {{  107,  119},	40,		0	},
   {{  73,   129},	50,		0	},
   {{  39,   119},	60,		0	},
   {{  17,    89},	70,		0	},
   {{  18,    51},	80,		0	},
   {{  40,    23},	90,		0	}
};

/*
 * altimeter needle
 */
MAKE_NEEDLE
(
	altimeter_needle,
	BMP_ALTIMETER_NEEDLE,
	NULL,
	altimeter_needle_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 74, 74 },
	{ 5, 54 },

	MODULE_VAR_NONE,
	altimeter_needle_cb,
	NULL,
	8
)


/*
 * altimeter altitude lock var
 */
MAKE_NEEDLE
(
	altimeter_altitude_lock_var,
	BMP_ALTIMETER_ALTITUDE_LOCK_VAR,
	&altimeter_altitude_lock_list,
	NULL,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 73, 73 },
	{ 6, 56 },

	MODULE_VAR_NONE,
	altimeter_altitude_lock_var_cb,
	NULL,
	10
)

/*
 * barometric pressure string
 */
MAKE_STRING
(
	altimeter_baro_pressure_string,
	&altimeter_baro_pressure_string_list,
	altimeter_baro_pressure_string_fail,
	IMAGE_USE_ERASE,
	0,
	{ 41, 80 },
	{ 66, 20 },
	5,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	RGB(189,189,189),
	RGB(4,4,4),
	RGB(192,192,192),
	FONT_COURIER,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_LEFT,
	NULL,
	altimeter_baro_pressure_string_cb
)


/*
 * altimeter_10000 feet icon
 */
MAKE_ICON
(
	altimeter_10000_icon,
	BMP_ALTIMETER_10000_0,
	&altimeter_10000_icon_list,
	altimeter_10000_icon_fail,
	IMAGE_USE_ERASE,
	0,
	40, 44,
	MODULE_VAR_NONE,
	altimeter_10000_icon_update,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	10,
	0.000000,
	0
)

/*
 * altimeter_1000 feet icon
 */
MAKE_ICON
(
	altimeter_1000_icon,
	BMP_ALTIMETER_1000_0,
	&altimeter_1000_icon_list,
	altimeter_1000_icon_fail,
	IMAGE_USE_ERASE,
	0,
	53, 44,
	MODULE_VAR_NONE,
	altimeter_1000_icon_update,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	10,
	0.000000,
	0
)

/*
 * altimeter hundreds tape
 */
MAKE_MOVING
(
	altimeter_hund_tape,
	BMP_ALTIMETER_HUND_TAPE,
	&altimeter_hund_tape_list,
	altimeter_hund_tape_fail,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY,
	0,
	{ 65, 44 },
	MODULE_VAR_NONE, NULL, 0, 0,
	MODULE_VAR_NONE, altimeter_hund_tape_cb, 0, 99
)


/*
 * altimeter tenths tape
 */
MAKE_MOVING
(
	altimeter_tenths_tape,
	BMP_ALTIMETER_TENTHS_TAPE,
	&altimeter_tenths_tape_list,
	altimeter_tenths_tape_fail,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY,
	0,
	{ 79, 44 },
	MODULE_VAR_NONE, NULL, 0, 0,
	MODULE_VAR_NONE, altimeter_tenths_tape_cb, 0, 99
)

/*
 * priority lists
 */
PELEMENT_HEADER altimeter_altitude_lock_list[] =
{
	&altimeter_needle.header,
	NULL
};

PELEMENT_HEADER altimeter_baro_pressure_string_list[] =
{
	&altimeter_altitude_lock_var.header,
	NULL
};

PELEMENT_HEADER altimeter_10000_icon_list[] =
{
	&altimeter_baro_pressure_string.header,
	NULL
};

PELEMENT_HEADER altimeter_1000_icon_list[] =
{
	&altimeter_10000_icon.header,
	NULL
};

PELEMENT_HEADER altimeter_hund_tape_list[] =
{
	&altimeter_1000_icon.header,
	NULL
};

PELEMENT_HEADER altimeter_tenths_tape_list[] =
{
	&altimeter_hund_tape.header,
	NULL
};

PELEMENT_HEADER altimeter_card_list[] =
{
	&altimeter_tenths_tape.header,
	NULL
};


/*
 * card background image
 */
MAKE_STATIC
(
    altimeter_bg,
    BMP_ALTIMETER_BG,
    &altimeter_card_list,
    altimeter_bg_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	0,0
)


extern PELEMENT_HEADER      altimeter_list = &altimeter_bg.header;

////////////////////////////////////////////////////////////////////////////////
// gauge initialization proc
////////////////////////////////////////////////////////////////////////////////
void FSAPI altimetergaugeproc( PGAUGEHDR pgauge, int service_id, UINT32 extra_data )
{
	UINT i;
	switch(service_id)
	{
	case PANEL_SERVICE_PRE_INSTALL:		// install_routine()
		break;

	case PANEL_SERVICE_PRE_INITIALIZE:	// initialize_routine()
		break;

	case PANEL_SERVICE_PRE_UPDATE:		// update_routine()
		lookup_var(&baro_alt);

		i = (UINT)baro_alt.var_value.n;
		baro_alt_tenths	= i % 100;				// update altimeter tenths
		baro_alt_hund = i / 10 % 100;			// update altimeter hundreds
		baro_alt_thous = i / 1000 % 10;     	// update altimeter thousands
		baro_alt_ten_thous = i / 10000 % 10;	// update altimeter ten thousands


		if (bPanelLightOn)	// if panel lights, brighten all elements
		{
			BRIGHT_IMG(pgauge->elements_list[0]);															// card
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]);													// altimeter_tenths_tape
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]);											// altimeter_hund_tape
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]);									// altimeter_1000_icon
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);							// altimeter_10000_icon
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);					// baro pressure string
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);			// autopilot altitude
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	// altimeter needle
		}
		else							// otherwise darken them
		{
			DARK_IMG(pgauge->elements_list[0]);																// card
			DARK_IMG(pgauge->elements_list[0]->N_E[0]);														// altimeter_tenths_tape
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]);												// altimeter_hund_tape
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]);										// altimeter_1000_icon
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);								// altimeter_10000_icon
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);						// baro pressure string
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);				// autopilot altitude
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);		// altimeter needle
    	}
		break;
	case PANEL_SERVICE_PRE_DRAW:		// draw_routine()
		break;

	case PANEL_SERVICE_PRE_KILL:		// kill_routine()
		break;
	}
}


/*
 * mouse tooltip stuff
 */
static FLOAT64 FSAPI AltimeterToolTipGetValue(FLOAT64 number, ID id,
	PCSTRINGZ string, MODULE_VAR *source_var, PGAUGEHDR gauge)
{
	lookup_var(&baro_alt);
	return AltitudeLockVar.var_value.n * FEETTOMETERS;
}


MOUSE_TOOLTIP_ARGS (AltimeterToolTipValue)
	MOUSE_TOOLTIP_ARG (MODULE_VAR_NONE, 0, NULL, NULL, NULL, AltimeterToolTipGetValue, NULL, NULL)
MOUSE_TOOLTIP_ARGS_END


MOUSERECT altimeter_rect[] =
{
    MOUSE_PARENT_BEGIN( 0, 0, 0, 0, HELP_NONE )
	    MOUSE_PARENT_BEGIN( 0, 0, 152, 110, HELP_NONE )
			MOUSE_TOOLTIP_TEXT_ID(TOOLTIPTEXT_ALTIMETER_METERS, AltimeterToolTipValue)
		MOUSE_PARENT_END

	    MOUSE_PARENT_BEGIN( 8, 112, 28, 28, HELPID_GAUGE_ALTIMETER_SET )
    	    MOUSE_CHILD_EVENT( 0, 0, 14, 28, CURSOR_DOWNARROW, MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, KEY_KOHLSMAN_DEC )
	        MOUSE_CHILD_EVENT( 14, 0, 14, 28, CURSOR_UPARROW, MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, KEY_KOHLSMAN_INC )
    	MOUSE_PARENT_END
	    MOUSE_PARENT_BEGIN( 112, 110, 32, 32, HELPID_AUTOPILOT_ALTITUDE_INDICATOR )
    	    MOUSE_CHILD_EVENT( 0, 0, 16, 32, CURSOR_DOWNARROW, MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, KEY_AP_ALT_VAR_DEC )
        	MOUSE_CHILD_EVENT( 16, 0, 16, 32, CURSOR_UPARROW, MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, KEY_AP_ALT_VAR_INC )
	    MOUSE_PARENT_END
    MOUSE_PARENT_END
    { MOUSE_RECT_EOL, { 0, 0, 0, 0 }, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL }
};


#undef		GAUGE_NAME
#undef		GAUGEHDR_VAR_NAME
#undef		GAUGE_W

/*
 * update altimeter tenths tape
 */
FLOAT64 FSAPI altimeter_tenths_tape_cb(PELEMENT_MOVING_IMAGE pelement)
{
	return baro_alt_tenths;
}

/*
 * update altimeter hundreds tape
 */
FLOAT64 FSAPI altimeter_hund_tape_cb(PELEMENT_MOVING_IMAGE pelement)
{
	return baro_alt_hund;
}

/*
 * update altimeter thousands tape
 */
FLOAT64 FSAPI altimeter_1000_icon_update(PELEMENT_ICON pelement)
{
	return baro_alt_thous;
}

/*
 * update altimeter ten thousands tape
 */
FLOAT64 FSAPI altimeter_10000_icon_update(PELEMENT_ICON pelement)
{
	return baro_alt_ten_thous;
}

/*
 * update baro pressure string
 */
FLOAT64 FSAPI altimeter_baro_pressure_string_cb(PELEMENT_STRING pelement)
{
	FLOAT64 f, alt_atm, alt_pressure_in;
	lookup_var(&baro_pressure);
	f = baro_pressure.var_value.n;
	alt_atm = f/1013.25;
	alt_pressure_in = alt_atm * 29.92;
	sprintf(pelement->string, "%2.2f", alt_pressure_in);
	return f;
}

/*
 * autopilot altitude lock var update
 */
FLOAT64 FSAPI altimeter_altitude_lock_var_cb(PELEMENT_NEEDLE pelement)
{
	FLOAT64 f;
	UINT32 i;
	UINT32 j;
	lookup_var(&AltitudeLockVar);
	f = AltitudeLockVar.var_value.n;
	i = (UINT32)f;
	j = i / 10 % 100;
	j =  j * 360 / 100;
	return  j;
}

/*
 * autopilot altitude lock var update
 */
FLOAT64 FSAPI altimeter_needle_cb(PELEMENT_NEEDLE pelement)
{
	UINT32 i = baro_alt_hund;
	UINT32 j = i;
	j =  j * 360 / 100;
	return  j;
}

