/*
 * $Id: audio.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The audio gauge $
 *
 * $Log: audio.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char audio_gauge_name[]	= 	GAUGE_NAME;
extern PELEMENT_HEADER      audio_list;
extern MOUSERECT            audio_rect[];


/*
 * forward declarations
 */

PELEMENT_HEADER audio_bg_list[];

GAUGE_HEADER_FS700( GAUGE_W, audio_gauge_name, &audio_list, \
					audio_rect, NULL, 0, 0, 0);


/*
 * callback routines
 */
FLOAT64 FSAPI nav1_audio_icon_cb(PELEMENT_ICON pelement)
{
	return TRUE_FALSE(pelement);
}
FLOAT64 FSAPI nav2_audio_icon_cb(PELEMENT_ICON pelement)
{
	return TRUE_FALSE(pelement);
}
FLOAT64 FSAPI adf_audio_icon_cb(PELEMENT_ICON pelement)
{
	return TRUE_FALSE(pelement);
}
FLOAT64 FSAPI omi_audio_icon_cb(PELEMENT_ICON pelement)
{
	return TRUE_FALSE(pelement);
}

/*
 * nav 1 audio icon
 */
MAKE_ICON
(
	nav1_audio_icon,
	BMP_AUDIO_ICON_OFF,
	NULL,
	NULL,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY | IMAGE_USE_BRIGHT,
	0,
	3, 3,
	NAV1_MORSE_IDENT,
	nav1_audio_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)

/*
 * nav 2 audio icon
 */
MAKE_ICON
(
	nav2_audio_icon,
	BMP_AUDIO_ICON_OFF,
	NULL,
	NULL,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY | IMAGE_USE_BRIGHT,
	0,
	4, 12,
	NAV2_MORSE_IDENT,
	nav2_audio_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)

/*
 * adf audio icon
 */
MAKE_ICON
(
	adf_audio_icon,
	BMP_AUDIO_ICON_OFF,
	NULL,
	NULL,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY | IMAGE_USE_BRIGHT,
	0,
	4, 22,
	ADF_MORSE_IDENT,
	adf_audio_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)

/*
 * marker audio icon
 */
MAKE_ICON
(
	omi_audio_icon,
	BMP_AUDIO_ICON_OFF,
	NULL,
	NULL,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY | IMAGE_USE_BRIGHT,
	0,
	5, 32,
	MARKER_SOUND_TOGGLE,
	omi_audio_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)



/*
 * card background image
 */
MAKE_STATIC
(
    audio_bg,
    BMP_AUDIO_BG,
    &audio_bg_list,
    NULL,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	0,0
)

/*
 * priority lists
 */
PELEMENT_HEADER audio_bg_list[] =
{
	&nav1_audio_icon.header,
	&nav2_audio_icon.header,
	&adf_audio_icon.header,
	&omi_audio_icon.header,
	NULL
};


extern PELEMENT_HEADER      audio_list = &audio_bg.header;

MOUSERECT audio_rect[] =
{
	MOUSE_PARENT_BEGIN( 0, 0, 0, 0, HELP_NONE )

		// Toggle nav 1 morse code
		MOUSE_PARENT_BEGIN( 0, 0, 13, 8, HELP_NONE )
			MOUSE_CHILD_EVENT( 0, 0, 13, 8, CURSOR_HAND, MOUSE_LEFTSINGLE, KEY_RADIO_VOR1_IDENT_TOGGLE )
		MOUSE_PARENT_END

		// Toggle nav 2 morse code
		MOUSE_PARENT_BEGIN( 0, 9, 13, 8, HELP_NONE )
			MOUSE_CHILD_EVENT( 0, 0, 13, 8, CURSOR_HAND, MOUSE_LEFTSINGLE, KEY_RADIO_VOR2_IDENT_TOGGLE )
		MOUSE_PARENT_END

		// Toggle adf morse code
		MOUSE_PARENT_BEGIN( 0, 18, 13, 8, HELP_NONE )
			MOUSE_CHILD_EVENT( 0, 0, 13, 8, CURSOR_HAND, MOUSE_LEFTSINGLE, KEY_RADIO_ADF_IDENT_TOGGLE )
		MOUSE_PARENT_END

		// Toggle omi sound
		MOUSE_PARENT_BEGIN( 0, 27, 13, 8, HELP_NONE )
			MOUSE_CHILD_EVENT( 0, 0, 13, 8, CURSOR_HAND, MOUSE_LEFTSINGLE, KEY_MARKER_SOUND_TOGGLE )
		MOUSE_PARENT_END

	MOUSE_PARENT_END
	{
		MOUSE_RECT_EOL, { 0, 0, 0, 0 }, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL
	}
};


#undef		GAUGE_NAME
#undef		GAUGEHDR_VAR_NAME
#undef		GAUGE_W

