/*
 * $Id: autobrk.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The autobrake gauge $
 *
 * $Log: autobrk.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char autobrake_gauge_name[]	= 	GAUGE_NAME;
extern PELEMENT_HEADER      autobrake_list;
extern MOUSERECT            autobrake_rect[];


/*
 * forward declarations
 */
PELEMENT_HEADER autobrake_bg_list[];


GAUGE_HEADER_FS700( GAUGE_W, autobrake_gauge_name, &autobrake_list, \
					autobrake_rect, NULL, 0, 0, 0);


FLOAT64 FSAPI autobrake_icon_cb(PELEMENT_ICON pelement)
{
	return pelement->source_var.var_value.d;
}

// Element Entries
MAKE_ICON
(      
	autobrake_icon,
	BMP_AUTOBRAKE_ICON_RTO,
	NULL,
	NULL,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY,
	0,
	0, 0,
	PANEL_AUTOBRAKE_SWITCH, autobrake_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	6,
	0.000000,
	0 
)

/*
 * card background image
 */
MAKE_STATIC
(
    autobrake_bg,
    BMP_AUTOBRAKE_BG,
    &autobrake_bg_list,
    NULL,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	0,0
)

/*
 * priority lists
 */
PELEMENT_HEADER autobrake_bg_list[] =
{
	&autobrake_icon.header,
	NULL
};


extern PELEMENT_HEADER      autobrake_list = &autobrake_bg.header;

BOOL FSAPI IncAutoBrake(PPIXPOINT pp, FLAGS32 flg)
{
	MFSSoundResPlay(main_sound, FALSE);
	trigger_key_event(KEY_INC_AUTOBRAKE_CONTROL, 1);
	return 0;
}
BOOL FSAPI DecAutoBrake(PPIXPOINT pp, FLAGS32 flg)
{
	MFSSoundResPlay(main_sound, FALSE);
	trigger_key_event(KEY_DEC_AUTOBRAKE_CONTROL, 1);
	return 0;
}

MOUSERECT autobrake_rect[] = 
{
    MOUSE_PARENT_BEGIN( 0, 0, 0, 0, HELP_NONE )
    MOUSE_PARENT_BEGIN( 0, 11, 91, 80, HELPID_GAUGE_AUTOBRAKE_SWITCH )
        MOUSE_CHILD_FUNCT( 0, 0, 46, 80, CURSOR_DOWNARROW, MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, DecAutoBrake )
        MOUSE_CHILD_FUNCT( 46, 0, 45, 80, CURSOR_UPARROW, MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, IncAutoBrake )
    MOUSE_PARENT_END
    MOUSE_PARENT_END
    { MOUSE_RECT_EOL, { 0, 0, 0, 0 }, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL }
};


#undef		GAUGE_NAME
#undef		GAUGEHDR_VAR_NAME
#undef		GAUGE_W


