/*
 * $Id: autoplt.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The autopilot gauge $
 *
 * $Log: autoplt.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char autopilot_gauge_name[]      = GAUGE_NAME;
extern PELEMENT_HEADER      autopilot_list;
extern MOUSERECT            autopilot_rect[];

/*
 * forward declarations
 */
void FSAPI apgaugeproc(PGAUGEHDR, int, UINT32);
FLOAT64 FSAPI ap_vor1_frequency_string_cb(PELEMENT_STRING pelement);
FLOAT64 FSAPI ap_nav1_course_string_cb(PELEMENT_STRING pelement);
FLOAT64 FSAPI ap_ias_mach_hold_string_cb(PELEMENT_STRING pelement);
FLOAT64 FSAPI ap_hdg_hold_string_cb(PELEMENT_STRING pelement);

BOOL FSAPI DecreaseApSwitch(PPIXPOINT relative_point, FLAGS32 mouse_flags);
BOOL FSAPI IncreaseApSwitch(PPIXPOINT relative_point, FLAGS32 mouse_flags);
BOOL FSAPI ToggleFlightDir(PPIXPOINT relative_point, FLAGS32 mouse_flags);
BOOL FSAPI ToggleAutopilotMaster(PPIXPOINT relative_point, FLAGS32 mouse_flags);
BOOL FSAPI ToggleAutoThrottleArm(PPIXPOINT relative_point, FLAGS32 mouse_flags);

FLOAT64 FSAPI ap_altitude_hold_string_cb(PELEMENT_STRING pelement);
FLOAT64 FSAPI ap_vs_hold_string_cb(PELEMENT_STRING pelement);
FLOAT64 FSAPI auto_throttle_icon_update(PELEMENT_ICON pelement);
FLOAT64 FSAPI flight_director_icon_update(PELEMENT_ICON pelement);
FLOAT64 FSAPI hdg_hold_icon_update(PELEMENT_ICON pelement);

GAUGE_HEADER_FS700(GAUGE_W, autopilot_gauge_name, &autopilot_list, \
                        autopilot_rect, apgaugeproc, 0, 0, 0);

/*
 * failure lists
 */
FAILURE_RECORD	ap_vor1_frequency_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_NAVIGATION_VOR1, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD	ap_nav1_course_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_NAVIGATION_VOR1, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD  ap_ias_mach_hold_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD  ap_hdg_hold_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD  ap_altitude_hold_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD  ap_vs_hold_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD  auto_throttle_icon_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NONE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD  flight_director_icon_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NONE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD  ap_master_switch_icon_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD  ap_wing_leveler_icon_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD  ap_yaw_damper_icon_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD  ap_speed_hold_icon_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD  ap_mach_hold_icon_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD  ap_heading_hold_icon_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD  ap_altitude_hold_icon_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD  ap_nav_hold_icon_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD  ap_backcourse_hold_icon_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD  ap_approach_hold_icon_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};


/*
 * the vor1 frequency string
 */
MAKE_STRING
(
	ap_vor1_frequency_string,
	NULL,
	ap_vor1_frequency_string_fail,
	IMAGE_USE_ERASE | IMAGE_USE_BRIGHT | transparent,
	0,
	{28, 29},
	{54, 21},
	6,

	NAV1_FREQUENCY,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_WHITE,
	RGB(4,4,4),
	CL_WHITE,
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_LEFT,
	NULL,
	ap_vor1_frequency_string_cb
)

/*
 * the nav 1 course string
 */
MAKE_STRING
(
	ap_nav1_course_string,
	NULL,
	ap_nav1_course_string_fail,
	IMAGE_USE_ERASE | IMAGE_USE_BRIGHT | transparent,
	0,
	{107, 29},
	{38, 20},
	4,

	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_WHITE,
	RGB(4,4,4),
	CL_WHITE,
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_LEFT,
	NULL,
	ap_nav1_course_string_cb
)

/*
 * ias/mach hold indicator
 */
MAKE_STRING
(
	ap_ias_mach_hold_string,
	NULL,
	ap_ias_mach_hold_string_fail,
	IMAGE_USE_ERASE | IMAGE_USE_BRIGHT | transparent,
	0,
	{232, 26},
	{39, 16},
	3,

	AUTOPILOT_AIRSPEED_HOLD_VAR,
	AUTOPILOT_MACH_HOLD_VAR,
	MODULE_VAR_NONE,
	CL_WHITE,
	RGB(4,4,4),
	CL_WHITE,
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_LEFT,
	NULL,
	ap_ias_mach_hold_string_cb
)

/*
 * heading hold string
 */
MAKE_STRING
(

	ap_hdg_hold_string,
	NULL,
	ap_hdg_hold_string_fail,
	IMAGE_USE_ERASE | IMAGE_USE_BRIGHT | transparent,
	0,
	{327, 26},
	{39, 16},
	3,

	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_WHITE,
	RGB(4,4,4),
	CL_WHITE,
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_LEFT,
	NULL,
	ap_hdg_hold_string_cb
)

/*
 * Altitude hold string
 */
MAKE_STRING
(
	ap_altitude_hold_string,
	NULL,
	ap_altitude_hold_string_fail,
	IMAGE_USE_ERASE | IMAGE_USE_BRIGHT | transparent,
	0,
	{501, 26},
	{65, 16},
	5,

	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_WHITE,
	RGB(4,4,4),
	CL_WHITE,
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_LEFT,
	NULL,
	ap_altitude_hold_string_cb
)


/*
 * Vertical speed hold string
 */
MAKE_STRING
(
	ap_vs_hold_string,
	NULL,
	ap_vs_hold_string_fail,
	IMAGE_USE_ERASE | IMAGE_USE_BRIGHT | transparent,
	0,
	{400, 26},
	{65, 16},
	5,

	AUTOPILOT_VERTICAL_HOLD_VAR,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_WHITE,
	RGB(4,4,4),
	CL_WHITE,
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_LEFT,
	NULL,
	ap_vs_hold_string_cb
)

/*
 * auto throttle icon
 */
MAKE_ICON
(
	auto_throttle_switch_icon,
	BMP_AUTOPILOT_MANUAL_SW_OFF,
	NULL,
	auto_throttle_icon_fail,
	IMAGE_USE_ERASE,
	0,
	201, 17,
	AUTOPILOT_AUTO_THROTTLE_ARM,
	auto_throttle_icon_update,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)

/*
 * flight director icon
 */
MAKE_ICON
(
	flight_director_switch_icon,
	BMP_AUTOPILOT_MANUAL_SW_OFF,
	NULL,
	NULL,
	IMAGE_USE_ERASE,
	0,
	175, 45,
	MODULE_VAR_NONE,
	flight_director_icon_update,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)

/*
 * autopilot master icon
 */
MAKE_ICON
(
	ap_master_switch_icon,
	BMP_AUTOPILOT_SW_OFF,
	NULL,
	ap_master_switch_icon_fail,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY | IMAGE_USE_BRIGHT,
	0,
	656, 34,
	AUTOPILOT_ACTIVE,
	auto_throttle_icon_update,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)

/*
 * wing leveler icon
 */
MAKE_ICON
(
	ap_wing_leveler_icon,
	BMP_AUTOPILOT_SW_OFF,
	NULL,
	ap_wing_leveler_icon_fail,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY | IMAGE_USE_BRIGHT,
	0,
	626, 62,
	AUTOPILOT_WING_LEVELER,
	auto_throttle_icon_update,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)

/*
 * speed hold icon
 */
MAKE_ICON
(
	ap_speed_hold_icon,
	BMP_AUTOPILOT_SW_OFF,
	NULL,
	ap_speed_hold_icon_fail,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY | IMAGE_USE_BRIGHT,
	0,
	202, 84,
	AUTOPILOT_AIRSPEED_HOLD,
	auto_throttle_icon_update,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)

/*
 * mach hold icon
 */
MAKE_ICON
(
	ap_mach_hold_icon,
	BMP_AUTOPILOT_SW_OFF,
	NULL,
	ap_mach_hold_icon_fail,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY | IMAGE_USE_BRIGHT,
	0,
	285, 84,
	AUTOPILOT_MACH_HOLD,
	auto_throttle_icon_update,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)

/*
 * yaw damper icon
 */
MAKE_ICON
(
	ap_yaw_damper_icon,
	BMP_AUTOPILOT_SW_OFF,
	NULL,
	ap_yaw_damper_icon_fail,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY | IMAGE_USE_BRIGHT,
	0,
	656, 62,
	AUTOPILOT_YAW_DAMPER,
	auto_throttle_icon_update,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)

/*
 * heading hold icon
 */
MAKE_ICON
(
	ap_heading_hold_icon,
	BMP_AUTOPILOT_SW_OFF,
	NULL,
	ap_heading_hold_icon_fail,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY | IMAGE_USE_BRIGHT,
	0,
	338, 83,
	AUTOPILOT_HEADING_LOCK,
	hdg_hold_icon_update,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)

/*
 * altitude hold icon
 */
MAKE_ICON
(
	ap_altitude_hold_icon,
	BMP_AUTOPILOT_SW_OFF,
	NULL,
	ap_altitude_hold_icon_fail,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY | IMAGE_USE_BRIGHT,
	0,
	521, 83,
	AUTOPILOT_ALTITUDE_LOCK,
	auto_throttle_icon_update,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)

/*
 * backcourse hold icon
 */
MAKE_ICON
(
	ap_backcourse_hold_icon,
	BMP_AUTOPILOT_SW_OFF,
	NULL,
	ap_backcourse_hold_icon_fail,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY | IMAGE_USE_BRIGHT,
	0,
	591, 30,
	AUTOPILOT_BACKCOURSE_HOLD,
	auto_throttle_icon_update,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)

/*
 * nav hold icon
 */
MAKE_ICON
(
	ap_nav_hold_icon,
	BMP_AUTOPILOT_SW_OFF,
	NULL,
	ap_nav_hold_icon_fail,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY | IMAGE_USE_BRIGHT,
	0,
	591, 59,
	AUTOPILOT_NAV1_LOCK,
	auto_throttle_icon_update,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)

/*
 * approach hold icon
 */
MAKE_ICON
(
	ap_approach_hold_icon,
	BMP_AUTOPILOT_SW_OFF,
	NULL,
	ap_approach_hold_icon_fail,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY | IMAGE_USE_BRIGHT,
	0,
	591, 85,
	AUTOPILOT_APROACH_HOLD,
	auto_throttle_icon_update,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)


/*
 * inner list
 */
PELEMENT_HEADER autopilot_inner_list[] =
{
	&flight_director_switch_icon.header,
	&ap_heading_hold_icon.header,
	&ap_altitude_hold_icon.header,
	&ap_backcourse_hold_icon.header,
	&ap_nav_hold_icon.header,
	&ap_approach_hold_icon.header,
	&ap_speed_hold_icon.header,
	&ap_mach_hold_icon.header,
	&ap_wing_leveler_icon.header,
	&ap_yaw_damper_icon.header,
	&ap_master_switch_icon.header,
	&ap_vor1_frequency_string.header,
	&ap_nav1_course_string.header,
	&ap_ias_mach_hold_string.header,
	&ap_hdg_hold_string.header,
	&ap_altitude_hold_string.header,
	&ap_vs_hold_string.header,
	NULL
};


/*
 * lights background image
 */
MAKE_STATIC
(
    autopilot_lights,
    BMP_AUTOPILOT_LIGHTS,
    &autopilot_inner_list,
    NULL,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	3,2
)

/*
 * background list
 */
PELEMENT_HEADER autopilot_bg_list[] =
{
    &autopilot_lights.header,
	&auto_throttle_switch_icon.header,
	NULL
};

/*
 * card background image
 */
MAKE_STATIC
(
    autopilot_background,
    BMP_AUTOPILOT_BG,
    &autopilot_bg_list,
    NULL,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	0,0
)


////////////////////////////////////////////////////////////////////////////////
// header
////////////////////////////////////////////////////////////////////////////////
PELEMENT_HEADER     autopilot_list   = &autopilot_background.header;


////////////////////////////////////////////////////////////////////////////////
// tooltip stuff
////////////////////////////////////////////////////////////////////////////////
static FLOAT64 FSAPI ApToolTipGetAltitudeLockVar(FLOAT64 number, ID id,
	PCSTRINGZ string, MODULE_VAR *source_var, PGAUGEHDR gauge)
{
	lookup_var(&AltitudeLockVar);
	return AltitudeLockVar.var_value.n * FEETTOMETERS;
}

static FLOAT64 FSAPI ApToolTipGetVsHoldVar(FLOAT64 number, ID id,
	PCSTRINGZ string, MODULE_VAR *source_var, PGAUGEHDR gauge)
{
	return (source_var->var_value.n * FEETTOMETERS)/60;
}


MOUSE_TOOLTIP_ARGS (ApToolTipAltitudeLockVar)
	MOUSE_TOOLTIP_ARG (MODULE_VAR_NONE, 0, NULL, NULL, NULL, ApToolTipGetAltitudeLockVar, NULL, NULL)
MOUSE_TOOLTIP_ARGS_END
MOUSE_TOOLTIP_ARGS (ApToolTipVsHoldVar)
	MOUSE_TOOLTIP_ARG (AUTOPILOT_VERTICAL_HOLD_VAR, 0, NULL, NULL, NULL, ApToolTipGetVsHoldVar, NULL, NULL)
MOUSE_TOOLTIP_ARGS_END


////////////////////////////////////////////////////////////////////////////////
MOUSERECT autopilot_rect[] =
{
	MOUSE_PARENT_BEGIN( 0, 0, 0, 0, HELP_NONE )

		// NAV1 frequency regulator
		MOUSE_PARENT_BEGIN( 33, 58, 40, 40, HELPID_RADIO_NAV1 )
			MOUSE_CHILD_EVENT( 0, 0, 20, 40, CURSOR_UPARROW,
				MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, KEY_NAV1_RADIO_WHOLE_INC )
			MOUSE_CHILD_EVENT( 20, 0, 20, 40, CURSOR_UPARROW,
				MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, KEY_NAV1_RADIO_FRACT_INC )
		MOUSE_PARENT_END

		// increase/decrease dtk/crs
		MOUSE_PARENT_BEGIN( 113, 58, 40, 40, HELPID_AUTOPILOT_NAV_INDICATOR )
			MOUSE_CHILD_EVENT(0,0,20,40, CURSOR_DOWNARROW,
				MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, KEY_VOR1_OBI_DEC)
			MOUSE_CHILD_EVENT(20,0,20,40, CURSOR_UPARROW,
				MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, KEY_VOR1_OBI_INC)
		MOUSE_PARENT_END

		// heading hold regulator
		MOUSE_PARENT_BEGIN( 337, 51, 22, 20, HELPID_AUTOPILOT_HEADING_HOLD )
			MOUSE_CHILD_EVENT(0,0,11,20, CURSOR_DOWNARROW,
				MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, KEY_HEADING_BUG_DEC)
			MOUSE_CHILD_EVENT(11,0,11,20, CURSOR_UPARROW,
				MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, KEY_HEADING_BUG_INC)
		MOUSE_PARENT_END

		MOUSE_PARENT_BEGIN( 241, 62, 26, 26, HELPID_AUTOPILOT_SPEED_HOLD )
			MOUSE_CHILD_FUNCT(13,0,13,26, CURSOR_UPARROW,
				MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, IncreaseApSwitch)
			MOUSE_CHILD_FUNCT(0,0,13,26, CURSOR_DOWNARROW,
				MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, DecreaseApSwitch)
		MOUSE_PARENT_END

        // vertical speed regulator
		MOUSE_PARENT_BEGIN( 419, 50, 30, 50, HELP_NONE )
			MOUSE_CHILD_EVENT(0,0,30,25, CURSOR_UPARROW,
				MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, KEY_AP_VS_VAR_INC)
			MOUSE_CHILD_EVENT(0,25,30,25, CURSOR_DOWNARROW,
				MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, KEY_AP_VS_VAR_DEC)
		MOUSE_PARENT_END

		// altitude hold regulator
		MOUSE_PARENT_BEGIN( 521, 49, 22, 22, HELP_NONE )
			MOUSE_CHILD_EVENT(11,0,11,22, CURSOR_UPARROW,
				MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, KEY_AP_ALT_VAR_INC)
			MOUSE_CHILD_EVENT(0,0,11,22, CURSOR_DOWNARROW,
				MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, KEY_AP_ALT_VAR_DEC)
		MOUSE_PARENT_END

		// auto throttle arm
		MOUSE_PARENT_BEGIN( 201, 17, 23, 25, HELPID_AUTOPILOT_AUTOTHROTTLE )
			MOUSE_CHILD_FUNCT( 0, 0, 23, 25, CURSOR_HAND, \
				MOUSE_LEFTSINGLE, ToggleAutoThrottleArm )
		MOUSE_PARENT_END

		// flight director
		MOUSE_PARENT_BEGIN( 175, 45, 23, 25, HELPID_AUTOPILOT_FLIGHT_DIRECTOR_SWITCH )
			MOUSE_CHILD_FUNCT( 0, 0, 23, 25, CURSOR_HAND, \
				MOUSE_LEFTSINGLE, ToggleFlightDir )
		MOUSE_PARENT_END

		// master switch
		MOUSE_PARENT_BEGIN( 653, 23, 28, 28, HELPID_GAUGE_AUTOPILOT_MASTER )
			MOUSE_CHILD_FUNCT( 0, 0, 28, 28, CURSOR_HAND, \
				MOUSE_LEFTSINGLE, ToggleAutopilotMaster )
		MOUSE_PARENT_END

		// wing leveler
		MOUSE_PARENT_BEGIN( 623, 52, 28, 28, HELPID_AUTOPILOT_WING_LEVELER )
			MOUSE_CHILD_EVENT( 0, 0, 28, 28, CURSOR_HAND, \
				MOUSE_LEFTSINGLE, KEY_AP_WING_LEVELER )
		MOUSE_PARENT_END

		// yaw damper
		MOUSE_PARENT_BEGIN( 653, 52, 28, 28, HELPID_AUTOPILOT_YAW_DAMP_HOLD )
			MOUSE_CHILD_EVENT( 0, 0, 28, 28, CURSOR_HAND, \
				MOUSE_LEFTSINGLE, KEY_YAW_DAMPER_TOGGLE )
		MOUSE_PARENT_END

		// mach hold
		MOUSE_PARENT_BEGIN( 282, 74, 28, 28, HELPID_AUTOPILOT_MACH_HOLD )
			MOUSE_CHILD_EVENT( 0, 0, 28, 28, CURSOR_HAND, \
				MOUSE_LEFTSINGLE, KEY_AP_PANEL_MACH_HOLD )
		MOUSE_PARENT_END

		// ias hold
		MOUSE_PARENT_BEGIN( 199, 74, 28, 28, HELPID_AUTOPILOT_IAS_HOLD )
			MOUSE_CHILD_EVENT( 0, 0, 28, 28, CURSOR_HAND, \
				MOUSE_LEFTSINGLE, KEY_AP_PANEL_SPEED_HOLD )
		MOUSE_PARENT_END

		// heading hold
		MOUSE_PARENT_BEGIN( 335, 73, 28, 28, HELPID_AUTOPILOT_HEADING_HOLD )
			MOUSE_CHILD_EVENT( 0, 0, 28, 28, CURSOR_HAND, \
				MOUSE_LEFTSINGLE, KEY_AP_PANEL_HEADING_HOLD )
		MOUSE_PARENT_END

		// altitude hold
		MOUSE_PARENT_BEGIN( 518, 73, 28, 28, HELPID_AUTOPILOT_ALTITUDE_HOLD )
			MOUSE_CHILD_EVENT( 0, 0, 28, 28, CURSOR_HAND, \
				MOUSE_LEFTSINGLE, KEY_AP_PANEL_ALTITUDE_HOLD )
		MOUSE_PARENT_END

		// back course hold
		MOUSE_PARENT_BEGIN( 588, 20, 28, 28, HELPID_AUTOPILOT_BC_HOLD )
			MOUSE_CHILD_EVENT( 0, 0, 28, 28, CURSOR_HAND, \
				MOUSE_LEFTSINGLE, KEY_AP_BC_HOLD )
		MOUSE_PARENT_END

		// nav1 hold
		MOUSE_PARENT_BEGIN( 588, 49, 28, 26, HELPID_AUTOPILOT_NAV_HOLD )
			MOUSE_CHILD_EVENT( 0, 0, 28, 26, CURSOR_HAND, \
				MOUSE_LEFTSINGLE, KEY_AP_NAV1_HOLD )
		MOUSE_PARENT_END

		// approach hold
		MOUSE_PARENT_BEGIN( 588, 75, 28, 28, HELPID_AUTOPILOT_APP_HOLD )
			MOUSE_CHILD_EVENT( 0, 0, 28, 28, CURSOR_HAND, \
				MOUSE_LEFTSINGLE, KEY_AP_APR_HOLD )
		MOUSE_PARENT_END

		MOUSE_PARENT_BEGIN( 28, 29, 54, 21, HELPID_RADIO_NAV1 )
		MOUSE_PARENT_END

		MOUSE_PARENT_BEGIN( 105, 29, 36, 21, HELPID_AUTOPILOT_NAV_INDICATOR )
		MOUSE_PARENT_END

		MOUSE_PARENT_BEGIN( 232, 26, 40, 16, HELPID_AUTOPILOT_SPEED_INDICATOR )
		MOUSE_PARENT_END

		MOUSE_PARENT_BEGIN( 327, 26, 40, 16, HELPID_AUTOPILOT_HEADING_INDICATOR )
		MOUSE_PARENT_END

		MOUSE_PARENT_BEGIN( 501, 26, 65, 16, HELP_NONE)
			MOUSE_TOOLTIP_TEXT_ID(TOOLTIPTEXT_AUTOPILOT_ALTITUDE_INDICATOR_METERS, ApToolTipAltitudeLockVar)
		MOUSE_PARENT_END

		MOUSE_PARENT_BEGIN( 400, 26, 65, 16, HELP_NONE)
			MOUSE_TOOLTIP_TEXT_ID(TOOLTIPTEXT_AUTOPILOT_VSI_INDICATOR_MS, ApToolTipVsHoldVar)
		MOUSE_PARENT_END

	MOUSE_PARENT_END
	{
		MOUSE_RECT_EOL, { 0, 0, 0, 0 }, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL
	}
};


////////////////////////////////////////////////////////////////////////////////
// gauge initialization proc
////////////////////////////////////////////////////////////////////////////////
void FSAPI apgaugeproc( PGAUGEHDR pgauge, int service_id, UINT32 extra_data )
{
	switch(service_id)
	{
	case PANEL_SERVICE_PRE_INSTALL: /* "install_routine()" */
		break;

	case PANEL_SERVICE_PRE_INITIALIZE:	/* "initialize_routine()" */
		initialize_var(&avlights);
		initialize_var(&hsi_obi_needle);
		initialize_var(&mach);
		initialize_var(&mach_in);
		initialize_var(&AltitudeLockVar);
		initialize_var(&flight_director_active);
		initialize_var(&units_of_measure);
		initialize_var(&airspeed);
		initialize_var(&mach_speed);
		initialize_var(&baro_alt);
		initialize_var(&baro_pressure);
		initialize_var(&glideslope_active);
		initialize_var(&deviation_active);
		initialize_var(&dme1_distance);
		initialize_var(&dme2_distance);
		initialize_var(&dme1_speed);
		initialize_var(&dme2_speed);
		initialize_var(&cur_dme);
		initialize_var(&plane_heading_degrees_gyro);
		initialize_var(&vor1_obi);
		initialize_var(&vor2_needle);
		initialize_var(&MagneticHeading);
		initialize_var(&ApHeadingLockDir);
		initialize_var(&to_from_flag);
		initialize_var(&gps_drives_nav1);
		initialize_var(&adf_needle);
		initialize_var(&fuel_weight);
		initialize_var(&fuel_left_main);
		initialize_var(&fuel_right_main);
		initialize_var(&engine2_oil_qty);
		initialize_var(&engine1_oil_qty);
		initialize_var(&engine2_oil_temp);
		initialize_var(&engine1_oil_temp);
		initialize_var(&engine2_oil_press);
		initialize_var(&engine1_oil_press);
		initialize_var(&spoilers_armed);

		break;

	case PANEL_SERVICE_PRE_UPDATE: /* "update_routine()" */
		lookup_var(&MagneticHeading);
		lookup_var(&ApHeadingLockDir);
		fMagneticHeading = MagneticHeading.var_value.n;
		fApHeadingLockDir = ApHeadingLockDir.var_value.n;
		lookup_var(&avlights);

		bPanelLightOn = avlights.var_value.n!=0;

		if (bPanelLightOn) // if panel lights on, brighten elements
		{
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[0]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[0]->next_element[1]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[0]->next_element[2]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[0]->next_element[3]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[0]->next_element[4]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[0]->next_element[5]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[0]->next_element[6]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[0]->next_element[7]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[0]->next_element[8]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[0]->next_element[9]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[0]->next_element[10]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[0]->next_element[11]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[0]->next_element[12]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[0]->next_element[13]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[0]->next_element[14]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[0]->next_element[15]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[0]->next_element[16]);
		}
		else
		{
			DARK_IMG(pgauge->elements_list[0]->next_element[0]);
			DARK_IMG(pgauge->elements_list[0]->next_element[0]->next_element[1]);
			DARK_IMG(pgauge->elements_list[0]->next_element[0]->next_element[2]);
			DARK_IMG(pgauge->elements_list[0]->next_element[0]->next_element[3]);
			DARK_IMG(pgauge->elements_list[0]->next_element[0]->next_element[4]);
			DARK_IMG(pgauge->elements_list[0]->next_element[0]->next_element[5]);
			DARK_IMG(pgauge->elements_list[0]->next_element[0]->next_element[6]);
			DARK_IMG(pgauge->elements_list[0]->next_element[0]->next_element[7]);
			DARK_IMG(pgauge->elements_list[0]->next_element[0]->next_element[8]);
			DARK_IMG(pgauge->elements_list[0]->next_element[0]->next_element[9]);
			DARK_IMG(pgauge->elements_list[0]->next_element[0]->next_element[10]);
			DARK_IMG(pgauge->elements_list[0]->next_element[0]->next_element[11]);
			DARK_IMG(pgauge->elements_list[0]->next_element[0]->next_element[12]);
			DARK_IMG(pgauge->elements_list[0]->next_element[0]->next_element[13]);
			DARK_IMG(pgauge->elements_list[0]->next_element[0]->next_element[14]);
			DARK_IMG(pgauge->elements_list[0]->next_element[0]->next_element[15]);
			DARK_IMG(pgauge->elements_list[0]->next_element[0]->next_element[16]);
		}
		break;

	case PANEL_SERVICE_PRE_DRAW: /* "draw_routine()" */
		break;

	case PANEL_SERVICE_PRE_KILL: /* "kill_routine()" */
		break;
	}
}



#undef GAUGE_NAME
#undef GAUGEHDR_VAR_NAME
#undef GAUGE_W


/*
 * the vor1 frequency string update
 */
FLOAT64 FSAPI ap_vor1_frequency_string_cb(PELEMENT_STRING pelement)
{
	UINT32 nFreq = (UINT32)pelement->source_var[0].var_value.d;

	lookup_var(&avlights);
	// do bcd conversion
	wsprintf(pelement->string, "1%d%d.%d%d", (nFreq >> 12) & 0x000f,
		(nFreq >> 8) & 0x000f, (nFreq >> 4) & 0x000f, nFreq & 0x000f);

	return (FLOAT64)nFreq;
}

/*
 * the nav1 course string update
 */
FLOAT64 FSAPI ap_nav1_course_string_cb(PELEMENT_STRING pelement)
{
	lookup_var(&hsi_obi_needle);
	wsprintf(pelement->string, "%0.3d", (int)hsi_obi_needle.var_value.n);
	return hsi_obi_needle.var_value.n;
}

/*
 * ias/mach hold string update
 */
FLOAT64 FSAPI ap_ias_mach_hold_string_cb(PELEMENT_STRING pelement)
{
	FLOAT64 f;
	lookup_var(&mach_in);
	if (mach_in.var_value.n!=0)
	{
    	f = (double)(pelement->source_var[1].var_value.n);
		if (f>0.99)
			f = 0.99;
		f*=100;
		wsprintf(pelement->string,".%0.2d",(int)f);
	}
	else
	{
    	f = pelement->source_var[0].var_value.n;
		wsprintf(pelement->string,"%0.3d",(int)f);
	}
	return f;
}

/*
 * hdg hold string update
 */
FLOAT64 FSAPI ap_hdg_hold_string_cb(PELEMENT_STRING pelement)
{
	FLOAT64 f = fApHeadingLockDir;
	wsprintf(pelement->string,"%0.3d",(int)f);
	return f;
}


/*
 * Altitude hold string update
 */
FLOAT64 FSAPI ap_altitude_hold_string_cb(PELEMENT_STRING pelement)
{
	FLOAT64 f;
	lookup_var(&AltitudeLockVar);
	f = AltitudeLockVar.var_value.n;
	if (f>=0)
		wsprintf(pelement->string,"%0.5d",(int)f);
	else
		wsprintf(pelement->string,"%0.4d",(int)f);
	return f;

}

/*
 * Altitude hold string
 */
FLOAT64 FSAPI ap_vs_hold_string_cb(PELEMENT_STRING pelement)
{
	FLOAT64 f = pelement->source_var[0].var_value.n;
	if (f>=0)
		wsprintf(pelement->string,"%0.5d",(int)f);
	else
		wsprintf(pelement->string,"%0.4d",(int)f);
	return f;
}

/*
 * auto throttle icon update
 */
FLOAT64 FSAPI auto_throttle_icon_update(PELEMENT_ICON pelement)
{
	return (0!=pelement->source_var.var_value.n) ? 1 : 0;
}

/*
 * heading hold icon update
 */
FLOAT64 FSAPI hdg_hold_icon_update(PELEMENT_ICON pelement)
{
	return (0!=pelement->source_var.var_value.n) ? 1 : 0;
}

/*
 * flight director icon update
 */
FLOAT64 FSAPI flight_director_icon_update(PELEMENT_ICON pelement)
{
	lookup_var(&flight_director_active);
	return (0!=flight_director_active.var_value.n) ? 1 : 0;
}


/*
 * decrease speed hold variable
 */
BOOL FSAPI DecreaseApSwitch(PPIXPOINT relative_point, FLAGS32 mouse_flags)
{
	lookup_var(&mach_in);

	if (mach_in.var_value.n!=0)
		trigger_key_event(KEY_AP_MACH_VAR_DEC,1);
	else
		trigger_key_event(KEY_AP_SPD_VAR_DEC,1);

	return TRUE;
}

/*
 * increase speed hold variable
 */
BOOL FSAPI IncreaseApSwitch(PPIXPOINT relative_point, FLAGS32 mouse_flags)
{
	lookup_var(&mach_in);
	if (mach_in.var_value.n!=0)
	{
		lookup_var(&mach);
		if (mach.var_value.n<0.99)
			trigger_key_event(KEY_AP_MACH_VAR_INC,1);
	}
	else
		trigger_key_event(KEY_AP_SPD_VAR_INC,1);
	return TRUE;
}

BOOL FSAPI ToggleFlightDir(PPIXPOINT relative_point, FLAGS32 mouse_flags)
{
	lookup_var(&flight_director_active);
	MFSSoundResPlay(main_sound, FALSE);
	if (flight_director_active.var_value.n!=0)
	{
	 	trigger_key_event(KEY_TOGGLE_FLIGHT_DIRECTOR,0);
		return FALSE;

	}
	else
	{
	 	trigger_key_event(KEY_TOGGLE_FLIGHT_DIRECTOR,1);
		return FALSE;
	}
}

/*
 * toggle autopilot master switch
 */
BOOL FSAPI ToggleAutopilotMaster(PPIXPOINT relative_point, FLAGS32 mouse_flags)
{
	MFSSoundResPlay(main_sound, FALSE);
	trigger_key_event(KEY_AP_MASTER,1);
	return FALSE;
}

/*
 * toggle autohrottle arm
 */
BOOL FSAPI ToggleAutoThrottleArm(PPIXPOINT relative_point, FLAGS32 mouse_flags)
{
	MFSSoundResPlay(main_sound, FALSE);
	trigger_key_event(KEY_AUTO_THROTTLE_ARM,1);
	return FALSE;
}

