/*
 * $Id: avmaster.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The avionics master switch gauge $
 *
 * $Log: avmaster.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char avionics_master_switch_gauge_name[]	= 	GAUGE_NAME;
extern PELEMENT_HEADER      avionics_master_switch_list;
extern MOUSERECT            avionics_master_switch_rect[];

FLOAT64 FSAPI avionics_master_switch_icon_cb(PELEMENT_ICON);

GAUGE_HEADER_FS700( GAUGE_W, avionics_master_switch_gauge_name, &avionics_master_switch_list, \
					avionics_master_switch_rect, NULL, 0, 0, 0);


/*
 * flaps ext icon
 */
MAKE_ICON
(      
	avionics_master_switch_icon,
	BMP_PANEL_SWITCH_OFF,
	NULL,
	NULL,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	0, 0,
	AVIONICS_MASTER_SWITCH, avionics_master_switch_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)


PELEMENT_HEADER avionics_master_switch_card_list[] =
{
	&avionics_master_switch_icon.header,
	NULL
};


/*
 * card background image
 */
MAKE_STATIC
(
    avionics_master_switch_bg,
    BMP_PANEL_SWITCH_BG,
    &avionics_master_switch_card_list,
    NULL,
	IMAGE_NO_STATIC_BLENDING,
	0,
	0,0
)


extern PELEMENT_HEADER      avionics_master_switch_list = &avionics_master_switch_bg.header;

BOOL FSAPI SwitchAvionicsMaster(PPIXPOINT pp, FLAGS32 flg)
{
	MFSSoundResPlay(main_sound, FALSE);
	trigger_key_event(KEY_TOGGLE_AVIONICS_MASTER,1);
	return 0;
}

/*
 * flaps mouse rect
 */
MOUSERECT avionics_master_switch_rect[] =
{
    MOUSE_PARENT_BEGIN( 0, 0, 0, 0, HELPID_GAUGE_AVIONICS_SWITCH )
		MOUSE_CHILD_FUNCT( 0, 0, 43, 73, CURSOR_HAND, MOUSE_LEFTSINGLE, SwitchAvionicsMaster )
    MOUSE_PARENT_END
    { MOUSE_RECT_EOL, { 0, 0, 0, 0 }, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL }
};

FLOAT64 FSAPI avionics_master_switch_icon_cb(PELEMENT_ICON pelement)
{
	return pelement->source_var.var_value.n!=0 ? 1 : 0;
}


#undef		GAUGE_NAME
#undef		GAUGEHDR_VAR_NAME
#undef		GAUGE_W

