/*
 * $Id: back_att.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The standby attitude gauge $
 *
 * $Log: back_att.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char backup_attitude_gauge_name[]	= 	GAUGE_NAME;
extern PELEMENT_HEADER      backup_attitude_list;
extern MOUSERECT            backup_attitude_rect[];


/*
 * forward declarations
 */
PELEMENT_HEADER backup_attitude_sprite_list[];
PELEMENT_HEADER backup_attitude_bg_list[];

void FSAPI backup_attitude_gaugeproc(PGAUGEHDR, int, UINT32);

FLOAT64 FSAPI backup_attitude_sprite_cb(PELEMENT_SPRITE);

GAUGE_HEADER_FS700( GAUGE_W, backup_attitude_gauge_name, &backup_attitude_list, \
					backup_attitude_rect, backup_attitude_gaugeproc, 0, 0, 0);


FAILURE_RECORD backup_attitude_sprite_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_ATTITUDE, FAIL_ACTION_NONE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD backup_attitude_needle_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_ATTITUDE, FAIL_ACTION_NONE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

/*
 * backup attitude needle
 */
MAKE_NEEDLE
(
	backup_attitude_needle,
	BMP_BACKUP_ATTITUDE_NEEDLE,
	NULL,
	backup_attitude_needle_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_NO_STATIC_BLENDING,
	0,
	{ 151, 156 },
	{ 7, 97 },
	//{ 143, 50 },
	PLANE_BANK_DEGREES,
	NULL,
	NULL,
	0
)


/*
 * backup attitude sprite
 */
MAKE_SPRITE
(
	backup_attitude_sprite,
	BMP_BACKUP_ATTITUDE_SPRITE,
	&backup_attitude_sprite_list,
	backup_attitude_sprite_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	23, 25,
	148, 152,
	0.450000, 0.450000,
	MODULE_VAR_NONE, NULL, 1.000000,
	ATTITUDE_INDICATOR_PITCH_DEGREES, backup_attitude_sprite_cb, 1.900000,
	ATTITUDE_INDICATOR_BANK_DEGREES, NULL, -1.000000 
)



/*
 * card background image
 */
MAKE_STATIC
(
    backup_attitude_bg,
    BMP_BACKUP_ATTITUDE_BG,
    &backup_attitude_bg_list,
    NULL,
	transparent | IMAGE_USE_ERASE,
	0,
	0,0
)

/*
 * priority lists
 */
PELEMENT_HEADER backup_attitude_sprite_list[] =
{
	&backup_attitude_needle.header,
	NULL
};
PELEMENT_HEADER backup_attitude_bg_list[] =
{
	&backup_attitude_sprite.header,
	NULL
};


extern PELEMENT_HEADER      backup_attitude_list = &backup_attitude_bg.header;

MOUSERECT backup_attitude_rect[] =
{
    MOUSE_PARENT_BEGIN( 0, 0, 0, 0, HELPID_GAUGE_BACKUP_ATTITUDE )
	MOUSE_PARENT_END
    { MOUSE_RECT_EOL, { 0, 0, 0, 0 }, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL }
};




#undef		GAUGE_NAME
#undef		GAUGEHDR_VAR_NAME
#undef		GAUGE_W


////////////////////////////////////////////////////////////////////////////////
// gauge initialization proc
////////////////////////////////////////////////////////////////////////////////
void FSAPI backup_attitude_gaugeproc( PGAUGEHDR pgauge, int service_id, UINT32 extra_data )
{
	
	switch(service_id)
	{
	case PANEL_SERVICE_PRE_INSTALL:		// install_routine()
		break;

	case PANEL_SERVICE_PRE_INITIALIZE:	// initialize_routine()
		break;

	case PANEL_SERVICE_PRE_UPDATE:		// update_routine()

		if (bPanelLightOn)	// if panel lights, brighten all elements
		{
			BRIGHT_IMG(pgauge->elements_list[0]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]);
		}
		else							// otherwise darken them
		{
			DARK_IMG(pgauge->elements_list[0]);	
			DARK_IMG(pgauge->elements_list[0]->N_E[0]);	
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]);	
    	}
		break;

	case PANEL_SERVICE_PRE_DRAW:		// draw_routine()
		break;

	case PANEL_SERVICE_PRE_KILL:		// kill_routine()
		break;
	}
}


FLOAT64 FSAPI backup_attitude_sprite_cb(PELEMENT_SPRITE pelement)
{
	FLOAT64 val = pelement->source_var_y.var_value.n;
	if (val>40)
		val=40;
	else if (val< -40)
		val = -40;
	return val;

}
