/*
 * $Id: chrono.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The chronometer gauge $
 *
 * $Log: chrono.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char chrono_gauge_name[]      = GAUGE_NAME;
extern PELEMENT_HEADER      chrono_list;
extern MOUSERECT            chrono_rect[];


/*
 * forward declarations
 */
void FSAPI chronogaugeproc(PGAUGEHDR, int, UINT32);
FLOAT64 FSAPI chrono_string_cb(PELEMENT_STRING pelement);


GAUGE_HEADER_FS700(GAUGE_W, chrono_gauge_name, &chrono_list, \
                        chrono_rect, chronogaugeproc, 0, 0, 0);

SEQ_REC chrono_seqrec[] =
{
   {SELECT_CLOCK_HOURS,  0,  1},
   {SELECT_CLOCK_MINUTES,  3,  4},
   {SELECT_CLOCK_SECONDS,  6,  7},
   {SELECT_NONE,  0,  0}
};

/*
 * chronometer string
 */
MAKE_STRING
(
	chrono_string,
	NULL,
	NULL,
	IMAGE_USE_ERASE | transparent,
	0,
	{10, 2},
	{200, 50},
	9,

	CLOCK_SECOND,
	CLOCK_MINUTE,
	CLOCK_HOUR,
	CL_AMBRA,
	RGB(4,4,4),
	CL_WHITE,
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_LEFT,
	chrono_seqrec,
	chrono_string_cb
)


/*
 * priority lists
 */
PELEMENT_HEADER chrono_bg_list[] =
{
	&chrono_string.header,
	NULL
};

/*
 * card background image
 */
MAKE_STATIC
(
    chrono_background,
    BMP_CHRONO_BG,
    &chrono_bg_list,
    NULL,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	0,0
)


////////////////////////////////////////////////////////////////////////////////
// header
////////////////////////////////////////////////////////////////////////////////
PELEMENT_HEADER     chrono_list   = &chrono_background.header;


////////////////////////////////////////////////////////////////////////////////
MOUSERECT chrono_rect[] =
{
	MOUSE_PARENT_BEGIN( 0, 0, 0, 0, HELPID_GAUGE_CLOCK )

	MOUSE_PARENT_END
	{
		MOUSE_RECT_EOL, { 0, 0, 0, 0 }, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL
	}
};


////////////////////////////////////////////////////////////////////////////////
// gauge initialization proc
////////////////////////////////////////////////////////////////////////////////
void FSAPI chronogaugeproc( PGAUGEHDR pgauge, int service_id, UINT32 extra_data )
{
	switch(service_id)
	{
	case PANEL_SERVICE_PRE_INSTALL: /* "install_routine()" */
		break;

	case PANEL_SERVICE_PRE_INITIALIZE:	/* "initialize_routine()" */
		break;

	case PANEL_SERVICE_PRE_UPDATE: /* "update_routine()" */
		if (bPanelLightOn)	// if panel lights, brighten all elements
		{
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]);
		}
		else
		{
			DARK_IMG(pgauge->elements_list[0]->N_E[0]);
		}
		break;

	case PANEL_SERVICE_PRE_DRAW: /* "draw_routine()" */
		break;

	case PANEL_SERVICE_PRE_KILL: /* "kill_routine()" */
		break;
	}
}



#undef GAUGE_NAME
#undef GAUGEHDR_VAR_NAME
#undef GAUGE_W


/*
 * chronometer string update
 */
FLOAT64 FSAPI chrono_string_cb(PELEMENT_STRING pelement)
{
	FLOAT64 h = pelement->source_var[2].var_value.n;
	FLOAT64 m = pelement->source_var[1].var_value.n;
	FLOAT64 s = pelement->source_var[0].var_value.n;
	FSeconds = s;
	wsprintf(pelement->string,"%0.2d:%0.2d:%0.2d",(int)h, (int)m, (int)s);
	return s;
}

