/*
 * $Id: dme.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The dme gauge $
 *
 * $Log: dme.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char dme_gauge_name[]     = GAUGE_NAME;
extern PELEMENT_HEADER      dme_list;
extern MOUSERECT            dme_rect[];
static UINT fCurDme=1;
static FLOAT64 fDme1=0,fDme2=0;
/*
 * forward declarations
 */
FLOAT64 FSAPI dme_selector_icon_cb(PELEMENT_ICON);
FLOAT64 FSAPI dme_distance_string_cb(PELEMENT_STRING);
FLOAT64 FSAPI dme_time_string_cb(PELEMENT_STRING);


void FSAPI dmegaugeproc(PGAUGEHDR, int, UINT32);

GAUGE_HEADER_FS700(GAUGE_W, dme_gauge_name, &dme_list, \
                        dme_rect, dmegaugeproc, 0, 0, 0);
						
FAILURE_RECORD dme_selector_icon_fail[] =
{
   {FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
   {FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
   {FAIL_GAUGE_NAVIGATION_BOTH, FAIL_ACTION_FREEZE},
   {FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD dme_distance_string_fail[] =
{
   {FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
   {FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
   {FAIL_GAUGE_NAVIGATION_BOTH, FAIL_ACTION_FREEZE},
   {FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD dme_time_string_fail[] =
{
   {FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
   {FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
   {FAIL_GAUGE_NAVIGATION_BOTH, FAIL_ACTION_FREEZE},
   {FAIL_NONE, FAIL_ACTION_NONE}
};

MAKE_ICON
(
	dme_selector_icon,
	BMP_DME1,
	NULL,
	dme_selector_icon_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 50, 45 },
	MODULE_VAR_NONE,
	dme_selector_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)

/*
 * the dme speed string
 */   
MAKE_STRING
(
	dme_time_string,
	NULL,
	dme_time_string_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	{200, 48},
	{67, 30},
	5,

	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_AMBRA,
	RGB(4,4,4),
	CL_WHITE,
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_CENTER,
	NULL,
	dme_time_string_cb
)
/*
 * the dme distance string
 */   
MAKE_STRING
(
	dme_distance_string,
	NULL,
	dme_distance_string_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	{111, 48},
	{60, 30},
	4,

	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_AMBRA,
	RGB(4,4,4),
	CL_WHITE,
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_CENTER,
	NULL,
	dme_distance_string_cb
)
       

PELEMENT_HEADER dme_bg_list[] =
{
	&dme_selector_icon.header,
	&dme_distance_string.header,
	&dme_time_string.header,
	NULL
};



/*
 * card background image
 */
MAKE_STATIC
(
    dme_background,
    BMP_DME_BG,
    &dme_bg_list,
    NULL,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	0,0
)


////////////////////////////////////////////////////////////////////////////////
// header
////////////////////////////////////////////////////////////////////////////////
PELEMENT_HEADER     dme_list   = &dme_background.header;


// tooltip stuff
static FLOAT64 FSAPI DmeTooltipGetSelector(FLOAT64 number, ID id,
	PCSTRINGZ string, MODULE_VAR *source_var, PGAUGEHDR gauge)
{
	return (fCurDme);
}

MOUSE_TOOLTIP_ARGS (DmeTooltipSelector)
	MOUSE_TOOLTIP_ARG(MODULE_VAR_NONE, 0, NULL, NULL, NULL, DmeTooltipGetSelector, NULL, NULL)
MOUSE_TOOLTIP_ARGS_END


////////////////////////////////////////////////////////////////////////////////
MOUSERECT dme_rect[] =
{
	MOUSE_PARENT_BEGIN( 0, 0, 0, 0, HELP_NONE )
		// back course hold
		MOUSE_PARENT_BEGIN( 50, 45, 32, 32, HELPID_RADIO_DME_N1_N2_SELECT )
			MOUSE_CHILD_EVENT( 0, 0, 32, 32, CURSOR_HAND, \
			MOUSE_LEFTSINGLE, KEY_DME_TOGGLE )
		MOUSE_PARENT_END
		MOUSE_PARENT_BEGIN( 105, 40, 70, 35, HELPID_RADIO_DME_NM )
		MOUSE_PARENT_END
		MOUSE_PARENT_BEGIN( 203, 40, 70, 35, HELPID_RADIO_DME_KT )
		MOUSE_PARENT_END

		
	MOUSE_PARENT_END
	{
		MOUSE_RECT_EOL, { 0, 0, 0, 0 }, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL
	}
};


////////////////////////////////////////////////////////////////////////////////
// gauge initialization proc
////////////////////////////////////////////////////////////////////////////////
void FSAPI dmegaugeproc( PGAUGEHDR pgauge, int service_id, UINT32 extra_data )
{
	switch(service_id)
	{
	case PANEL_SERVICE_PRE_INSTALL: /* "install_routine()" */
		break;

	case PANEL_SERVICE_PRE_INITIALIZE:	/* "initialize_routine()" */
		break;

	case PANEL_SERVICE_PRE_UPDATE: /* "update_routine()" */
		if (bPanelLightOn)	// if panel lights, brighten all elements
		{
			BRIGHT_IMG(pgauge->elements_list[0]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[1]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[2]);

		}
		else
		{
			DARK_IMG(pgauge->elements_list[0]);
			DARK_IMG(pgauge->elements_list[0]->N_E[0]);
			DARK_IMG(pgauge->elements_list[0]->N_E[1]);
			DARK_IMG(pgauge->elements_list[0]->N_E[2]);
		}
		lookup_var(&cur_dme);
		fCurDme  = (UINT)cur_dme.var_value.d;


		if (fCurDme==1)
		{
			lookup_var(&dme1_distance);
			fDme1=dme1_distance.var_value.n;
			if (dme1_distance.var_value.n<0)
			{
				HIDE_IMAGE(pgauge->elements_list[0]->N_E[1]);
				HIDE_IMAGE(pgauge->elements_list[0]->N_E[2]);
			}
			else
			{
				SHOW_IMAGE(pgauge->elements_list[0]->N_E[1]);
				SHOW_IMAGE(pgauge->elements_list[0]->N_E[2]);
			}

		}
		else
		{
			lookup_var(&dme2_distance);
			fDme2=dme2_distance.var_value.n;
			if (dme2_distance.var_value.n<0)
			{
				HIDE_IMAGE(pgauge->elements_list[0]->N_E[1]);
				HIDE_IMAGE(pgauge->elements_list[0]->N_E[2]);
			}
			else
			{
				SHOW_IMAGE(pgauge->elements_list[0]->N_E[1]);
				SHOW_IMAGE(pgauge->elements_list[0]->N_E[2]);
			}
		}
		break;

	case PANEL_SERVICE_PRE_DRAW: /* "draw_routine()" */
		break;

	case PANEL_SERVICE_PRE_KILL: /* "kill_routine()" */
		break;
	}
}



#undef GAUGE_NAME
#undef GAUGEHDR_VAR_NAME
#undef GAUGE_W

/*
 * current dme update
 */
FLOAT64 FSAPI dme_selector_icon_cb(PELEMENT_ICON icon)
{
	return ((fCurDme==1) ? 0 : 1);
}

/*
 * dme distance update
 */
FLOAT64 FSAPI dme_distance_string_cb(PELEMENT_STRING pelement)
{
	FLOAT64 f;
	if (1==fCurDme)
	{
		f =fDme1;
	
	}
	else
	{
		f = fDme2;

	}
	
	if (f>=100)
		wsprintf( pelement->string,"%0.4d", (int)f);
	else if (f>=10)
		sprintf( pelement->string,"%0.1f",f);
	else
		sprintf( pelement->string,"%0.2f",f);
	return f;
}

/*
 * dme speed/time update
 */
FLOAT64 FSAPI dme_time_string_cb(PELEMENT_STRING pelement)
{
	FLOAT64 f;
	FLOAT64 hrs, mins, secs;

	/*lookup_var(&airspeed);				// get true airspeed
	f = airspeed.var_value.n;*/

	f = TasFromMachTat(fTat,fMachSpeed);


	if (f<30)							// if speed is too slow
	{
		lstrcpy( pelement->string,"-----");		
		return f;
	}

	if (1==fCurDme)						// compute hours required
	{
		if (fDme1<0)					// if no dme signal
		{
			lstrcpy( pelement->string,"-----");		
			return f;
		}
		hrs = fDme1/f;					// fm dme 1
	}
	else
	{
		if (fDme2<0)					// if no dme signal
		{
			lstrcpy( pelement->string,"-----");		
			return f;
		}
		hrs = fDme2/f;					// fm dme 2
	}

	if (hrs>99)							// clip hours to a reasonable value
		hrs=99;

	mins = (hrs-(int)hrs)*60;			// compute minutes


	if (mins<5)							// if less than 5 minutes left, mm:ss
	{
		secs = (mins-(int)mins)*60;
		wsprintf(pelement->string,"%0.2d:%0.2d", (int)mins,(int)secs);
	}
	else								// otherwise hh:mm
		wsprintf(pelement->string,"%0.2d:%0.2d", (int)hrs,(int)mins);

	return f;							// return value
}