/*
 * $Id: eicas1.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The eicas1 gauge $
 *
 * $Log: eicas1.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char eicas1_gauge_name[]     = GAUGE_NAME;
extern PELEMENT_HEADER      eicas1_list;
extern MOUSERECT            eicas1_rect[];


/*
 * forward declarations
 */


void FSAPI eicas1_gaugeproc(PGAUGEHDR, int, UINT32);
FLOAT64 FSAPI eicas1_e1n1_string_cb(PELEMENT_STRING);
FLOAT64 FSAPI eicas1_e1egt_string_cb(PELEMENT_STRING);
FLOAT64 FSAPI eicas1_e2n1_string_cb(PELEMENT_STRING);
FLOAT64 FSAPI eicas1_e2egt_string_cb(PELEMENT_STRING);
FLOAT64 FSAPI eicas1_e1n1_needle_cb(PELEMENT_NEEDLE);
FLOAT64 FSAPI eicas1_e2n1_needle_cb(PELEMENT_NEEDLE);
FLOAT64 FSAPI eicas1_e1egt_needle_cb(PELEMENT_NEEDLE);
FLOAT64 FSAPI eicas1_e2egt_needle_cb(PELEMENT_NEEDLE);

GAUGE_HEADER_FS700(GAUGE_W, eicas1_gauge_name, &eicas1_list, \
                        eicas1_rect, eicas1_gaugeproc, 0, 0, 0);


#define LEFT_X 32
#define TOP_Y 32
#define STR_W 32
#define STR_H 12

#define E1N1_X 27
#define E1N1_Y 50

#define EICAS_OFFSET_X 72
#define EICAS_OFFSET_Y 69

NONLINEARITY  eicas1_e1n1_nonlinearity[] =
{
	{{52,	50},	0,		0	},
	{{46,	67},	25,		0	},
	{{27,	73},	50,		0	},
	{{3,	50},	75,		0	},
	{{26,	27},	100,	0	}
};


NONLINEARITY  eicas1_e2n1_nonlinearity[] =
{
	{{52+EICAS_OFFSET_X,	50},	0,		0	},
	{{46+EICAS_OFFSET_X,	67},	25,		0	},
	{{27+EICAS_OFFSET_X,	73},	50,		0	},
	{{ 3+EICAS_OFFSET_X,	50},	75,		0	},
	{{26+EICAS_OFFSET_X,	27},	100,	0	}
};

NONLINEARITY  eicas1_e1egt_nonlinearity[] =
{
	{{52,	50+EICAS_OFFSET_Y},	0,		0	},
	{{46,	67+EICAS_OFFSET_Y},	250,	0	},
	{{27,	73+EICAS_OFFSET_Y},	500,	0	},
	{{3,	50+EICAS_OFFSET_Y},	750,	0	},
	{{26,	27+EICAS_OFFSET_Y},	1000,	0	}
};

NONLINEARITY  eicas1_e2egt_nonlinearity[] =
{
	{{52+EICAS_OFFSET_X,	50+EICAS_OFFSET_Y},	0,		0	},
	{{46+EICAS_OFFSET_X,	67+EICAS_OFFSET_Y},	250,	0	},
	{{27+EICAS_OFFSET_X,	73+EICAS_OFFSET_Y},	500,	0	},
	{{3+EICAS_OFFSET_X,		50+EICAS_OFFSET_Y},	750,	0	},
	{{26+EICAS_OFFSET_X,	27+EICAS_OFFSET_Y},	1000,	0	}
};


FAILURE_RECORD	eicas1_e2egt_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ENGINE, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD	eicas1_e1egt_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ENGINE, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD	eicas1_e1n1_needle_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ENGINE, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD	eicas1_e1egt_needle_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ENGINE, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD	eicas1_e2egt_needle_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ENGINE, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD	eicas1_e2n1_needle_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ENGINE, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD	eicas1_e1n1_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ENGINE, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD	eicas1_e2n1_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ENGINE, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

/*
 * Engine 1 egt needle
 */
MAKE_NEEDLE
(
	eicas1_e1egt_needle,
	BMP_EICAS1_NEEDLE,
	NULL,
	eicas1_e1egt_needle_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	E1N1_X, E1N1_Y+EICAS_OFFSET_Y,
	0, 1,
	GENERAL_ENGINE1_EGT,
	eicas1_e1egt_needle_cb,
	eicas1_e1egt_nonlinearity,
	6
)

/*
 * Engine 2 egt needle
 */
MAKE_NEEDLE
(
	eicas1_e2egt_needle,
	BMP_EICAS1_NEEDLE,
	NULL,
	eicas1_e2egt_needle_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	E1N1_X+EICAS_OFFSET_X, E1N1_Y+EICAS_OFFSET_Y,
	0, 1,
	GENERAL_ENGINE2_EGT,
	eicas1_e2egt_needle_cb,
	eicas1_e2egt_nonlinearity,
	6
)

/*
 * Engine 1 N1 needle
 */
MAKE_NEEDLE
(
	eicas1_e1n1_needle,
	BMP_EICAS1_NEEDLE,
	NULL,
	eicas1_e1n1_needle_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	E1N1_X, E1N1_Y,
	0, 1,
	TURB_ENGINE_1_N1,
	eicas1_e1n1_needle_cb,
	eicas1_e1n1_nonlinearity,
	6
)

/*
 * Engine 2 N1 needle
 */
MAKE_NEEDLE
(
	eicas1_e2n1_needle,
	BMP_EICAS1_NEEDLE,
	NULL,
	eicas1_e2n1_needle_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	E1N1_X+EICAS_OFFSET_X, E1N1_Y,
	0, 1,
	TURB_ENGINE_2_N1,
	eicas1_e2n1_needle_cb,
	eicas1_e2n1_nonlinearity,
	6
)


/*
 * engine 2, egt string
 */
MAKE_STRING
(
	eicas1_e2egt_string,
	NULL,
	eicas1_e2egt_string_fail,
	IMAGE_USE_ERASE | IMAGE_USE_BRIGHT | transparent,
	0,
	{LEFT_X+72, TOP_Y+69},
	{STR_W, STR_H},
	3,

	GENERAL_ENGINE2_EGT,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_WHITE,
	RGB(4,4,4),
	RGB(255,255, 255),
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_CENTER,
	NULL,
	eicas1_e2egt_string_cb
)

/*
 * engine 1, egt string
 */
MAKE_STRING
(
	eicas1_e1egt_string,
	NULL,
	eicas1_e1egt_string_fail,
	IMAGE_USE_ERASE | IMAGE_USE_BRIGHT | transparent,
	0,
	{LEFT_X, TOP_Y+69},
	{STR_W, STR_H},
	3,

	GENERAL_ENGINE1_EGT,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_WHITE,
	RGB(4,4,4),
	RGB(255,255, 255),
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_CENTER,
	NULL,
	eicas1_e1egt_string_cb
)

/*
 * engine 1, n1 string
 */
MAKE_STRING
(
	eicas1_e1n1_string,
	NULL,
	eicas1_e1n1_string_fail,
	IMAGE_USE_ERASE | IMAGE_USE_BRIGHT | transparent,
	0,
	{LEFT_X, TOP_Y},
	{STR_W, STR_H},
	3,

	TURB_ENGINE_1_N1,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_WHITE,
	RGB(4,4,4),
	RGB(255,255, 255),
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_CENTER,
	NULL,
	eicas1_e1n1_string_cb
)

/*
 * engine 2, n1 string
 */
MAKE_STRING
(
	eicas1_e2n1_string,
	NULL,
	eicas1_e2n1_string_fail,
	IMAGE_USE_ERASE | IMAGE_USE_BRIGHT | transparent,
	0,
	{LEFT_X+72, TOP_Y},
	{STR_W, STR_H},
	3,

	TURB_ENGINE_2_N1,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_WHITE,
	RGB(4,4,4),
	RGB(255,255, 255),
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_CENTER,
	NULL,
	eicas1_e2n1_string_cb
)


PELEMENT_HEADER eicas1_bg_list[] =
{
	&eicas1_e1egt_needle.header,
	&eicas1_e2egt_needle.header,
	&eicas1_e1n1_string.header,
	&eicas1_e2n1_string.header,
	&eicas1_e1egt_string.header,
	&eicas1_e2egt_string.header,
	&eicas1_e1n1_needle.header,
	&eicas1_e2n1_needle.header,
	NULL
};

/*
 * card background image
 */
MAKE_STATIC
(
    eicas1_background,
    BMP_EICAS1_BG,
    &eicas1_bg_list,
    NULL,
    IMAGE_USE_ERASE  | IMAGE_USE_TRANSPARENCY,
	0,
    0,0
)

////////////////////////////////////////////////////////////////////////////////
// header
////////////////////////////////////////////////////////////////////////////////
PELEMENT_HEADER     eicas1_list   = &eicas1_background.header;


////////////////////////////////////////////////////////////////////////////////
MOUSERECT eicas1_rect[] =
{
	MOUSE_PARENT_BEGIN( 0, 0, 0, 0, HELP_NONE )

	MOUSE_PARENT_BEGIN( 4, 27, 126, 49, HELPID_GAUGE_ENGINE_N1)
	MOUSE_PARENT_END
	MOUSE_PARENT_BEGIN( 4, 27+EICAS_OFFSET_Y, 126, 49, HELPID_GAUGE_EGT)
	MOUSE_PARENT_END

//
	MOUSE_PARENT_END
	{
		MOUSE_RECT_EOL, { 0, 0, 0, 0 }, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL
	}
};


////////////////////////////////////////////////////////////////////////////////
// gauge initialization proc
////////////////////////////////////////////////////////////////////////////////
void FSAPI eicas1_gaugeproc( PGAUGEHDR pgauge, int service_id, UINT32 extra_data )
{
	switch(service_id)
	{
	case PANEL_SERVICE_PRE_INSTALL: /* "install_routine()" */
		break;

	case PANEL_SERVICE_PRE_INITIALIZE:	/* "initialize_routine()" */
		break;

	case PANEL_SERVICE_PRE_UPDATE: /* "update_routine()" */
		if (bPanelLightOn)	// if panel lights, brighten all elements
		{
			BRIGHT_IMG(pgauge->elements_list[0]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[1]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[2]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[3]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[4]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[5]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[6]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[7]);
		}
		else
		{
			DARK_IMG(pgauge->elements_list[0]);
			DARK_IMG(pgauge->elements_list[0]->N_E[0]);
			DARK_IMG(pgauge->elements_list[0]->N_E[1]);
			DARK_IMG(pgauge->elements_list[0]->N_E[2]);
			DARK_IMG(pgauge->elements_list[0]->N_E[3]);
			DARK_IMG(pgauge->elements_list[0]->N_E[4]);
			DARK_IMG(pgauge->elements_list[0]->N_E[5]);
			DARK_IMG(pgauge->elements_list[0]->N_E[6]);
			DARK_IMG(pgauge->elements_list[0]->N_E[7]);
		}
		break;

	case PANEL_SERVICE_PRE_DRAW: /* "draw_routine()" */
		break;

	case PANEL_SERVICE_PRE_KILL: /* "kill_routine()" */
		break;
	}
}

FLOAT64 FSAPI eicas1_e1n1_string_cb(PELEMENT_STRING pelement)
{
	FLOAT64 val = pelement->source_var[0].var_value.n;
	if (val>100)
		val=100;
	wsprintf(pelement->string, "%0.3d", (int)val);
	return val;
}

FLOAT64 FSAPI eicas1_e2n1_string_cb(PELEMENT_STRING pelement)
{
	FLOAT64 val = pelement->source_var[0].var_value.n;
	if (val>100)
		val=100;
	wsprintf(pelement->string, "%0.3d", (int)val);
	return val;
}

FLOAT64 FSAPI eicas1_e1egt_string_cb(PELEMENT_STRING pelement)
{
	FLOAT64 val = RANKINETOCELSIUS(pelement->source_var[0].var_value.n);
	if (val>999)
		val=999;
	wsprintf(pelement->string, "%0.3d", (int)val);
	return val;
}

FLOAT64 FSAPI eicas1_e2egt_string_cb(PELEMENT_STRING pelement)
{
	FLOAT64 val = RANKINETOCELSIUS(pelement->source_var[0].var_value.n);
	if (val>999)
		val=999;
	wsprintf(pelement->string, "%0.3d", (int)val);
	return val;
}

FLOAT64 FSAPI eicas1_e1n1_needle_cb(PELEMENT_NEEDLE pelement)
{
	FLOAT64		dir = pelement->source_var.var_value.n;
	if (dir>100) dir = 100;
	return dir;
}

FLOAT64 FSAPI eicas1_e2n1_needle_cb(PELEMENT_NEEDLE pelement)
{
	FLOAT64		dir = pelement->source_var.var_value.n;
	if (dir>100) dir = 100;
	return dir;
}

FLOAT64 FSAPI eicas1_e1egt_needle_cb(PELEMENT_NEEDLE pelement)
{
	FLOAT64 val = RANKINETOCELSIUS(pelement->source_var.var_value.n);
	if (val>999)
		val=999;
	return val;
}

FLOAT64 FSAPI eicas1_e2egt_needle_cb(PELEMENT_NEEDLE pelement)
{
	FLOAT64 val = RANKINETOCELSIUS(pelement->source_var.var_value.n);
	if (val>999)
		val=999;
	return val;
}

#undef GAUGE_NAME
#undef GAUGEHDR_VAR_NAME
#undef GAUGE_W



