/*
 * $Id: eicas2.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The eicas 2 gauge $
 *
 * $Log: eicas2.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char eicas2_gauge_name[]    = GAUGE_NAME;
extern PELEMENT_HEADER      eicas2_list;
extern MOUSERECT            eicas2_rect[];

/*
 * forward declarations
 */
PELEMENT_HEADER      eicas2_bg_list[];

void FSAPI eicas2_gaugeproc(PGAUGEHDR, int, UINT32);

FLOAT64 FSAPI eicas2_e1n2_string_cb(PELEMENT_STRING);
FLOAT64 FSAPI eicas2_e2n2_string_cb(PELEMENT_STRING);
FLOAT64 FSAPI eicas2_e1ff_string_cb(PELEMENT_STRING);
FLOAT64 FSAPI eicas2_e2ff_string_cb(PELEMENT_STRING);

FLOAT64 FSAPI eicas2_e1n2_needle_cb(PELEMENT_NEEDLE);
FLOAT64 FSAPI eicas2_e2n2_needle_cb(PELEMENT_NEEDLE);
FLOAT64 FSAPI eicas2_e1ff_needle_cb(PELEMENT_NEEDLE);
FLOAT64 FSAPI eicas2_e2ff_needle_cb(PELEMENT_NEEDLE);

FLOAT64 FSAPI eicas2_no_smoking_icon_cb(PELEMENT_ICON);
FLOAT64 FSAPI eicas2_fasten_seat_belts_icon_cb(PELEMENT_ICON);

static FLOAT64 fEng1N2Needle=0;
static FLOAT64 fEng2N2Needle=0;
static FLOAT64 fEng1ffNeedle=0;
static FLOAT64 fEng2ffNeedle=0;

GAUGE_HEADER_FS700( GAUGE_W, eicas2_gauge_name, &eicas2_list, \
					eicas2_rect, eicas2_gaugeproc, 0, 0, 0);


NONLINEARITY  eicas2_e1n2_nonlinearity[] =
{
	{{49,	43},	0,		0	},
	{{40,	59},	25,		0	},
	{{25,	65},	50,		0	},
	{{1,	42},	75,		0	},
	{{22,	19},	100,	0	}
};

NONLINEARITY  eicas2_e2n2_nonlinearity[] =
{
	{{49+72,	43},	0,		0	},
	{{40+72,	59},	25,		0	},
	{{25+72,	65},	50,		0	},
	{{1+72,		42},	75,		0	},
	{{22+72,	19},	100,	0	}
};

NONLINEARITY  eicas2_e1ff_nonlinearity[] =
{
	{{49,	43+69},	0,		0	},
	{{40,	59+69},	25,		0	},
	{{25,	65+69},	50,		0	},
	{{1,	42+69},	75,		0	},
	{{22,	19+69},	100,	0	}
};
NONLINEARITY  eicas2_e2ff_nonlinearity[] =
{
	{{49+72,	43+69},	0,		0	},
	{{40+72,	59+69},	25,		0	},
	{{25+72,	65+69},	50,		0	},
	{{1+72,		42+69},	75,		0	},
	{{22+72,	19+69},	100,	0	}
};


FAILURE_RECORD	eicas2_e1n2_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ENGINE, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD	eicas2_e2n2_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ENGINE, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD	eicas2_e1ff_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ENGINE, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD	eicas2_e2ff_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ENGINE, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD eicas2_e1n2_needle_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ENGINE, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD eicas2_e2n2_needle_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ENGINE, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD eicas2_e1ff_needle_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ENGINE, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD eicas2_e2ff_needle_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ENGINE, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

/*
 * engine 1 n2 needle
 */
MAKE_NEEDLE
(
	eicas2_e1n2_needle,
	BMP_EICAS1_NEEDLE,
	NULL,
	eicas2_e1n2_needle_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	25,42,
	0, 1,
	MODULE_VAR_NONE,
	eicas2_e1n2_needle_cb,
	eicas2_e1n2_nonlinearity,
	6
)

/*
 * engine 2 n2 needle
 */
MAKE_NEEDLE
(
	eicas2_e2n2_needle,
	BMP_EICAS1_NEEDLE,
	NULL,
	eicas2_e2n2_needle_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	25+72,42,
	0, 1,
	MODULE_VAR_NONE,
	eicas2_e2n2_needle_cb,
	eicas2_e2n2_nonlinearity,
	6
)

/*
 * engine 1 ff needle
 */
MAKE_NEEDLE
(
	eicas2_e1ff_needle,
	BMP_EICAS1_NEEDLE,
	NULL,
	eicas2_e1ff_needle_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	25,42+69,
	0, 1,
	MODULE_VAR_NONE,
	eicas2_e1ff_needle_cb,
	eicas2_e1ff_nonlinearity,
	6
)

/*
 * engine 2 n2 needle
 */
MAKE_NEEDLE
(
	eicas2_e2ff_needle,
	BMP_EICAS1_NEEDLE,
	NULL,
	eicas2_e2ff_needle_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	25+72,42+69,
	0, 1,
	MODULE_VAR_NONE,
	eicas2_e2ff_needle_cb,
	eicas2_e2ff_nonlinearity,
	6
)


/*
 * engine 1, n2 string
 */
MAKE_STRING
(
	eicas2_e1n2_string,
	NULL,
	eicas2_e1n2_string_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	{29, 25},
	{STR_W, STR_H},
	3,

	TURB_ENGINE_1_N2,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_WHITE,
	RGB(4,4,4),
	RGB(255,255, 255),
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_CENTER,
	NULL,
	eicas2_e1n2_string_cb
)

/*
 * engine 2, n2 string
 */
MAKE_STRING
(
	eicas2_e2n2_string,
	NULL,
	eicas2_e2n2_string_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	{101, 25},
	{STR_W, STR_H},
	3,

	TURB_ENGINE_2_N2,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_WHITE,
	RGB(4,4,4),
	RGB(255,255, 255),
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_CENTER,
	NULL,
	eicas2_e2n2_string_cb
)

//

/*
 * engine 1, ff string
 */
MAKE_STRING
(
	eicas2_e1ff_string,
	NULL,
	eicas2_e1ff_string_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	{29, 94},
	{STR_W, STR_H},
	3,

	ENGINE1_FF_PPH,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_WHITE,
	RGB(4,4,4),
	RGB(255,255, 255),
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_CENTER,
	NULL,
	eicas2_e1ff_string_cb
)

/*
 * engine 2, ff string
 */
MAKE_STRING
(
	eicas2_e2ff_string,
	NULL,
	eicas2_e2ff_string_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	{101, 94},
	{STR_W, STR_H},
	3,

	ENGINE2_FF_PPH,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_WHITE,
	RGB(4,4,4),
	RGB(255,255, 255),
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_CENTER,
	NULL,
	eicas2_e2ff_string_cb
)

/*
 * no smoking icon
 */
MAKE_ICON
(
	eicas2_no_smoking_icon,
	BMP_NO_SMOKING_ICON_OFF,
	NULL,
	NULL,
	IMAGE_USE_ERASE | transparent,
	0,
	14, 145,
	MODULE_VAR_NONE,
	eicas2_no_smoking_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)

/*
 * fasten seat belts
 */
MAKE_ICON
(
	eicas2_fasten_seat_belts_icon,
	BMP_FASTEN_SEAT_BELTS_ICON_OFF,
	NULL,
	NULL,
	IMAGE_USE_ERASE | transparent,
	0,
	47, 145,
	MODULE_VAR_NONE,
	eicas2_fasten_seat_belts_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)


/*
 * card background image
 */
MAKE_STATIC
(
    eicas2_bg,
    BMP_EICAS2_BG,
    &eicas2_bg_list,
    NULL,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	0,0
)


/*
 * priority lists
 */
PELEMENT_HEADER      eicas2_bg_list[] =
{
	&eicas2_e1n2_string.header,
	&eicas2_e2n2_string.header,
	&eicas2_e1ff_string.header,
	&eicas2_e2ff_string.header,
	&eicas2_e1n2_needle.header,
	&eicas2_e2n2_needle.header,
	&eicas2_e1ff_needle.header,
	&eicas2_e2ff_needle.header,
	&eicas2_fasten_seat_belts_icon.header,
	&eicas2_no_smoking_icon.header,
	NULL
};



extern PELEMENT_HEADER      eicas2_list = &eicas2_bg.header;

/*
 * dynamic tooltip stuff
 */
static FLOAT64 FSAPI Eicas2ToolTipGetEngine1ff(FLOAT64 number, ID id,
	PCSTRINGZ string, MODULE_VAR *source_var, PGAUGEHDR gauge)
{
	return source_var->var_value.n;
}
static FLOAT64 FSAPI Eicas2ToolTipGetEngine2ff(FLOAT64 number, ID id,
	PCSTRINGZ string, MODULE_VAR *source_var, PGAUGEHDR gauge)
{
	return source_var->var_value.n;
}

MOUSE_TOOLTIP_ARGS (Eicas2ToolTipEngine1ff)
	MOUSE_TOOLTIP_ARG (ENGINE1_FF_GPH, 0, NULL, NULL, NULL, Eicas2ToolTipGetEngine1ff, NULL, NULL)
MOUSE_TOOLTIP_ARGS_END

MOUSE_TOOLTIP_ARGS (Eicas2ToolTipEngine2ff)
	MOUSE_TOOLTIP_ARG (ENGINE1_FF_GPH, 0, NULL, NULL, NULL, Eicas2ToolTipGetEngine2ff, NULL, NULL)
MOUSE_TOOLTIP_ARGS_END



MOUSERECT eicas2_rect[] =
{
	MOUSE_PARENT_BEGIN( 0, 0, 0, 0, HELP_NONE )
		/*
		 * N2
		 */
		MOUSE_PARENT_BEGIN( 2, 17, 136, 52, HELPID_GAUGE_ENGINE_N2 )
		MOUSE_PARENT_END

		/*
		 * fuel flow
		 */ 
		MOUSE_PARENT_BEGIN( 1, 87, 64, 50, HELP_NONE )
			MOUSE_TOOLTIP_TEXT_ID(TOOLTIPTEXT_ENG1_FUEL_FLOW_GALLON_HOUR, Eicas2ToolTipEngine1ff)
		MOUSE_PARENT_END
		MOUSE_PARENT_BEGIN(73, 87, 64, 50, HELP_NONE )
			MOUSE_TOOLTIP_TEXT_ID(TOOLTIPTEXT_ENG2_FUEL_FLOW_GALLON_HOUR, Eicas2ToolTipEngine2ff)
		MOUSE_PARENT_END


	MOUSE_PARENT_END
	{
		MOUSE_RECT_EOL, { 0, 0, 0, 0 }, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL
	}
};


////////////////////////////////////////////////////////////////////////////////
// gauge initialization proc
////////////////////////////////////////////////////////////////////////////////
void FSAPI eicas2_gaugeproc( PGAUGEHDR pgauge, int service_id, UINT32 extra_data )
{
	switch(service_id)
	{
	case PANEL_SERVICE_PRE_INSTALL:		// install_routine()
		break;

	case PANEL_SERVICE_PRE_INITIALIZE:	// initialize_routine()
		break;

	case PANEL_SERVICE_PRE_UPDATE:		// update_routine()
		if (bPanelLightOn)	// if panel lights, brighten all elements
		{
			BRIGHT_IMG(pgauge->elements_list[0]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[1]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[2]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[3]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[4]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[5]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[6]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[7]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[8]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[9]);
		}
		else							// otherwise darken them
		{
			DARK_IMG(pgauge->elements_list[0]);
			DARK_IMG(pgauge->elements_list[0]->N_E[0]);
			DARK_IMG(pgauge->elements_list[0]->N_E[1]);
			DARK_IMG(pgauge->elements_list[0]->N_E[2]);
			DARK_IMG(pgauge->elements_list[0]->N_E[3]);
			DARK_IMG(pgauge->elements_list[0]->N_E[4]);
			DARK_IMG(pgauge->elements_list[0]->N_E[5]);
			DARK_IMG(pgauge->elements_list[0]->N_E[6]);
			DARK_IMG(pgauge->elements_list[0]->N_E[7]);
			DARK_IMG(pgauge->elements_list[0]->N_E[8]);
			DARK_IMG(pgauge->elements_list[0]->N_E[9]);
    	}
		break;

	case PANEL_SERVICE_PRE_DRAW:		// draw_routine()
		break;

	case PANEL_SERVICE_PRE_KILL:		// kill_routine()
		break;
	}
}

#undef GAUGE_NAME
#undef GAUGEHDR_VAR_NAME
#undef GAUGE_W

FLOAT64 FSAPI eicas2_e1n2_string_cb(PELEMENT_STRING pelement)
{
	FLOAT64 val = pelement->source_var[0].var_value.n;
	if (val>100)
		val=100;
	fEng1N2Needle=val;
	wsprintf(pelement->string, "%0.3d", (int)val);
	return val;
}

FLOAT64 FSAPI eicas2_e2n2_string_cb(PELEMENT_STRING pelement)
{
	FLOAT64 val = pelement->source_var[0].var_value.n;
	if (val>100)
		val=100;
	fEng2N2Needle=val;
	wsprintf(pelement->string, "%0.3d", (int)val);
	return val;
}

FLOAT64 FSAPI eicas2_e1ff_string_cb(PELEMENT_STRING pelement)
{
	FLOAT64 val = pelement->source_var[0].var_value.n*100/16384;
	if (val>100)
		val=100;
	fEng1ffNeedle=val;
	wsprintf(pelement->string, "%0.3d", (int)val);
	return val;
}

FLOAT64 FSAPI eicas2_e2ff_string_cb(PELEMENT_STRING pelement)
{
	FLOAT64 val = pelement->source_var[0].var_value.n*100/16384;
	if (val>100)
		val=100;
	fEng2ffNeedle=val;
	wsprintf(pelement->string, "%0.3d", (int)val);
	return val;
}

/*
 * update engine 1 n2 needle
 */
FLOAT64 FSAPI eicas2_e1n2_needle_cb(PELEMENT_NEEDLE pelement)
{
	return fEng1N2Needle;
}

/*
 * update engine 2 n2 needle
 */
FLOAT64 FSAPI eicas2_e2n2_needle_cb(PELEMENT_NEEDLE pelement)
{
	return fEng2N2Needle;
}

/*
 * update engine 1 ff needle
 */
FLOAT64 FSAPI eicas2_e1ff_needle_cb(PELEMENT_NEEDLE pelement)
{
	return fEng1ffNeedle;
}

/*
 * update engine 2 ff needle
 */
FLOAT64 FSAPI eicas2_e2ff_needle_cb(PELEMENT_NEEDLE pelement)
{
	return fEng2ffNeedle;
}

/*
 * update no smoking sign
 */
FLOAT64 FSAPI eicas2_no_smoking_icon_cb(PELEMENT_ICON p)
{
	return NoSmokingSign ? 1 : 0;
}

/*
 * update fasten seat belts sign
 */
FLOAT64 FSAPI eicas2_fasten_seat_belts_icon_cb(PELEMENT_ICON p)
{
	return FastenSeatBelts ? 1 : 0;
}
