/*
 * $Id: flap_lt.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The flaps lights gauge $
 *
 * $Log: flap_lt.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char flaps_lights_gauge_name[]	= 	GAUGE_NAME;
extern PELEMENT_HEADER      flaps_lights_list;
extern MOUSERECT            flaps_lights_rect[];

void FSAPI flaps_lights_gaugeproc(PGAUGEHDR, int, UINT32 );

FLOAT64 FSAPI flaps_ext_icon_cb(PELEMENT_ICON);
FLOAT64 FSAPI flaps_transit_icon_cb(PELEMENT_ICON);

GAUGE_HEADER_FS700( GAUGE_W, flaps_lights_gauge_name, &flaps_lights_list, \
					flaps_lights_rect, flaps_lights_gaugeproc, 0, 0, 0);


/*
 * failures
 */
FAILURE_RECORD flaps_ext_icon_fail[] =
{
   { FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW },
   { FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW },
   { FAIL_NONE, FAIL_ACTION_NONE }
};

FAILURE_RECORD flaps_transit_icon_fail[] =
{
   { FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW },
   { FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW },
   { FAIL_NONE, FAIL_ACTION_NONE }
};


/*
 * flaps ext icon
 */
MAKE_ICON
(      
	flaps_ext_icon,
	BMP_FLAP_EXT_OFF,
	NULL,
	flaps_ext_icon_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	33, 1,
	FLAPS_POS_LEFT, flaps_ext_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)

/*
 * flaps transit icon
 */
MAKE_ICON
(      
	flaps_transit_icon,
	BMP_FLAP_TRANSIT_OFF,
	NULL,
	flaps_transit_icon_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	1, 1,
	FLAPS_POS_LEFT, flaps_transit_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)

PELEMENT_HEADER flaps_lights_card_list[] =
{
	&flaps_ext_icon.header,
	&flaps_transit_icon.header,
	NULL
};


/*
 * card background image
 */
MAKE_STATIC
(
    flaps_lights_bg,
    BMP_FLAP_LIGHTS_BG,
    &flaps_lights_card_list,
    NULL,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	0,0
)


extern PELEMENT_HEADER      flaps_lights_list = &flaps_lights_bg.header;

/*
 * flaps mouse rect
 */
MOUSERECT flaps_lights_rect[] =
{
    MOUSE_PARENT_BEGIN( 0, 0, 0, 0, HELP_NONE )
	    MOUSE_PARENT_BEGIN( 32, 0, 32, 19, HELPID_B737_FLAPS_EXT_LIGHT )
	    MOUSE_PARENT_END
	    MOUSE_PARENT_BEGIN( 0, 0, 32, 19, HELPID_B737_FLAPS_TRANSIT_LIGHT )
	    MOUSE_PARENT_END
    MOUSE_PARENT_END
    { MOUSE_RECT_EOL, { 0, 0, 0, 0 }, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL }
};

FLOAT64 FSAPI flaps_ext_icon_cb(PELEMENT_ICON pelement)
{
	return pelement->source_var.var_value.n>=409.6 ? 1 : 0;
}

FLOAT64 FSAPI flaps_transit_icon_cb(PELEMENT_ICON pelement)
{
	return (pelement->source_var.var_value.n>0 && pelement->source_var.var_value.n<409.6) ? 1 : 0;
}


////////////////////////////////////////////////////////////////////////////////
// gauge initialization proc
////////////////////////////////////////////////////////////////////////////////
void FSAPI flaps_lights_gaugeproc( PGAUGEHDR pgauge, int service_id, UINT32 extra_data )
{
	switch(service_id)
	{
	case PANEL_SERVICE_PRE_INSTALL:		// install_routine()
		break;

	case PANEL_SERVICE_PRE_INITIALIZE:	// initialize_routine()
		break;

	case PANEL_SERVICE_PRE_UPDATE:		// update_routine()
		if (bPanelLightOn)	// if panel lights, brighten all elements
		{
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[1]);
		}
		else							// otherwise darken them
		{
			DARK_IMG(pgauge->elements_list[0]->N_E[0]);
			DARK_IMG(pgauge->elements_list[0]->N_E[1]);
    	}
		break;
	case PANEL_SERVICE_PRE_DRAW:		// draw_routine()
		break;

	case PANEL_SERVICE_PRE_KILL:		// kill_routine()
		break;
	}
}

#undef		GAUGE_NAME
#undef		GAUGEHDR_VAR_NAME
#undef		GAUGE_W

