/*
 * $Id: flaps.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The flaps gauge $
 *
 * $Log: flaps.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char flaps_gauge_name[]	= 	GAUGE_NAME;
extern PELEMENT_HEADER      flaps_list;
extern MOUSERECT            flaps_rect[];

void FSAPI flapsgaugeproc(PGAUGEHDR, int, UINT32 );

GAUGE_HEADER_FS700( GAUGE_W, flaps_gauge_name, &flaps_list, \
					flaps_rect, flapsgaugeproc, 0, 0, 0);

FAILURE_RECORD flaps_needle_fail[] =
{
   {FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
   {FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
   {FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD flaps_bg_fail[] =
{
   {FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
   {FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
   {FAIL_NONE, FAIL_ACTION_NONE}
};


NONLINEARITY flaps_nonlinearity[] =
{
   {{  17,   40}, 0,     0	},
   {{  24,   24}, 2048,  0	},
   {{  40,   15}, 4095,  0	},
   {{  56,   18}, 6143,  0	},
   {{  69,   31}, 8190,  0	},
   {{  70,   44}, 10237, 0	},
   {{  65,   56}, 12285, 0	},
   {{  55,   65}, 14333, 0	},
   {{  41,   68}, 16384, 0	}
};


MAKE_NEEDLE
(
	flaps_needle,
	BMP_FLAPS_NEEDLE,
	NULL,
	flaps_needle_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 44, 42 },
	{ -9, 2 },
	//{ 90, 0 },
	FLAPS_POS_RIGHT,
	NULL,
	flaps_nonlinearity,
	6
)


PELEMENT_HEADER flaps_card_list[] =
{
	&flaps_needle.header,
	NULL
};


/*
 * card background image
 */
MAKE_STATIC
(
    flaps_bg,
    BMP_FLAPS_BG,
    &flaps_card_list,
    flaps_bg_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	0,0
)


extern PELEMENT_HEADER      flaps_list = &flaps_bg.header;

/*
 * flaps mouse rect
 */
MOUSERECT flaps_rect[] =
{
    MOUSE_PARENT_BEGIN( 0, 0, 0, 0, HELPID_SPITFIRE_FLAPS )
        MOUSE_CHILD_EVENT( 0, 0, 44, 85, CURSOR_DOWNARROW, MOUSE_LEFTSINGLE, KEY_FLAPS_DECR )
        MOUSE_CHILD_EVENT( 44, 0, 44, 85, CURSOR_UPARROW, MOUSE_LEFTSINGLE, KEY_FLAPS_INCR )
    MOUSE_PARENT_END
    { MOUSE_RECT_EOL, { 0, 0, 0, 0 }, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL }
};


////////////////////////////////////////////////////////////////////////////////
// gauge initialization proc
////////////////////////////////////////////////////////////////////////////////
void FSAPI flapsgaugeproc( PGAUGEHDR pgauge, int service_id, UINT32 extra_data )
{
	switch(service_id)
	{
	case PANEL_SERVICE_PRE_INSTALL:		// install_routine()
		break;

	case PANEL_SERVICE_PRE_INITIALIZE:	// initialize_routine()
		break;

	case PANEL_SERVICE_PRE_UPDATE:		// update_routine()
		if (bPanelLightOn)	// if panel lights, brighten all elements
		{
			BRIGHT_IMG(pgauge->elements_list[0]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]);
		}
		else							// otherwise darken them
		{
			DARK_IMG(pgauge->elements_list[0]);
			DARK_IMG(pgauge->elements_list[0]->N_E[0]);
    	}
		break;
	case PANEL_SERVICE_PRE_DRAW:		// draw_routine()
		break;

	case PANEL_SERVICE_PRE_KILL:		// kill_routine()
		break;
	}
}

#undef		GAUGE_NAME
#undef		GAUGEHDR_VAR_NAME
#undef		GAUGE_W

