/*
 * $Id: fuel.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The fuel regulator $
 *
 * $Log: fuel.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char fuel_gauge_name[]	= 	GAUGE_NAME;
extern PELEMENT_HEADER      fuel_list;
extern MOUSERECT            fuel_rect[];

UINT32 nFuelQtyLeft = 0;
UINT32 nFuelQtyRight = 0;


/*
 * forward declarations
 */
void FSAPI fuel_gaugeproc(PGAUGEHDR, int, UINT32);

PELEMENT_HEADER fuel_bg_list[];

FLOAT64 FSAPI fuel_left_hund_icon_cb(PELEMENT_ICON);
FLOAT64 FSAPI fuel_left_thous_icon_cb(PELEMENT_ICON);
FLOAT64 FSAPI fuel_left_one_icon_cb(PELEMENT_ICON);
FLOAT64 FSAPI fuel_right_hund_icon_cb(PELEMENT_ICON);
FLOAT64 FSAPI fuel_right_thous_icon_cb(PELEMENT_ICON);
FLOAT64 FSAPI fuel_right_one_icon_cb(PELEMENT_ICON);

GAUGE_HEADER_FS700( GAUGE_W, fuel_gauge_name, &fuel_list, \
					fuel_rect, fuel_gaugeproc, 0, 0, 0);


/*
 * failure lists
 */
FAILURE_RECORD fuel_left_hund_icon_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_FUEL_INDICATORS, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD fuel_left_thous_icon_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_FUEL_INDICATORS, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD fuel_left_one_icon_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_FUEL_INDICATORS, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD fuel_right_hund_icon_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_FUEL_INDICATORS, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD fuel_right_thous_icon_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_FUEL_INDICATORS, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD fuel_right_one_icon_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_FUEL_INDICATORS, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};


/*
 * fuel left hundred thousand icon
 */
MAKE_ICON
(
	fuel_left_hund_icon,
	BMP_FUEL_NUMBER_0_0,
	NULL,
	fuel_left_hund_icon_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	7, 7,
	MODULE_VAR_NONE,
	fuel_left_hund_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	10,
	0.000000,
	0
)

/*
 * fuel left ten thousand icon
 */
MAKE_ICON
(
	fuel_left_thous_icon,
	BMP_FUEL_NUMBER_0_0,
	NULL,
	fuel_left_thous_icon_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	18, 7,
	MODULE_VAR_NONE,
	fuel_left_thous_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	10,
	0.000000,
	0
)

/*
 * fuel left one thousand icon
 */
MAKE_ICON
(
	fuel_left_one_icon,
	BMP_FUEL_NUMBER_1_0,
	NULL,
	fuel_left_one_icon_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	29, 6,
	MODULE_VAR_NONE,
	fuel_left_one_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	10,
	0.000000,
	0
)


/*
 * fuel right hundred thousand icon
 */
MAKE_ICON
(
	fuel_right_hund_icon,
	BMP_FUEL_NUMBER_0_0,
	NULL,
	fuel_right_hund_icon_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	109, 7,
	MODULE_VAR_NONE,
	fuel_right_hund_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	10,
	0.000000,
	0
)

/*
 * fuel right ten thousand icon
 */
MAKE_ICON
(
	fuel_right_thous_icon,
	BMP_FUEL_NUMBER_0_0,
	NULL,
	fuel_right_thous_icon_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	120, 7,
	MODULE_VAR_NONE,
	fuel_right_thous_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	10,
	0.000000,
	0
)

/*
 * fuel right one thousand icon
 */
MAKE_ICON
(
	fuel_right_one_icon,
	BMP_FUEL_NUMBER_1_0,
	NULL,
	fuel_right_one_icon_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	131, 6,
	MODULE_VAR_NONE,
	fuel_right_one_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	10,
	0.000000,
	0
)


/*
 * card background image
 */
MAKE_STATIC
(
    fuel_bg,
    BMP_FUEL_BG,
    &fuel_bg_list,
    NULL,
	IMAGE_USE_ERASE | transparent,
	0,
	0,0
)

/*
 * priority lists
 */
PELEMENT_HEADER fuel_bg_list[] =
{
	&fuel_left_hund_icon.header,
	&fuel_left_thous_icon.header,
	&fuel_left_one_icon.header,
	&fuel_right_hund_icon.header,
	&fuel_right_thous_icon.header,
	&fuel_right_one_icon.header,
	NULL
};


extern PELEMENT_HEADER      fuel_list = &fuel_bg.header;

MOUSERECT fuel_rect[] =
{
    MOUSE_PARENT_BEGIN( 0, 0, 0, 0, HELPID_CONCORDE_FUEL_QUANTITY )
    MOUSE_PARENT_END
    { MOUSE_RECT_EOL, { 0, 0, 0, 0 }, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL }
};


#undef		GAUGE_NAME
#undef		GAUGEHDR_VAR_NAME
#undef		GAUGE_W


////////////////////////////////////////////////////////////////////////////////
// gauge initialization proc
////////////////////////////////////////////////////////////////////////////////
void FSAPI fuel_gaugeproc( PGAUGEHDR pgauge, int service_id, UINT32 extra_data )
{
	FLOAT64 fLeft, fRight;
	switch(service_id)
	{
	case PANEL_SERVICE_PRE_INSTALL:		// install_routine()
		break;

	case PANEL_SERVICE_PRE_INITIALIZE:	// initialize_routine()
		break;

	case PANEL_SERVICE_PRE_UPDATE:		// update_routine()
		if (bPanelLightOn)	// if panel lights, brighten all elements
		{
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[1]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[2]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[3]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[4]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[5]);
		}
		else							// otherwise darken them
		{
			DARK_IMG(pgauge->elements_list[0]->N_E[0]);	
			DARK_IMG(pgauge->elements_list[0]->N_E[1]);	
			DARK_IMG(pgauge->elements_list[0]->N_E[2]);	
			DARK_IMG(pgauge->elements_list[0]->N_E[3]);	
			DARK_IMG(pgauge->elements_list[0]->N_E[4]);	
			DARK_IMG(pgauge->elements_list[0]->N_E[5]);	
    	}

		
		
		lookup_var(&fuel_weight);
		lookup_var(&fuel_left_main);
		lookup_var(&fuel_right_main);
		
		fLeft = fuel_left_main.var_value.n * (fuel_weight.var_value.n*10);
		fRight = fuel_right_main.var_value.n * (fuel_weight.var_value.n*10);
		
		nFuelQtyLeft = (UINT32)fLeft;
		nFuelQtyRight = (UINT32)fRight;
		

		break;
	case PANEL_SERVICE_PRE_DRAW:		// draw_routine()
		break;

	case PANEL_SERVICE_PRE_KILL:		// kill_routine()
		break;
	}
}

/*
 * update left fuel 100 thousand
 */
FLOAT64 FSAPI fuel_left_hund_icon_cb(PELEMENT_ICON pelement)
{
	return nFuelQtyLeft / 100000 % 10;
}

/*
 * update left fuel 10 thousand
 */
FLOAT64 FSAPI fuel_left_thous_icon_cb(PELEMENT_ICON pelement)
{
	return nFuelQtyLeft / 10000 % 10;
}

/*
 * update left fuel 1 thousand
 */
FLOAT64 FSAPI fuel_left_one_icon_cb(PELEMENT_ICON pelement)
{
	return nFuelQtyLeft / 1000 % 10;
}

/*
 * update right fuel 100 thousand
 */
FLOAT64 FSAPI fuel_right_hund_icon_cb(PELEMENT_ICON pelement)
{
	return nFuelQtyRight / 100000 % 10;
}

/*
 * update right fuel 10 thousand
 */
FLOAT64 FSAPI fuel_right_thous_icon_cb(PELEMENT_ICON pelement)
{
	return nFuelQtyRight / 10000 % 10;
}

/*
 * update right fuel 1 thousand
 */
FLOAT64 FSAPI fuel_right_one_icon_cb(PELEMENT_ICON pelement)
{
	return nFuelQtyRight / 1000 % 10;
}
