/*
 * $Id: gearlite.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The gear lights gauge $
 *
 * $Log: gearlite.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char gear_lights_gauge_name[]	= 	GAUGE_NAME;
extern PELEMENT_HEADER      gear_lights_list;
extern MOUSERECT            gear_lights_rect[];


/*
 * forward declarations
 */

PELEMENT_HEADER gear_lights_bg_list[];
FLOAT64 FSAPI gear_nose_icon_cb(PELEMENT_ICON);
FLOAT64 FSAPI gear_left_icon_cb(PELEMENT_ICON);
FLOAT64 FSAPI gear_right_icon_cb(PELEMENT_ICON);
void FSAPI gear_lights_gaugeproc(PGAUGEHDR, int, UINT32);

GAUGE_HEADER_FS700( GAUGE_W, gear_lights_gauge_name, &gear_lights_list, \
					gear_lights_rect, gear_lights_gaugeproc, 0, 0, 0);

FAILURE_RECORD	gear_nose_icon_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD	gear_left_icon_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD	gear_right_icon_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};


/*
 * gear nose icon
 */
MAKE_ICON
(
	gear_nose_icon,
	BMP_NOSE_GEAR_LIGHT_OFF,
	NULL,
	gear_nose_icon_fail,
	IMAGE_USE_ERASE,
	0,
	24, 2,
	GEAR_POS_NOSE,
	gear_nose_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)

/*
 * gear left icon
 */
MAKE_ICON
(
	gear_left_icon,
	BMP_LEFT_GEAR_LIGHT_OFF,
	NULL,
	gear_left_icon_fail,
	IMAGE_USE_ERASE,
	0,
	2, 25,
	GEAR_POS_LEFT,
	gear_left_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)

/*
 * gear right icon
 */
MAKE_ICON
(
	gear_right_icon,
	BMP_RIGHT_GEAR_LIGHT_OFF,
	NULL,
	gear_right_icon_fail,
	IMAGE_USE_ERASE,
	0,
	44, 25,
	GEAR_POS_RIGHT,
	gear_right_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)



/*
 * card background image
 */
MAKE_STATIC
(
    gear_lights_bg,
    BMP_GEAR_LIGHTS_BG,
    &gear_lights_bg_list,
    NULL,
	transparent,
	0,
	0,0
)

/*
 * priority lists
 */
PELEMENT_HEADER gear_lights_bg_list[] =
{
	&gear_nose_icon.header,
	&gear_left_icon.header,
	&gear_right_icon.header,
	NULL
};


extern PELEMENT_HEADER      gear_lights_list = &gear_lights_bg.header;

MOUSE_BEGIN( gear_lights_rect, HELP_NONE, 0, 0 )
	
MOUSE_END


#undef		GAUGE_NAME
#undef		GAUGEHDR_VAR_NAME
#undef		GAUGE_W

/*
 * update nose icon
 */
FLOAT64 FSAPI gear_nose_icon_cb(PELEMENT_ICON pelement)
{
	return TRUE_FALSE(pelement);
}

/*
 * update left icon
 */
FLOAT64 FSAPI gear_left_icon_cb(PELEMENT_ICON pelement)
{
	return TRUE_FALSE(pelement);
}

/*
 * update nose icon
 */
FLOAT64 FSAPI gear_right_icon_cb(PELEMENT_ICON pelement)
{
	return TRUE_FALSE(pelement);
}


////////////////////////////////////////////////////////////////////////////////
// gauge initialization proc
////////////////////////////////////////////////////////////////////////////////
void FSAPI gear_lights_gaugeproc( PGAUGEHDR pgauge, int service_id, UINT32 extra_data )
{
	
	switch(service_id)
	{
	case PANEL_SERVICE_PRE_INSTALL:		// install_routine()
		break;

	case PANEL_SERVICE_PRE_INITIALIZE:	// initialize_routine()
		break;

	case PANEL_SERVICE_PRE_UPDATE:		// update_routine()
		if (bPanelLightOn)	// if panel lights, brighten all elements
		{
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[1]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[2]);
		}
		else							// otherwise darken them
		{
			DARK_IMG(pgauge->elements_list[0]->N_E[0]);	
			DARK_IMG(pgauge->elements_list[0]->N_E[1]);	
			DARK_IMG(pgauge->elements_list[0]->N_E[2]);	
    	}
		break;

	case PANEL_SERVICE_PRE_DRAW:		// draw_routine()
		break;

	case PANEL_SERVICE_PRE_KILL:		// kill_routine()
		break;
	}
}
