/*
 * $Id: gearlvr.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The gear lever gauge $
 *
 * $Log: gearlvr.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char gear_lever_gauge_name[]	= 	GAUGE_NAME;
extern PELEMENT_HEADER      gear_lever_list;
extern MOUSERECT            gear_lever_rect[];


/*
 * forward declarations
 */
PELEMENT_HEADER gear_lever_bg_list[];
GAUGE_HEADER_FS700( GAUGE_W, gear_lever_gauge_name, &gear_lever_list, \
					gear_lever_rect, NULL, 0, 0, 0);

FAILURE_RECORD	gear_lever_slider_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NONE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};




/*
 * gear lever slider
 */
MAKE_SLIDER
(    
	gear_lever_slider,
	BMP_GEAR_LEVER_SLIDER,
	NULL,
	gear_lever_slider_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 6, 0 },
	MODULE_VAR_NONE, NULL, 0.000000,
	GEAR_HANDLE_POS, NULL, 0.007080 
)


/*
 * card background image
 */
MAKE_STATIC
(
    gear_lever_bg,
    BMP_GEAR_LEVER_BG,
    &gear_lever_bg_list,
    NULL,
	IMAGE_USE_ERASE | transparent,
	0,
	0,0
)

/*
 * priority lists
 */
PELEMENT_HEADER gear_lever_bg_list[] =
{
	&gear_lever_slider.header,
	NULL
};


extern PELEMENT_HEADER      gear_lever_list = &gear_lever_bg.header;

MOUSE_BEGIN( gear_lever_rect, HELPID_GAUGE_GEAR_LEVER, 0, 0 )
	MOUSE_CHILD_EVENT( 0, 0, 55, 194, CURSOR_HAND, MOUSE_LEFTSINGLE, KEY_GEAR_TOGGLE)
MOUSE_END


#undef		GAUGE_NAME
#undef		GAUGEHDR_VAR_NAME
#undef		GAUGE_W
