/*
 * $Id: hsi.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The hsi gauge $
 *
 * $Log: hsi.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char hsi_gauge_name[]	= 	GAUGE_NAME;
extern PELEMENT_HEADER      hsi_list;
extern MOUSERECT            hsi_rect[];


/*
 * forward declarations
 */
PELEMENT_HEADER hsi_arc_horizontal_needle_list[];
PELEMENT_HEADER hsi_arc_horizontal_gs_list[];
PELEMENT_HEADER hsi_arc_sprite_list[];
PELEMENT_HEADER hsi_arc_bg_list[];
PELEMENT_HEADER hsi_tf_indicator_list[];
PELEMENT_HEADER hsi_plane_list[];
PELEMENT_HEADER hsi_vor2_needle_list[];
PELEMENT_HEADER hsi_heading_bug_list[];
PELEMENT_HEADER hsi_cdi_list[];
PELEMENT_HEADER hsi_horizontal_gs_list[];
PELEMENT_HEADER hsi_gyroscope_needle_list[];
PELEMENT_HEADER hsi_bg_list[];

FLOAT64 FSAPI hsi_gyroscope_needle_cb(PELEMENT_SPRITE);
FLOAT64 FSAPI hsi_horizontal_gs_cb(PELEMENT_NEEDLE);
FLOAT64 FSAPI hsi_cdi_x_cb(PELEMENT_SPRITE);
FLOAT64 FSAPI hsi_cdi_z_cb(PELEMENT_SPRITE);
FLOAT64 FSAPI hsi_vor2_needle_cb(PELEMENT_NEEDLE);
FLOAT64 FSAPI hsi_heading_bug_cb(PELEMENT_NEEDLE);
FLOAT64 FSAPI hsi_magnetic_heading_string_cb(PELEMENT_STRING);
FLOAT64 FSAPI hsi_vor1_id_string_cb(PELEMENT_STRING);
FLOAT64 FSAPI hsi_vor1_freq_string_cb(PELEMENT_STRING);
FLOAT64 FSAPI hsi_vor2_id_string_cb(PELEMENT_STRING);
FLOAT64 FSAPI hsi_vor2_freq_string_cb(PELEMENT_STRING);
FLOAT64 FSAPI hsi_arc_horizontal_gs_cb(PELEMENT_SPRITE);

void FSAPI hsi_gaugeproc(PGAUGEHDR, int, UINT32);

GAUGE_HEADER_FS700( GAUGE_W, hsi_gauge_name, &hsi_list, \
					hsi_rect, hsi_gaugeproc, 0, 0, 0);


/*
 * failure lists
 */
FAILURE_RECORD  hsi_gyroscope_needle_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_GYRO_HEADING, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD  hsi_arc_sprite_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_GYRO_HEADING, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD  hsi_horizontal_gs_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_NAVIGATION_VOR1, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD  hsi_arc_horizontal_gs_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_NAVIGATION_VOR1, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD  hsi_arc_horizontal_needle_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_NAVIGATION_VOR1, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD  hsi_cdi_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_NAVIGATION_VOR1, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD  hsi_vor2_needle_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_NAVIGATION_VOR2, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD  hsi_heading_bug_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD  hsi_magnetic_heading_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_MAGNETIC_COMPASS, FAIL_ACTION_FREEZE},
	{FAIL_GAUGE_GYRO_HEADING, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD  hsi_vor1_id_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD  hsi_vor1_freq_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD  hsi_vor2_id_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD  hsi_vor2_freq_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

/*
 * vor 2 frequency string
 */
MAKE_STRING
(
	hsi_vor2_freq_string,
	NULL,
	hsi_vor2_freq_string_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	{171, 28},
	{72, 17},
	6,

	NAV2_FREQUENCY,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_LIME,
	RGB(4,4,4),
	CL_WHITE,
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_LEFT,
	NULL,
	hsi_vor2_freq_string_cb
)

/*
 * vor 2 id string
 */
MAKE_STRING
(
	hsi_vor2_id_string,
	NULL,
	hsi_vor2_id_string_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	{195, 7},
	{48, 17},
	4,

	VOR2_IDENTITY,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_LIME,
	RGB(4,4,4),
	CL_WHITE,
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_RIGHT,
	NULL,
	hsi_vor2_id_string_cb
)


/*
 * vor 1 frequency string
 */
MAKE_STRING
(
	hsi_vor1_freq_string,
	NULL,
	hsi_vor1_freq_string_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	{7, 28},
	{72, 17},
	6,

	NAV1_FREQUENCY,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_WHITE,
	RGB(4,4,4),
	CL_WHITE,
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_LEFT,
	NULL,
	hsi_vor1_freq_string_cb
)

/*
 * vor 1 id string
 */
MAKE_STRING
(
	hsi_vor1_id_string,
	NULL,
	hsi_vor1_id_string_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	{7, 7},
	{48, 17},
	4,

	VOR1_IDENTITY,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_WHITE,
	RGB(4,4,4),
	CL_WHITE,
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_LEFT,
	NULL,
	hsi_vor1_id_string_cb
)



/*
 * plane magnetic heading string
 */
MAKE_STRING
(
	hsi_magnetic_heading_string,
	NULL,
	hsi_magnetic_heading_string_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	{100, 7},
	{48, 17},
	3,

	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_WHITE,
	RGB(4,4,4),
	CL_WHITE,
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_LEFT,
	NULL,
	hsi_magnetic_heading_string_cb
)


/*
 * hsi arc horizontal needle (in reality that is the vertical needle!!!)
 */
MAKE_SPRITE
(
	hsi_arc_horizontal_needle,
	BMP_HSI_ARC_HORIZONTAL_NEEDLE,
	&hsi_arc_horizontal_needle_list,
	hsi_arc_horizontal_needle_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
    10, 90,
	125, 280,
	1, 1,

	HSI_VERTICAL_NEEDLE, hsi_cdi_x_cb, -2,
	MODULE_VAR_NONE, NULL, 0,
	MODULE_VAR_NONE, hsi_cdi_z_cb, 1
)

/*
 * hsi arc horizontal gs
 */
MAKE_SPRITE
(
	hsi_arc_horizontal_gs,
	BMP_HSI_ARC_HORIZONTAL_GS,
	&hsi_arc_horizontal_gs_list,
	hsi_arc_horizontal_gs_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
    0, 30,
	125, 280,
	1, 1,

	MODULE_VAR_NONE, NULL, 0,
	MODULE_VAR_NONE, NULL, 0,
	MODULE_VAR_NONE, hsi_arc_horizontal_gs_cb, 1
)

/*
 * hsi arc
 */
MAKE_SPRITE
(
	hsi_arc_sprite,
	BMP_HSI_ARC_SPRITE,
	&hsi_arc_sprite_list,
	hsi_arc_sprite_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
    0, 30,
	125, 280,
	1, 1,

	MODULE_VAR_NONE, NULL, 0,
	MODULE_VAR_NONE, NULL, 0,
	MODULE_VAR_NONE, hsi_gyroscope_needle_cb, 1
)


/*
 * hsi arc background
 */
MAKE_STATIC
(
    hsi_arc_bg,
    BMP_HSI_ARC_BG,
    &hsi_arc_bg_list,
    NULL,
	transparent | IMAGE_USE_ERASE,
	0,
	0, 0
)



/*
 * t/f indicator
 */
MAKE_STATIC
(
    hsi_tf_indicator,
    BMP_HSI_TF_INDICATOR,
    &hsi_tf_indicator_list,
    NULL,
	transparent | IMAGE_USE_ERASE,
	0,
	80, 92
)

/*
 * plane icon
 */
MAKE_STATIC
(
    hsi_plane,
    BMP_HSI_PLANE,
    &hsi_plane_list,
    NULL,
	transparent | IMAGE_USE_ERASE,
	0,
	125-17,142-16
)



/*
 * hsi vor 2 needle
 */
MAKE_NEEDLE
(
	hsi_vor2_needle,
	BMP_HSI_VOR2_NEEDLE,
	&hsi_vor2_needle_list,
	hsi_vor2_needle_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 125, 142 },
	{ 13, 114 },
	
	MODULE_VAR_NONE,
	hsi_vor2_needle_cb,
	NULL,
	0
)

/*
 * hsi heading bug
 */
MAKE_NEEDLE
(
	hsi_heading_bug,
	BMP_HSI_HEADING_BUG,
	&hsi_heading_bug_list,
	hsi_heading_bug_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 125, 142 },
	{ 11, 116 },
	
	MODULE_VAR_NONE,
	hsi_heading_bug_cb,
	NULL,
	0
)

/*
 * hsi cdi
 */
MAKE_SPRITE
(
	hsi_cdi,
	BMP_HSI_CDI,
	&hsi_cdi_list,
	hsi_cdi_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
    125-71, 142-60,
	125, 142,
	1, 1,

	HSI_VERTICAL_NEEDLE, hsi_cdi_x_cb, -1,
	MODULE_VAR_NONE, NULL, 0,
	MODULE_VAR_NONE, hsi_cdi_z_cb, -1
)


/*
 * hsi horizontal gs (vertical needle !!!)
 */
MAKE_NEEDLE
(
	hsi_horizontal_gs,
	BMP_HSI_HORIZONTAL_GS,
	&hsi_horizontal_gs_list,
	hsi_horizontal_gs_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 125, 142 },
	{ 55, 95 },
	
	MODULE_VAR_NONE,
	hsi_horizontal_gs_cb,
	NULL,
	0
)


/*
 * hsi gyroscope (rose)
 */
MAKE_SPRITE
(
	hsi_gyroscope_needle,
	BMP_HSI_ROSE,
	&hsi_gyroscope_needle_list,
	hsi_gyroscope_needle_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
    19, 35,
	125, 142,
	1, 1,

	MODULE_VAR_NONE, NULL, 0,
	MODULE_VAR_NONE, NULL, 0,
	MODULE_VAR_NONE, hsi_gyroscope_needle_cb, 1
)


/*
 * card background image
 */
MAKE_STATIC
(
    hsi_bg,
    BMP_HSI_BG,
    &hsi_bg_list,
    NULL,
	transparent | IMAGE_USE_ERASE,
	0,
	0,0
)

/*
 * priority lists
 */
PELEMENT_HEADER hsi_arc_horizontal_needle_list[] =
{
	&hsi_magnetic_heading_string.header,
	&hsi_vor1_id_string.header,
	&hsi_vor1_freq_string.header,
	&hsi_vor2_id_string.header,
	&hsi_vor2_freq_string.header,
	NULL
};

PELEMENT_HEADER hsi_arc_horizontal_gs_list[] =
{
	&hsi_arc_horizontal_needle.header,
	NULL
};

PELEMENT_HEADER hsi_arc_sprite_list[] =
{
	&hsi_arc_horizontal_gs.header,
	NULL
};

PELEMENT_HEADER hsi_arc_bg_list[] =
{
	&hsi_arc_sprite.header,
	NULL
};


PELEMENT_HEADER hsi_tf_indicator_list[] =
{
	&hsi_arc_bg.header,
	NULL
};
 
PELEMENT_HEADER hsi_plane_list[] =
{
	&hsi_tf_indicator.header,
	NULL
};
PELEMENT_HEADER hsi_vor2_needle_list[] =
{
	&hsi_plane.header,
	NULL
};
PELEMENT_HEADER hsi_heading_bug_list[] =
{
	&hsi_vor2_needle.header,
	NULL
};

PELEMENT_HEADER hsi_cdi_list[] = 
{
	&hsi_heading_bug.header,
	NULL
};

PELEMENT_HEADER hsi_horizontal_gs_list[] = 
{
	&hsi_cdi.header,
	NULL
};

PELEMENT_HEADER hsi_gyroscope_needle_list[] =
{
	&hsi_horizontal_gs.header,
	NULL
};

PELEMENT_HEADER hsi_bg_list[] =
{
	&hsi_gyroscope_needle.header,
	NULL
};


extern PELEMENT_HEADER      hsi_list = &hsi_bg.header;

MOUSE_BEGIN( hsi_rect, HELPID_GAUGE_HSI, 0, 0 )
	
MOUSE_END


#undef		GAUGE_NAME
#undef		GAUGEHDR_VAR_NAME
#undef		GAUGE_W

/*
 * update arc horizontal gs
 */
FLOAT64 FSAPI hsi_arc_horizontal_gs_cb(PELEMENT_SPRITE pelement)
{
	return fVor1Needle;
}


/*
 * update gyroscope
 */
FLOAT64 FSAPI hsi_gyroscope_needle_cb(PELEMENT_SPRITE pelement)
{
	return fDegreesGyro;
}

/*
 * update horizontal gs
 */
FLOAT64 FSAPI hsi_horizontal_gs_cb(PELEMENT_NEEDLE pelement)
{
	return fVor1Needle;
}


/*
 * update cdi on Z-axis
 */
FLOAT64 FSAPI hsi_cdi_z_cb(PELEMENT_SPRITE pelement)
{
	return fVor1Needle;
}

/*
 * update cdi on X-axis
 */
FLOAT64 FSAPI hsi_cdi_x_cb(PELEMENT_SPRITE pelement)
{
	return pelement->source_var_x.var_value.n*48;
}

/*
 * update vor arrow
 */
FLOAT64 FSAPI hsi_vor2_needle_cb(PELEMENT_NEEDLE pelement)
{
	return fVor2Radial;
}

/*
 * update heading bug needle
 */
FLOAT64 FSAPI hsi_heading_bug_cb(PELEMENT_NEEDLE pelement)
{
	return fHsiHdgBugDelta;

}

/*
 * update magnetic heading string
 */
FLOAT64 FSAPI hsi_magnetic_heading_string_cb(PELEMENT_STRING pelement)
{
	wsprintf(pelement->string,"%0.3d", (int)fMagneticHeading);
	return fMagneticHeading;

}

/*
 * update vor 1 id string
 */
FLOAT64 FSAPI hsi_vor1_id_string_cb(PELEMENT_STRING pelement)
{
	char *str = (char *)pelement->source_var[0].var_value.p;
	lookup_var(&gps_drives_nav1);
	if (gps_drives_nav1.var_value.n!=0)
		lstrcpy(pelement->string,"GPS");
	else
		lstrcpy(pelement->string,str);
	return 0;
}

/*
 * update vor 2 id string
 */
FLOAT64 FSAPI hsi_vor2_id_string_cb(PELEMENT_STRING pelement)
{
	char *str = (char *)pelement->source_var[0].var_value.p;
	if (*str)
		lstrcpy(pelement->string,str);
	else
		lstrcpy(pelement->string,"----");
	return 0;
}

/*
 * update vor 1 frequency string
 */
FLOAT64 FSAPI hsi_vor1_freq_string_cb(PELEMENT_STRING pelement)
{
	UINT32 nFreq = (UINT32)pelement->source_var[0].var_value.d;

	// do bcd conversion
	wsprintf(pelement->string, "1%d%d.%d%d", (nFreq >> 12) & 0x000f,
		(nFreq >> 8) & 0x000f, (nFreq >> 4) & 0x000f, nFreq & 0x000f);
	return (FLOAT64)nFreq;

}

/*
 * update vor 2 frequency string
 */
FLOAT64 FSAPI hsi_vor2_freq_string_cb(PELEMENT_STRING pelement)
{
	UINT32 nFreq = (UINT32)pelement->source_var[0].var_value.d;

	// do bcd conversion
	wsprintf(pelement->string, "1%d%d.%d%d", (nFreq >> 12) & 0x000f,
		(nFreq >> 8) & 0x000f, (nFreq >> 4) & 0x000f, nFreq & 0x000f);
	return (FLOAT64)nFreq;

}

////////////////////////////////////////////////////////////////////////////////
// gauge initialization proc
////////////////////////////////////////////////////////////////////////////////
void FSAPI hsi_gaugeproc( PGAUGEHDR pgauge, int service_id, UINT32 extra_data )
{
	
	FLOAT64 obi;
	switch(service_id)
	{
	case PANEL_SERVICE_PRE_INSTALL:		// install_routine()
		break;

	case PANEL_SERVICE_PRE_INITIALIZE:	// initialize_routine()
		break;

	case PANEL_SERVICE_PRE_UPDATE:		// update_routine()

		lookup_var(&plane_heading_degrees_gyro); // update gyro degrees
		fDegreesGyro = plane_heading_degrees_gyro.var_value.n;
		lookup_var(&vor1_obi);
		fVor1Needle = vor1_obi.var_value.n - fDegreesGyro;

		lookup_var(&vor2_needle);
		obi = (FLOAT64)vor2_needle.var_value.n*360/(FLOAT64)0xffff;
		fVor2Radial=((obi-plane_heading_degrees_gyro.var_value.n)+180);

		
		fHsiHdgBugDelta=fApHeadingLockDir - fMagneticHeading;


		if (bHsiModeArc)		// arc mode ...
		{
			HIDE_IMAGE(pgauge->elements_list[0]);
			HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]);
			HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]);
			HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]);
			HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);
			HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);
			HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);
			HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]); // t/f indicator
			
		}
		else
		{
			SHOW_IMAGE(pgauge->elements_list[0]);
			SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]);
			SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]);
			SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]);
			SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);
			SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);
			SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);
			SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]); // t/f indicator

		}


	/*	if (bPanelLightOn)	// if panel lights, brighten all elements
		{
			BRIGHT_IMG(pgauge->elements_list[0]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]); // t/f indicator
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]); // mag hdg
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[1]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[2]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[3]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[4]);
		}
		else							// otherwise darken them
		{
			DARK_IMG(pgauge->elements_list[0]);	
			DARK_IMG(pgauge->elements_list[0]->N_E[0]);	
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]);
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]);
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]); // t/f indicator
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]); // mag hdg
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[1]);
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[2]);
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[3]);
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[4]);
    	}*/
		
		
		lookup_var(&deviation_active);
		if (!bHsiModeArc)
		{
			if ((int)deviation_active.var_value.n!=0) // if we have deviation, show cdi
			{
				SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]);
			}
			else									// otherwise hide
			{
				HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]);
			}
		}
		else
			HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]);


		// show/hide to-from indicator
		lookup_var(&to_from_flag);

		if (!bHsiModeArc)
		{
			if (to_from_flag.var_value.n!=0)
			{
				SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]); // t/f indicator
			}
			else
			{
				HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]); // t/f indicator
			}
		}
		else
			HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]); // t/f indicator


		break;
	case PANEL_SERVICE_PRE_DRAW:		// draw_routine()
		break;

	case PANEL_SERVICE_PRE_KILL:		// kill_routine()
		break;
	}
}

