/*
 * $Id: landlite.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The landing lights switch gauge $
 *
 * $Log: landlite.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char lls_gauge_name[]	= 	GAUGE_NAME;
extern PELEMENT_HEADER      lls_list;
extern MOUSERECT            lls_rect[];


/*
 * forward declarations
 */
FLOAT64 FSAPI lls_icon_cb(PELEMENT_ICON);
PELEMENT_HEADER lls_bg_list[];
GAUGE_HEADER_FS700( GAUGE_W, lls_gauge_name, &lls_list, \
					lls_rect, NULL, 0, 0, 0);



FAILURE_RECORD	lls_attitude_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NONE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};




/*
 * flight director icon
 */
MAKE_ICON
(
	lls_icon,
	BMP_LLS_ICON_ON,
	NULL,
	NULL,
	IMAGE_USE_ERASE | transparent,
	0,
	0, 0,
	LANDING_LIGHTS,
	lls_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)



/*
 * card background image
 */
MAKE_STATIC
(
    lls_bg,
    BMP_LLS_BG,
    &lls_bg_list,
    NULL,
	IMAGE_USE_ERASE | transparent,
	0,
	0,0
)

/*
 * priority lists
 */
PELEMENT_HEADER lls_bg_list[] =
{
	&lls_icon.header,
	NULL
};


extern PELEMENT_HEADER      lls_list = &lls_bg.header;

MOUSERECT lls_rect[] =
{
    MOUSE_PARENT_BEGIN( 0, 0, 0, 0, HELPID_GAUGE_LIGHT_SWITCH_LANDING )
		MOUSE_CHILD_EVENT( 0, 0, 33, 40, CURSOR_HAND, \
					MOUSE_LEFTSINGLE, KEY_LANDING_LIGHTS_TOGGLE )
    MOUSE_PARENT_END
    { MOUSE_RECT_EOL, { 0, 0, 0, 0 }, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL }
};


#undef		GAUGE_NAME
#undef		GAUGEHDR_VAR_NAME
#undef		GAUGE_W

FLOAT64 FSAPI lls_icon_cb(PELEMENT_ICON pelement)
{ 
	return pelement->source_var.var_value.n==1 ? 1 : 0;
}