/*
 * $Id: leftrstk.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The left radio stack gauge $
 *
 * $Log: leftrstk.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char left_radio_stack_gauge_name[]     = GAUGE_NAME;
extern PELEMENT_HEADER      left_radio_stack_list;
extern MOUSERECT            left_radio_stack_rect[];


/*
 * forward declarations
 */


void FSAPI left_radio_stack_gaugeproc(PGAUGEHDR, int, UINT32);

FLOAT64 FSAPI left_stack_com1_frequency_string_cb(PELEMENT_STRING);
FLOAT64 FSAPI left_stack_com2_frequency_string_cb(PELEMENT_STRING);
FLOAT64 FSAPI left_stack_nav1_frequency_string_cb(PELEMENT_STRING);
FLOAT64 FSAPI left_stack_nav2_frequency_string_cb(PELEMENT_STRING);
FLOAT64 FSAPI left_stack_nav1_id_icon_cb(PELEMENT_ICON);
FLOAT64 FSAPI left_stack_nav2_id_icon_cb(PELEMENT_ICON);
FLOAT64 FSAPI left_stack_marker_ident_icon_cb(PELEMENT_ICON);

GAUGE_HEADER_FS700(GAUGE_W, left_radio_stack_gauge_name, &left_radio_stack_list, \
                        left_radio_stack_rect, left_radio_stack_gaugeproc, 0, 0, 0);

/*
 * failure lists
 */
FAILURE_RECORD	left_stack_com1_frequency_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_COMMUNICATIONS, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD	left_stack_com2_frequency_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_COMMUNICATIONS, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD	left_stack_nav1_frequency_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_NAVIGATION_VOR1, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD	left_stack_nav2_frequency_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_NAVIGATION_VOR2, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};


/*
 * nav1 ident toggle
 */
MAKE_ICON
(
	left_stack_nav1_ident_icon,
	BMP_RADIO_IDENT_OFF,
	NULL,
	NULL,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY | IMAGE_USE_BRIGHT,
	0,
	6, 5,
	NAV1_MORSE_IDENT,
	left_stack_nav1_id_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)

/*
 * nav2 ident toggle
 */
MAKE_ICON
(
	left_stack_nav2_ident_icon,
	BMP_RADIO_IDENT_OFF,
	NULL,
	NULL,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY | IMAGE_USE_BRIGHT,
	0,
	7, 14,
	NAV2_MORSE_IDENT,
	left_stack_nav2_id_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)

/*
 * marker sound toggle
 */
MAKE_ICON
(
	left_stack_marker_ident_icon,
	BMP_RADIO_IDENT_OFF,
	NULL,
	NULL,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY | IMAGE_USE_BRIGHT,
	0,
	7, 24,
	MARKER_SOUND_TOGGLE,
	left_stack_marker_ident_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)


/*
 * the com1 frequency string
 */
MAKE_STRING
(
	left_stack_com1_frequency_string,
	NULL,
	left_stack_com1_frequency_string_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	{22, 8},
	{46, 18},
	6,

	COM_FREQUENCY,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_LIME,
	RGB(4,4,4),
	CL_WHITE,
	FONT_COURIER,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_LEFT,
	NULL,
	left_stack_com1_frequency_string_cb
)

/*
 * the com2 frequency string
 */
MAKE_STRING
(
	left_stack_com2_frequency_string,
	NULL,
	left_stack_com2_frequency_string_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	{105, 8},
	{46, 18},
	6,

	COM2_FREQUENCY,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_LIME,
	RGB(4,4,4),
	CL_WHITE,
	FONT_COURIER,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_LEFT,
	NULL,
	left_stack_com2_frequency_string_cb
)

/*
 * the nav1 frequency string
 */
MAKE_STRING
(
	left_stack_nav1_frequency_string,
	NULL,
	left_stack_nav1_frequency_string_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	{26, 28},
	{46, 18},
	6,

	NAV1_FREQUENCY,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_LIME,
	RGB(4,4,4),
	CL_WHITE,
	FONT_COURIER,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_LEFT,
	NULL,
	left_stack_nav1_frequency_string_cb
)

/*
 * the nav2 frequency string
 */
MAKE_STRING
(
	left_stack_nav2_frequency_string,
	NULL,
	left_stack_nav2_frequency_string_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	{109, 28},
	{46, 18},
	6,

	NAV2_FREQUENCY,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_LIME,
	RGB(4,4,4),
	CL_WHITE,
	FONT_COURIER,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_LEFT,
	NULL,
	left_stack_nav2_frequency_string_cb
)

PELEMENT_HEADER left_radio_stack_bg_list[] =
{
	&left_stack_com1_frequency_string.header,
	&left_stack_com2_frequency_string.header,
	&left_stack_nav1_frequency_string.header,
	&left_stack_nav2_frequency_string.header,
	&left_stack_nav1_ident_icon.header,
	&left_stack_nav2_ident_icon.header,
	&left_stack_marker_ident_icon.header,
	NULL
};

/*
 * card background image
 */
MAKE_STATIC
(
    left_radio_stack_background,
    BMP_LEFT_RADIO_STACK_BG,
    &left_radio_stack_bg_list,
    NULL,
	IMAGE_USE_ERASE  | IMAGE_USE_TRANSPARENCY,,
	0,
	0,0
)


////////////////////////////////////////////////////////////////////////////////
// header
////////////////////////////////////////////////////////////////////////////////
PELEMENT_HEADER     left_radio_stack_list   = &left_radio_stack_background.header;


////////////////////////////////////////////////////////////////////////////////
MOUSERECT left_radio_stack_rect[] =
{
	MOUSE_PARENT_BEGIN( 0, 0, 0, 0, HELP_NONE )

		// ident toggles
		MOUSE_PARENT_BEGIN( 3, 3, 11, 8, HELP_NONE )  // nav1
			MOUSE_CHILD_EVENT( 0, 0, 11, 8, CURSOR_HAND, \
					MOUSE_LEFTSINGLE, KEY_RADIO_VOR1_IDENT_TOGGLE )
		MOUSE_PARENT_END

		MOUSE_PARENT_BEGIN( 4, 12, 11, 8, HELP_NONE )  // nav2
			MOUSE_CHILD_EVENT( 0, 0, 11, 8, CURSOR_HAND, \
					MOUSE_LEFTSINGLE, KEY_RADIO_VOR2_IDENT_TOGGLE )
		MOUSE_PARENT_END

		MOUSE_PARENT_BEGIN( 4, 22, 11, 8, HELP_NONE )  // marker
			MOUSE_CHILD_EVENT( 0, 0, 11, 8, CURSOR_HAND, \
					MOUSE_LEFTSINGLE, KEY_MARKER_SOUND_TOGGLE )
		MOUSE_PARENT_END

		// vor1 frequency regulator
		MOUSE_PARENT_BEGIN( 26, 28, 60, 20, HELPID_RADIO_NAV1 )
			MOUSE_CHILD_EVENT( 0, 0, 15, 20, CURSOR_DOWNARROW,
				MOUSE_DOWN_REPEAT /*| MOUSE_LEFTSINGLE*/, KEY_NAV1_RADIO_WHOLE_DEC )
			MOUSE_CHILD_EVENT( 15, 0, 15, 20, CURSOR_UPARROW,
				MOUSE_DOWN_REPEAT /*| MOUSE_LEFTSINGLE*/, KEY_NAV1_RADIO_WHOLE_INC )
			MOUSE_CHILD_EVENT( 30, 0, 15, 20, CURSOR_DOWNARROW,
				MOUSE_DOWN_REPEAT /*| MOUSE_LEFTSINGLE,*/, KEY_NAV1_RADIO_FRACT_DEC )
			MOUSE_CHILD_EVENT( 45, 0, 15, 20, CURSOR_UPARROW,
					MOUSE_DOWN_REPEAT /*| MOUSE_LEFTSINGLE*/, KEY_NAV1_RADIO_FRACT_INC )
		MOUSE_PARENT_END

		// vor2 frequency regulator
		MOUSE_PARENT_BEGIN( 109, 28, 45, 18, HELPID_RADIO_NAV2 )
			MOUSE_CHILD_EVENT( 0, 0, 10, 18, CURSOR_DOWNARROW,
				MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, KEY_NAV2_RADIO_WHOLE_DEC )
			MOUSE_CHILD_EVENT( 11, 0, 10, 18, CURSOR_UPARROW,
				MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, KEY_NAV2_RADIO_WHOLE_INC )
			MOUSE_CHILD_EVENT( 22, 0, 10, 18, CURSOR_DOWNARROW,
				MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, KEY_NAV2_RADIO_FRACT_DEC )
			MOUSE_CHILD_EVENT( 33, 0, 10, 18, CURSOR_UPARROW,
					MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, KEY_NAV2_RADIO_FRACT_INC )
		MOUSE_PARENT_END

		// com1 frequency regulator
		MOUSE_PARENT_BEGIN( 22, 8, 46, 18, HELPID_RADIO_COMM1 )
			MOUSE_CHILD_EVENT( 0, 0, 10, 18, CURSOR_DOWNARROW,
				MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, KEY_COM_RADIO_WHOLE_DEC )
			MOUSE_CHILD_EVENT( 11, 0, 10, 18, CURSOR_UPARROW,
				MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, KEY_COM_RADIO_WHOLE_INC )
			MOUSE_CHILD_EVENT( 22, 0, 10, 18, CURSOR_DOWNARROW,
				MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, KEY_COM_RADIO_FRACT_DEC )
			MOUSE_CHILD_EVENT( 33, 0, 10, 18, CURSOR_UPARROW,
					MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, KEY_COM_RADIO_FRACT_INC )
		MOUSE_PARENT_END

		// com2 frequency regulator
		MOUSE_PARENT_BEGIN( 105, 8, 45, 18, HELPID_RADIO_COMM2 )
			MOUSE_CHILD_EVENT( 0, 0, 10, 18, CURSOR_DOWNARROW,
				MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, KEY_COM2_RADIO_WHOLE_DEC )
			MOUSE_CHILD_EVENT( 11, 0, 10, 18, CURSOR_UPARROW,
				MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, KEY_COM2_RADIO_WHOLE_INC )
			MOUSE_CHILD_EVENT( 22, 0, 10, 18, CURSOR_DOWNARROW,
				MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, KEY_COM2_RADIO_FRACT_DEC )
			MOUSE_CHILD_EVENT( 33, 0, 10, 18, CURSOR_UPARROW,
					MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, KEY_COM2_RADIO_FRACT_INC )
		MOUSE_PARENT_END


	MOUSE_PARENT_END
	{
		MOUSE_RECT_EOL, { 0, 0, 0, 0 }, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL
	}
};


////////////////////////////////////////////////////////////////////////////////
// gauge initialization proc
////////////////////////////////////////////////////////////////////////////////
void FSAPI left_radio_stack_gaugeproc( PGAUGEHDR pgauge, int service_id, UINT32 extra_data )
{
	switch(service_id)
	{
	case PANEL_SERVICE_PRE_INSTALL: /* "install_routine()" */
		break;

	case PANEL_SERVICE_PRE_INITIALIZE:	/* "initialize_routine()" */
		break;

	case PANEL_SERVICE_PRE_UPDATE: /* "update_routine()" */
        lookup_var(&avlights);
		if (avlights.var_value.n!=0)	// if panel lights, brighten all elements
		{
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[0]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[1]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[2]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[3]);
		}
		else
		{
			DARK_IMG(pgauge->elements_list[0]->next_element[0]);
			DARK_IMG(pgauge->elements_list[0]->next_element[1]);
			DARK_IMG(pgauge->elements_list[0]->next_element[2]);
			DARK_IMG(pgauge->elements_list[0]->next_element[3]);
		}
		break;

	case PANEL_SERVICE_PRE_DRAW: /* "draw_routine()" */
		break;

	case PANEL_SERVICE_PRE_KILL: /* "kill_routine()" */
		break;
	}
}



#undef GAUGE_NAME
#undef GAUGEHDR_VAR_NAME
#undef GAUGE_W


/*
 *  UPDATE COMM 1
 */
FLOAT64 FSAPI left_stack_com1_frequency_string_cb(PELEMENT_STRING pelement)
{
	UINT32 nFreq = (UINT32)pelement->source_var[0].var_value.d;
	// do bcd conversion
	wsprintf(pelement->string, "1%d%d.%d%d", (nFreq >> 12) & 0x000f,
		(nFreq >> 8) & 0x000f, (nFreq >> 4) & 0x000f, nFreq & 0x000f);
	return (FLOAT64)nFreq;
}

/*
 *  UPDATE COMM 2
 */
FLOAT64 FSAPI left_stack_com2_frequency_string_cb(PELEMENT_STRING pelement)
{
	UINT32 nFreq = (UINT32)pelement->source_var[0].var_value.d;
	// do bcd conversion
	wsprintf(pelement->string, "1%d%d.%d%d", (nFreq >> 12) & 0x000f,
		(nFreq >> 8) & 0x000f, (nFreq >> 4) & 0x000f, nFreq & 0x000f);
	return (FLOAT64)nFreq;
}

/*
 *  UPDATE NAV 1
 */
FLOAT64 FSAPI left_stack_nav1_frequency_string_cb(PELEMENT_STRING pelement)
{
	UINT32 nFreq = (UINT32)pelement->source_var[0].var_value.d;
	// do bcd conversion
	wsprintf(pelement->string, "1%d%d.%d%d", (nFreq >> 12) & 0x000f,
		(nFreq >> 8) & 0x000f, (nFreq >> 4) & 0x000f, nFreq & 0x000f);
	return (FLOAT64)nFreq;
}

/*
 *  UPDATE NAV 2
 */
FLOAT64 FSAPI left_stack_nav2_frequency_string_cb(PELEMENT_STRING pelement)
{
	UINT32 nFreq = (UINT32)pelement->source_var[0].var_value.d;
	// do bcd conversion
	wsprintf(pelement->string, "1%d%d.%d%d", (nFreq >> 12) & 0x000f,
		(nFreq >> 8) & 0x000f, (nFreq >> 4) & 0x000f, nFreq & 0x000f);
	return (FLOAT64)nFreq;
}

/*
 * nav1 ident update
 */
FLOAT64 FSAPI left_stack_nav1_id_icon_cb(PELEMENT_ICON pelement)
{
	return (0!=pelement->source_var.var_value.n) ? 1 : 0;
}

/*
 * nav2 ident update
 */
FLOAT64 FSAPI left_stack_nav2_id_icon_cb(PELEMENT_ICON pelement)
{
	return (0!=pelement->source_var.var_value.n) ? 1 : 0;
}

/*
 * marker sound update
 */
FLOAT64 FSAPI left_stack_marker_ident_icon_cb(PELEMENT_ICON pelement)
{
	return (0!=pelement->source_var.var_value.n) ? 1 : 0;
}



