/*
 * $Id: lights.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The lights switch gauge $
 *
 * $Log: lights.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char lights_gauge_name[]	= 	GAUGE_NAME;
extern PELEMENT_HEADER      lights_list;
extern MOUSERECT            lights_rect[];


/*
 * forward declarations
 */
PELEMENT_HEADER lights_bg_list[];
FLOAT64 FSAPI lights_engine_starter_icon_cb(PELEMENT_ICON);


GAUGE_HEADER_FS700( GAUGE_W, lights_gauge_name, &lights_list, \
					lights_rect, NULL, 0, 0, 0);



FAILURE_RECORD	lights_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NONE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD	lights_pitot_heat_icon_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NONE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD	lights_strobe_lights_icon_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NONE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD	lights_nav_lights_icon_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NONE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD	lights_landing_lights_icon_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NONE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD	lights_engine_starter_icon_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NONE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};


/*
 * pitot heat
 */
MAKE_ICON
(      
	lights_pitot_heat_icon,
	BMP_LIGHTS_ICON_OFF,
	NULL,
	lights_pitot_heat_icon_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 259, 36 },
	PITOT_HEAT, NULL,
	ICON_SWITCH_TYPE_STEP_TO,
	2,
	0.000000,
	0 
)

/*
 * strobe lights
 */
MAKE_ICON
(      
	lights_strobe_lights_icon,
	BMP_LIGHTS_ICON_OFF,
	NULL,
	lights_strobe_lights_icon_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 212, 36 },
	STROBE_LIGHTS, NULL,
	ICON_SWITCH_TYPE_STEP_TO,
	2,
	0.000000,
	0
)

/*
 * nav lights
 */
MAKE_ICON
(      
	lights_nav_lights_icon,
	BMP_LIGHTS_ICON_OFF,
	NULL,
	lights_nav_lights_icon_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 160, 36 },
	NAV_LIGHTS, NULL,
	ICON_SWITCH_TYPE_STEP_TO,
	2,
	0.000000,
	0
)


/*
 * landing lights
 */
MAKE_ICON
(      
	lights_landing_lights_icon,
	BMP_LIGHTS_ICON_OFF,
	NULL,
	lights_landing_lights_icon_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 110, 36 },
	LANDING_LIGHTS, NULL,
	ICON_SWITCH_TYPE_STEP_TO,
	2,
	0.000000,
	0
)

MAKE_ICON
(      
	lights_engine_starter_icon,
	BMP_ENGINE_STARTER1,
	NULL,
	lights_engine_starter_icon_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 17, 37 },
	ENGINE1_STARTER_SWITCH_POS, lights_engine_starter_icon_cb,
	ICON_SWITCH_TYPE_STEP_TO,
	5,
	0.000000,
	0
)




/*
 * card background image
 */
MAKE_STATIC
(
    lights_bg,
    BMP_LIGHTS_BG,
    &lights_bg_list,
    NULL,
	IMAGE_USE_ERASE | transparent,
	0,
	0,0
)

/*
 * priority lists
 */
PELEMENT_HEADER lights_bg_list[] =
{
	&lights_pitot_heat_icon.header,
	&lights_strobe_lights_icon.header,
	&lights_nav_lights_icon.header,
	&lights_landing_lights_icon.header,
	&lights_engine_starter_icon.header,
	NULL
};


extern PELEMENT_HEADER      lights_list = &lights_bg.header;

MOUSERECT lights_rect[] =
{
    MOUSE_PARENT_BEGIN( 0, 0, 0, 0, HELP_NONE )

		MOUSE_PARENT_BEGIN( 0, 0, 0, 0, HELPID_GAUGE_MAGNETO_SWITCH )
			MOUSE_CHILD_EVENT( 0, 0, 44, 88, CURSOR_DOWNARROW, MOUSE_LEFTSINGLE, KEY_MAGNETO_DECR )
			MOUSE_CHILD_EVENT( 44, 0, 44, 88, CURSOR_UPARROW, MOUSE_LEFTSINGLE, KEY_MAGNETO_INCR )
		MOUSE_PARENT_END
		MOUSE_PARENT_BEGIN( 104, 28, 44, 66, HELPID_GAUGE_LIGHT_SWITCH_LANDING )
			MOUSE_CHILD_EVENT( 0, 0, 44, 66, CURSOR_HAND, MOUSE_LEFTSINGLE, KEY_LANDING_LIGHTS_TOGGLE )
		MOUSE_PARENT_END
		MOUSE_PARENT_BEGIN( 152, 28, 44, 66, HELPID_GAUGE_LIGHT_SWITCH_NAV )
			MOUSE_CHILD_EVENT( 0, 0, 44, 66, CURSOR_HAND, MOUSE_LEFTSINGLE, KEY_TOGGLE_NAV_LIGHTS )
		MOUSE_PARENT_END
		MOUSE_PARENT_BEGIN( 194, 28, 54, 66, HELPID_GAUGE_LIGHT_SWITCH_STROBE )
			MOUSE_CHILD_EVENT( 0, 0, 44, 66, CURSOR_HAND, MOUSE_LEFTSINGLE, KEY_STROBES_TOGGLE )
		MOUSE_PARENT_END
		MOUSE_PARENT_BEGIN( 248, 15, 41, 80, HELPID_GAUGE_PITOT_HEAT_SWITCH )
			MOUSE_CHILD_EVENT( 0, 0, 41, 80, CURSOR_HAND, MOUSE_LEFTSINGLE, KEY_PITOT_HEAT_TOGGLE )
		MOUSE_PARENT_END
    MOUSE_PARENT_END
    { MOUSE_RECT_EOL, { 0, 0, 0, 0 }, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL }
};


#undef		GAUGE_NAME
#undef		GAUGEHDR_VAR_NAME
#undef		GAUGE_W


FLOAT64 FSAPI lights_engine_starter_icon_cb(PELEMENT_ICON pelement)
{
	return pelement->source_var.var_value.n;

}
