/*
 * $Id: logolite.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The logo lights switch gauge $
 *
 * $Log: logolite.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char logo_lights_gauge_name[]	= 	GAUGE_NAME;
extern PELEMENT_HEADER      logo_lights_list;
extern MOUSERECT            logo_lights_rect[];


/*
 * forward declarations
 */
FLOAT64 FSAPI logo_lights_icon_cb(PELEMENT_ICON);
PELEMENT_HEADER logo_lights_bg_list[];
GAUGE_HEADER_FS700( GAUGE_W, logo_lights_gauge_name, &logo_lights_list, \
					logo_lights_rect, NULL, 0, 0, 0);



FAILURE_RECORD	logo_lights_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NONE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};




/*
 * flight director icon
 */
MAKE_ICON
(
	logo_lights_icon,
	BMP_WLS_ICON_ON,
	NULL,
	NULL,
	IMAGE_USE_ERASE | transparent,
	0,
	0, 0,
	LOGO_LIGHTS,
	logo_lights_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)



/*
 * card background image
 */
MAKE_STATIC
(
    logo_lights_bg,
    BMP_WLS_BG,
    &logo_lights_bg_list,
    NULL,
	IMAGE_USE_ERASE | transparent,
	0,
	0,0
)

/*
 * priority lists
 */
PELEMENT_HEADER logo_lights_bg_list[] =
{
	&logo_lights_icon.header,
	NULL
};


extern PELEMENT_HEADER      logo_lights_list = &logo_lights_bg.header;

MOUSERECT logo_lights_rect[] =
{
    MOUSE_PARENT_BEGIN( 0, 0, 0, 0, HELPID_GAUGE_LIGHT_SWITCH_LOGO )
		MOUSE_CHILD_EVENT( 0, 0, 33, 40, CURSOR_HAND, \
					MOUSE_LEFTSINGLE, KEY_TOGGLE_LOGO_LIGHTS )
    MOUSE_PARENT_END
    { MOUSE_RECT_EOL, { 0, 0, 0, 0 }, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL }
};


#undef		GAUGE_NAME
#undef		GAUGEHDR_VAR_NAME
#undef		GAUGE_W

FLOAT64 FSAPI logo_lights_icon_cb(PELEMENT_ICON pelement)
{ 
	return pelement->source_var.var_value.n==1 ? 1 : 0;
}