/*
 * $Id: gearlite.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The new hsi gauge $
 *
 * $Log$
 */

/*
 *  Set up gauge header
 */
char ehsi_gauge_name[]	= 	GAUGE_NAME;
extern PELEMENT_HEADER      ehsi_list;
extern MOUSERECT            ehsi_rect[];


/*
 * forward declarations
 */
PELEMENT_HEADER ehsi_arc_tf_indicator_list[];
PELEMENT_HEADER ehsi_arc_plane_list[];
PELEMENT_HEADER ehsi_arc_heading_bug_list[];
PELEMENT_HEADER ehsi_arc_vor2_needle_list[];
PELEMENT_HEADER ehsi_arc_cdi_list[];
PELEMENT_HEADER ehsi_arc_vor1_needle_list[];
PELEMENT_HEADER ehsi_arc_card_bg_list[];
PELEMENT_HEADER ehsi_arc_sprite_list[];
PELEMENT_HEADER ehsi_tf_indicator_list[];
PELEMENT_HEADER ehsi_plane_list[];
PELEMENT_HEADER ehsi_heading_bug_list[];
PELEMENT_HEADER ehsi_cdi_list[];
PELEMENT_HEADER ehsi_rose_sprite_list[];
PELEMENT_HEADER ehsi_rose_card_bg_list[];
PELEMENT_HEADER ehsi_bg_list[];
PELEMENT_HEADER ehsi_vor1_needle_list[];
PELEMENT_HEADER ehsi_vor2_needle_list[];

FLOAT64 FSAPI ehsi_arc_sprite_cb(PELEMENT_SPRITE);
FLOAT64 FSAPI ehsi_rose_sprite_cb(PELEMENT_SPRITE);
FLOAT64 FSAPI ehsi_vor1_needle_cb(PELEMENT_NEEDLE);
FLOAT64 FSAPI ehsi_heading_bug_cb(PELEMENT_NEEDLE);
FLOAT64 FSAPI ehsi_vor2_needle_cb(PELEMENT_NEEDLE);
FLOAT64 FSAPI ehsi_cdi_z_cb(PELEMENT_SPRITE);
FLOAT64 FSAPI ehsi_cdi_x_cb(PELEMENT_SPRITE);
FLOAT64 FSAPI ehsi_arc_vor1_needle_cb(PELEMENT_SPRITE);
FLOAT64 FSAPI ehsi_arc_vor2_needle_cb(PELEMENT_SPRITE);
FLOAT64 FSAPI ehsi_arc_heading_bug_cb(PELEMENT_SPRITE);
FLOAT64 FSAPI ehsi_magnetic_heading_string_cb(PELEMENT_STRING);
FLOAT64 FSAPI ehsi_vor1_id_string_cb(PELEMENT_STRING);
FLOAT64 FSAPI ehsi_vor1_freq_string_cb(PELEMENT_STRING);
FLOAT64 FSAPI ehsi_vor2_id_string_cb(PELEMENT_STRING);
FLOAT64 FSAPI ehsi_vor2_freq_string_cb(PELEMENT_STRING);


void FSAPI ehsi_gaugeproc(PGAUGEHDR, int, UINT32);
                  
GAUGE_HEADER_FS700( GAUGE_W, ehsi_gauge_name, &ehsi_list, \
					ehsi_rect, ehsi_gaugeproc, 0, 0, 0);


/*
 * failure lists
 */

FAILURE_RECORD ehsi_rose_card_bg_fail[] =
{
   {FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
   {FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
   {FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD  ehsi_rose_sprite_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_GYRO_HEADING, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD  ehsi_arc_vor2_needle_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_NAVIGATION_VOR2, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD  ehsi_arc_vor1_needle_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_NAVIGATION_VOR1, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD  ehsi_vor1_needle_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_NAVIGATION_VOR1, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD  ehsi_magnetic_heading_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_MAGNETIC_COMPASS, FAIL_ACTION_FREEZE},
	{FAIL_GAUGE_GYRO_HEADING, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD  ehsi_cdi_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_NAVIGATION_VOR1, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD  ehsi_heading_bug_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD  ehsi_arc_heading_bug_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD  ehsi_vor2_needle_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_NAVIGATION_VOR2, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD  ehsi_plane_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD  ehsi_arc_plane_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD  ehsi_arc_tf_indicator_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD  ehsi_tf_indicator_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD ehsi_arc_card_bg_fail[] =
{
   {FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
   {FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
   {FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD  ehsi_arc_sprite_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_GYRO_HEADING, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD  ehsi_arc_cdi_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_NAVIGATION_VOR1, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD  ehsi_vor1_id_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD  ehsi_vor1_freq_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD  ehsi_vor2_id_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD  ehsi_vor2_freq_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

/*
 * vor 2 frequency string
 */
MAKE_STRING
(
	ehsi_vor2_freq_string,
	NULL,
	ehsi_vor2_freq_string_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	{170, 40},
	{64, 16},
	6,

	NAV2_FREQUENCY,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_LIME,
	RGB(4,4,4),
	CL_WHITE,
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_LEFT,
	NULL,
	ehsi_vor2_freq_string_cb
)

/*
 * vor 2 id string
 */
MAKE_STRING
(
	ehsi_vor2_id_string,
	NULL,
	ehsi_vor2_id_string_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	{170, 22},
	{45, 16},
	4,

	VOR2_IDENTITY,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_LIME,
	RGB(4,4,4),
	CL_WHITE,
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_RIGHT,
	NULL,
	ehsi_vor2_id_string_cb
)


/*
 * vor 1 frequency string
 */
MAKE_STRING
(
	ehsi_vor1_freq_string,
	NULL,
	ehsi_vor1_freq_string_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	{8, 40},
	{64, 16},
	6,

	NAV1_FREQUENCY,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_WHITE,
	RGB(4,4,4),
	CL_WHITE,
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_LEFT,
	NULL,
	ehsi_vor1_freq_string_cb
)

/*
 * vor 1 id string
 */
MAKE_STRING
(
	ehsi_vor1_id_string,
	NULL,
	ehsi_vor1_id_string_fail,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY,
	0,
	{8, 22},
	{45, 16},
	4,

	VOR1_IDENTITY,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_WHITE,
	RGB(4,4,4),
	CL_WHITE,
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_LEFT,
	NULL,
	ehsi_vor1_id_string_cb
)


/*
 * plane magnetic heading string
 */
MAKE_STRING
(
	ehsi_magnetic_heading_string,
	NULL,
	ehsi_magnetic_heading_string_fail,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY,
	0,
	{103, 22},
	{34, 16},
	3,

	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_WHITE,
	RGB(4,4,4),
	CL_WHITE,
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_LEFT,
	NULL,
	ehsi_magnetic_heading_string_cb
)


/*
 * t/f indicator
 */
MAKE_STATIC
(
    ehsi_arc_tf_indicator,
    BMP_NEW_HSI_ARC_TF_INDICATOR,
    &ehsi_arc_tf_indicator_list,
    ehsi_arc_tf_indicator_fail,
	transparent | IMAGE_USE_ERASE,
	0,
	111, 179
)


/*
 * plane icon
 */
MAKE_STATIC
(
    ehsi_arc_plane,
    BMP_NEW_HSI_ARC_PLANE,
    &ehsi_arc_plane_list,
    ehsi_arc_plane_fail,
	transparent | IMAGE_USE_ERASE,
	0,
	101,203
)
/*
 * hsi arc vor 1 needle
 */
MAKE_SPRITE
(
	ehsi_arc_heading_bug,
	BMP_NEW_HSI_ARC_HEADING_BUG,
	&ehsi_arc_heading_bug_list,
	ehsi_arc_heading_bug_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
    0, 0,
	118,219,
	1, 1,

	MODULE_VAR_NONE, NULL, 0,
	MODULE_VAR_NONE, NULL, 0,
	MODULE_VAR_NONE, ehsi_arc_heading_bug_cb, -1
)
/*
 * hsi arc vor 1 needle
 */
MAKE_SPRITE
(
	ehsi_arc_vor2_needle,
	BMP_NEW_HSI_ARC_VOR2_NEEDLE,
	&ehsi_arc_vor2_needle_list,
	ehsi_arc_vor2_needle_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
    0, 0,
	118,219,
	1, 1,

	MODULE_VAR_NONE, NULL, 0,
	MODULE_VAR_NONE, NULL, 0,
	MODULE_VAR_NONE, ehsi_arc_vor2_needle_cb, -1
)

/*
 * hsi arc cdi
 */
MAKE_SPRITE
(
	ehsi_arc_cdi,
	BMP_NEW_HSI_ARC_CDI,
	&ehsi_arc_cdi_list,
	ehsi_arc_cdi_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
    0,0,
	118, 219,
	1, 1,

	HSI_VERTICAL_NEEDLE, ehsi_cdi_x_cb, -2,
	MODULE_VAR_NONE, NULL, 0,
	MODULE_VAR_NONE, ehsi_cdi_z_cb, -1
)


/*
 * hsi arc vor 1 needle
 */
MAKE_SPRITE
(
	ehsi_arc_vor1_needle,
	BMP_NEW_HSI_ARC_VOR1_NEEDLE,
	&ehsi_arc_vor1_needle_list,
	ehsi_arc_vor1_needle_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
    0, 0,
	118,219,
	1, 1,

	MODULE_VAR_NONE, NULL, 0,
	MODULE_VAR_NONE, NULL, 0,
	MODULE_VAR_NONE, ehsi_arc_vor1_needle_cb, -1
)
/*
 * hsi gyroscope (arc)
 */
MAKE_SPRITE
(
	ehsi_arc_sprite,
	BMP_NEW_HSI_ARC_SPRITE,
	&ehsi_arc_sprite_list,
	ehsi_arc_sprite_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
    0, 0,
	118,219,
	1, 1,

	MODULE_VAR_NONE, NULL, 0,
	MODULE_VAR_NONE, NULL, 0,
	MODULE_VAR_NONE, ehsi_arc_sprite_cb, 1
)


/*
 * arc card background
 */
MAKE_STATIC
(
    ehsi_arc_card_bg,
    BMP_NEW_HSI_ARC_CARD,
    &ehsi_arc_card_bg_list,
    ehsi_arc_card_bg_fail,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY,
	0,
	0,0
)


/*
 * t/f indicator
 */
MAKE_STATIC
(
    ehsi_tf_indicator,
    BMP_NEW_HSI_TF_INDICATOR,
    &ehsi_tf_indicator_list,
    ehsi_tf_indicator_fail,
	transparent | IMAGE_USE_ERASE,
	0,
	77, 124
)

/*
 * plane icon
 */
MAKE_STATIC
(
    ehsi_plane,
    BMP_NEW_HSI_PLANE,
    &ehsi_plane_list,
    ehsi_plane_fail,
	transparent | IMAGE_USE_ERASE,
	0,
	120-19,140-16
)



/*
 * ehsi vor 2 needle
 */
MAKE_NEEDLE
(
	ehsi_vor2_needle,
	BMP_NEW_HSI_VOR2_NEEDLE,
	&ehsi_vor2_needle_list,
	ehsi_vor2_needle_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 120, 140 },
	{ 13, 115 },
	
	MODULE_VAR_NONE,
	ehsi_vor2_needle_cb,
	NULL,
	0
)


/*
 * ehsi heading bug
 */
MAKE_NEEDLE
(
	ehsi_heading_bug,
	BMP_NEW_HSI_HEADING_BUG,
	ehsi_heading_bug_list,
	&ehsi_heading_bug_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 120, 140 },
	{ 8, 98 },
	
	MODULE_VAR_NONE,
	ehsi_heading_bug_cb,
	NULL,
	0
)


/*
 * hsi cdi
 */
MAKE_SPRITE
(
	ehsi_cdi,
	BMP_NEW_HSI_CDI,
	&ehsi_cdi_list,
	ehsi_cdi_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
    118-71, 118-60,
	118, 138,
	1, 1,

	HSI_VERTICAL_NEEDLE, ehsi_cdi_x_cb, -1,
	MODULE_VAR_NONE, NULL, 0,
	MODULE_VAR_NONE, ehsi_cdi_z_cb, -1
)

/*
 * hsi vor 1 needle
 */
MAKE_NEEDLE
(
	ehsi_vor1_needle,
	BMP_NEW_HSI_VOR1_NEEDLE,
	&ehsi_vor1_needle_list,
	ehsi_vor1_needle_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 118, 138 },
	{ 55, 80 },
	
	MODULE_VAR_NONE,
	ehsi_vor1_needle_cb,
	NULL,
	0
)


/*
 * hsi gyroscope (rose)
 */
MAKE_SPRITE
(
	ehsi_rose_sprite,
	BMP_NEW_HSI_ROSE_SPRITE,
	&ehsi_rose_sprite_list,
	ehsi_rose_sprite_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
    11, 47,
	118,138,
	1, 1,

	MODULE_VAR_NONE, NULL, 0,
	MODULE_VAR_NONE, NULL, 0,
	MODULE_VAR_NONE, ehsi_rose_sprite_cb, 1
)

/*
 * rose card background
 */
MAKE_STATIC
(
    ehsi_rose_card_bg,
    BMP_NEW_HSI_CARD_ROSE,
    &ehsi_rose_card_bg_list,
    ehsi_rose_card_bg_fail,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY,
	0,
	0,0
)

/*
 * card background image
 */
MAKE_STATIC
(
    ehsi_bg,
    BMP_NEW_HSI_BG,
    &ehsi_bg_list,
    NULL,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY,
	0,
	0,0
)

/*
 * priority lists
 */

PELEMENT_HEADER ehsi_arc_tf_indicator_list[]=
{
	&ehsi_magnetic_heading_string.header,
	&ehsi_vor1_id_string.header,
	&ehsi_vor1_freq_string.header,
	&ehsi_vor2_id_string.header,
	&ehsi_vor2_freq_string.header,
	NULL                                      
};

PELEMENT_HEADER ehsi_arc_plane_list[] =
{
	&ehsi_arc_tf_indicator.header,
	NULL
};

 
PELEMENT_HEADER ehsi_arc_heading_bug_list[] =  // ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0]
{
	&ehsi_arc_plane.header,
	NULL
};


PELEMENT_HEADER ehsi_arc_vor2_needle_list[] =  // ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0]
{
    &ehsi_arc_heading_bug.header,
	NULL
};


PELEMENT_HEADER ehsi_arc_cdi_list[] =    // ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0]
{
	&ehsi_arc_vor2_needle.header,
	NULL
};

PELEMENT_HEADER ehsi_arc_vor1_needle_list[] = // ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0]
{
	&ehsi_arc_cdi.header,
	NULL
};
PELEMENT_HEADER ehsi_arc_sprite_list[] =  // ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0]
{
	&ehsi_arc_vor1_needle.header,
	NULL
};
PELEMENT_HEADER ehsi_arc_card_bg_list[] =
{
	&ehsi_arc_sprite.header, // ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0]
	NULL
};
PELEMENT_HEADER ehsi_tf_indicator_list[] =
{
	&ehsi_arc_card_bg.header,
	NULL                       // ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0]
};
PELEMENT_HEADER ehsi_plane_list[] =
{
	&ehsi_tf_indicator.header, // ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0]
	NULL
};

 
PELEMENT_HEADER ehsi_heading_bug_list[] =
{
	&ehsi_plane.header, // ne[0] ne[0] ne[0] ne[0] ne[0] ne[0] ne[0]
	NULL
};

PELEMENT_HEADER ehsi_cdi_list[] =
{
	&ehsi_heading_bug.header, // ne[0] ne[0] ne[0] ne[0] ne[0] ne[0]
	NULL
};

PELEMENT_HEADER ehsi_vor1_needle_list[] =
{
	&ehsi_cdi.header, // ne[0] ne[0] ne[0] ne[0] ne[0]
	NULL
};

PELEMENT_HEADER ehsi_vor2_needle_list[] =
{
	&ehsi_vor1_needle.header, // ne[0] ne[0] ne[0] ne[0]
	NULL
};

 

PELEMENT_HEADER ehsi_rose_sprite_list[] =
{
	&ehsi_vor2_needle.header,	// ne[0] ne[0] ne[0]
	NULL
};



PELEMENT_HEADER ehsi_rose_card_bg_list[] =
{
	&ehsi_rose_sprite.header,	// ne[0] ne[0]
	NULL
};



PELEMENT_HEADER ehsi_bg_list[] =
{
	&ehsi_rose_card_bg.header,	// ne[0] 
	NULL
};


extern PELEMENT_HEADER      ehsi_list = &ehsi_bg.header;

MOUSE_BEGIN( ehsi_rect, HELP_NONE, 0, 0 )
	
MOUSE_END


#undef		GAUGE_NAME
#undef		GAUGEHDR_VAR_NAME
#undef		GAUGE_W


/*
 * gauge initialization proc
 */
void FSAPI ehsi_gaugeproc( PGAUGEHDR pgauge, int service_id, UINT32 extra_data )
{
	FLOAT64 obi;
	switch(service_id)
	{
	case PANEL_SERVICE_PRE_INSTALL:		// install_routine()
		break;

	case PANEL_SERVICE_PRE_INITIALIZE:	// initialize_routine()
		break;

	case PANEL_SERVICE_PRE_UPDATE:		// update_routine()
		lookup_var(&plane_heading_degrees_gyro); // update gyro degrees
		fDegreesGyro = plane_heading_degrees_gyro.var_value.n;
		lookup_var(&vor1_obi);
		fVor1Needle = vor1_obi.var_value.n - fDegreesGyro;
		lookup_var(&vor2_needle);
		obi = (FLOAT64)vor2_needle.var_value.n*360/(FLOAT64)0xffff;
		fVor2Radial=((obi-plane_heading_degrees_gyro.var_value.n)+180);
		fHsiHdgBugDelta=fApHeadingLockDir - fMagneticHeading;
		
		if (bPanelLightOn)											// if panel lights, brighten all string elements
		{
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]); 	
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[1]);	
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[2]);	
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[3]);	
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[4]);	
 		}
		else
		{
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[1]);	
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[2]);	
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[3]);	
			DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[4]);	
		}								
		if (bHsiModeArc)												// display in arc/mode, switch off rose elements
		{
			HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]);			
			HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]);	
			HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]);	
			HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
			HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
			HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
			HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
			HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	

			SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
			SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
			SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
			// SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]); // cdi	
			SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
			SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]); // vor 2 needle	
			SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]); // heading bug
			SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]); // vor 2 needle	
		//	SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]); // vor 2 needle	
			if (bPanelLightOn)											// if panel lights, brighten all elements
			{
				BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
				BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
				BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
				BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
				BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
            	BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]); // vor 2 needle	
 				BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]); // plane	
				BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]); // tf indicator	

			}
			else
			{
				DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
				DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
				DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
				DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
				DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
            	DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]); // vor 2 needle	
 				DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]); // vor 2 needle	
				DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]); // vor 2 needle	
			}
			
			lookup_var(&deviation_active);
			if ((int)deviation_active.var_value.n!=0) // if we have deviation, show cdi
			{
				SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);
			}
			else									// otherwise hide
			{
				HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);
			}
			lookup_var(&to_from_flag);
			if (to_from_flag.var_value.n!=0)
				SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);
			else
				HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);



		}
		else
		{
			SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]);			
			SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]);	
			SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]);	
			SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
			SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
			SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
			SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
			SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
			HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
			HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
			HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
			HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
  			HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]); // vor 2 needle	
  			HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]); // heading bug
  			HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]); // vor 2 needle	
			HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]); // vor 2 needle	
			
			lookup_var(&to_from_flag);
			if (to_from_flag.var_value.n!=0)
				SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	// hsi t/f
			else
				HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	// hsi t/f

			
			lookup_var(&deviation_active);
			if ((int)deviation_active.var_value.n!=0) // if we have deviation, show cdi
			{
				SHOW_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);
			}
			else									// otherwise hide
			{
				HIDE_IMAGE(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);
			}


			if (bPanelLightOn)											// if panel lights, brighten all elements
			{
				BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]);		
				BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]);
				BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]);	
				BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
				BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
				BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);
				BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);
				BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	

			}
			else														// otherwise, darken
			{
				DARK_IMG(pgauge->elements_list[0]->N_E[0]);				
				DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]);	
				DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]);	
				DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);
				DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
				DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
				DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	
				DARK_IMG(pgauge->elements_list[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]->N_E[0]);	

			}
		}
		break;

	case PANEL_SERVICE_PRE_DRAW:		// draw_routine()
		break;

	case PANEL_SERVICE_PRE_KILL:		// kill_routine()
		break;
	}
}


/*
 * update rose sprite
 */
FLOAT64 FSAPI ehsi_rose_sprite_cb(PELEMENT_SPRITE pelement)
{
	return fDegreesGyro;
}

/*
 * update vor 1 needle
 */
FLOAT64 FSAPI ehsi_vor1_needle_cb(PELEMENT_NEEDLE pelement)
{
	return fVor1Needle;
}

/*
 * update heading bug needle
 */
FLOAT64 FSAPI ehsi_heading_bug_cb(PELEMENT_NEEDLE pelement)
{
	return fHsiHdgBugDelta;
}

/*
 * update vor2 needle
 */
FLOAT64 FSAPI ehsi_vor2_needle_cb(PELEMENT_NEEDLE pelement)
{
	return fVor2Radial;
}


/*
 * update cdi on Z-axis
 */
FLOAT64 FSAPI ehsi_cdi_z_cb(PELEMENT_SPRITE pelement)
{
	return fVor1Needle;
}

/*
 * update cdi on X-axis
 */
FLOAT64 FSAPI ehsi_cdi_x_cb(PELEMENT_SPRITE pelement)
{
	return pelement->source_var_x.var_value.n*48;
}

/*
 * edit arc sprite
 */
FLOAT64 FSAPI ehsi_arc_sprite_cb(PELEMENT_SPRITE pelement)
{
	return fDegreesGyro;
}

/*
 * update vor 1 needle in arc mode
 */
FLOAT64 FSAPI ehsi_arc_vor1_needle_cb(PELEMENT_SPRITE pelement)
{
	return fVor1Needle;
}

/*
 * update vor2 needle in arc mode
 */
FLOAT64 FSAPI ehsi_arc_vor2_needle_cb(PELEMENT_SPRITE pelement)
{
	return fVor2Radial;
}

/*
 * update heading bug in arc mode
 */
FLOAT64 FSAPI ehsi_arc_heading_bug_cb(PELEMENT_SPRITE pelement)
{
	return fHsiHdgBugDelta;
}

/*
 * update magnetic heading string
 */
FLOAT64 FSAPI ehsi_magnetic_heading_string_cb(PELEMENT_STRING pelement)
{
	wsprintf(pelement->string,"%0.3d", (int)fMagneticHeading);
	return fMagneticHeading;

}

/*
 * update vor 1 id string
 */
FLOAT64 FSAPI ehsi_vor1_id_string_cb(PELEMENT_STRING pelement)
{
	char *str = (char *)pelement->source_var[0].var_value.p;
	lookup_var(&gps_drives_nav1);
	if (gps_drives_nav1.var_value.n!=0)
		lstrcpy(pelement->string,"GPS");
	else
		lstrcpy(pelement->string,str);
	return 0;
}

/*
 * update vor 1 frequency string
 */
FLOAT64 FSAPI ehsi_vor1_freq_string_cb(PELEMENT_STRING pelement)
{
	UINT32 nFreq = (UINT32)pelement->source_var[0].var_value.d;

	// do bcd conversion
	wsprintf(pelement->string, "1%d%d.%d%d", (nFreq >> 12) & 0x000f,
		(nFreq >> 8) & 0x000f, (nFreq >> 4) & 0x000f, nFreq & 0x000f);
	return (FLOAT64)nFreq;

}

/*
 * update vor 2 id string
 */
FLOAT64 FSAPI ehsi_vor2_id_string_cb(PELEMENT_STRING pelement)
{
	char *str = (char *)pelement->source_var[0].var_value.p;
	if (*str)
		lstrcpy(pelement->string,str);
	else
		lstrcpy(pelement->string,"----");
	return 0;
}

/*
 * update vor 2 frequency string
 */
FLOAT64 FSAPI ehsi_vor2_freq_string_cb(PELEMENT_STRING pelement)
{
	UINT32 nFreq = (UINT32)pelement->source_var[0].var_value.d;

	// do bcd conversion
	wsprintf(pelement->string, "1%d%d.%d%d", (nFreq >> 12) & 0x000f,
		(nFreq >> 8) & 0x000f, (nFreq >> 4) & 0x000f, nFreq & 0x000f);
	return (FLOAT64)nFreq;

}

