/*
 * $Id: oil.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The oil gauge $
 *
 * $Log: oil.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char oil_gauge_name[]	= 	GAUGE_NAME;
extern PELEMENT_HEADER      oil_list;
extern MOUSERECT            oil_rect[];

/*
 * forward declarations
 */
void FSAPI oil_gaugeproc(PGAUGEHDR, int, UINT32);

PELEMENT_HEADER oil_bg_list[];

FLOAT64 FSAPI engine2_oil_qty_string_cb(PELEMENT_STRING);
FLOAT64 FSAPI engine1_oil_qty_string_cb(PELEMENT_STRING);
FLOAT64 FSAPI engine2_oil_temp_string_cb(PELEMENT_STRING);
FLOAT64 FSAPI engine1_oil_temp_string_cb(PELEMENT_STRING);
FLOAT64 FSAPI engine2_oil_press_string_cb(PELEMENT_STRING);
FLOAT64 FSAPI engine1_oil_press_string_cb(PELEMENT_STRING);
FLOAT64 FSAPI engine1_oil_press_slider_cb(PELEMENT_SLIDER);
FLOAT64 FSAPI engine2_oil_press_slider_cb(PELEMENT_SLIDER);


GAUGE_HEADER_FS700( GAUGE_W, oil_gauge_name, &oil_list, \
					oil_rect, oil_gaugeproc, 0, 0, 0);


/*
 * failure lists
 */
FAILURE_RECORD engine2_oil_qty_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD engine1_oil_qty_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD engine2_oil_temp_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD engine1_oil_temp_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD engine2_oil_press_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD engine1_oil_press_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD engine2_oil_qty_slider_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD engine1_oil_qty_slider_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD engine2_oil_temp_slider_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD engine1_oil_temp_slider_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD engine2_oil_press_slider_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD engine1_oil_press_slider_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

/*
 * engine 2 oil quantity slider
 */
MAKE_SLIDER
(    
	engine2_oil_qty_slider,
	BMP_OIL_2_SLIDER,
	NULL,
    engine2_oil_qty_slider_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 47, 175 },
	MODULE_VAR_NONE, NULL, 0.000000,
	ENGINE2_OIL_QUANTITY, NULL, -0.002663 
)

/*
 * engine 1 oil quantity slider
 */
MAKE_SLIDER
(    
	engine1_oil_qty_slider,
	BMP_OIL_1_SLIDER,
	NULL,
    engine1_oil_qty_slider_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 36, 175 },
	MODULE_VAR_NONE, NULL, 0.000000,
	ENGINE1_OIL_QUANTITY, NULL, -0.002663 
)

/*
 * engine 2 oil temp slider
 */
MAKE_SLIDER
(    
	engine2_oil_temp_slider,
	BMP_OIL_2_SLIDER,
	NULL,
    engine2_oil_temp_slider_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 47, 113 },
	MODULE_VAR_NONE, NULL, 0.000000,
	ENGINE2_OIL_TEMPERATURE, NULL, -0.002051 
)

/*
 * engine 1 oil temp slider
 */
MAKE_SLIDER
(    
	engine1_oil_temp_slider,
	BMP_OIL_1_SLIDER,
	NULL,
    engine1_oil_temp_slider_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 36, 113 },
	MODULE_VAR_NONE, NULL, 0.000000,
	ENGINE1_OIL_TEMPERATURE, NULL, -0.002051 
)

/*
 * engine 2 oil pressure slider
 */
MAKE_SLIDER
(    
	engine2_oil_press_slider,
	BMP_OIL_2_SLIDER,
	NULL,
    engine2_oil_press_slider_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 47, 54 },
	MODULE_VAR_NONE, NULL, 0.000000,
	ENGINE2_OIL_PRESSURE, engine2_oil_press_slider_cb, -0.2699
)

/*
 * engine 1 oil pressure slider
 */
MAKE_SLIDER
(    
	engine1_oil_press_slider,
	BMP_OIL_1_SLIDER,
	NULL,
    engine1_oil_press_slider_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 36, 54 },
	MODULE_VAR_NONE, NULL, 0.000000,
	ENGINE1_OIL_PRESSURE, engine1_oil_press_slider_cb, -0.2699
)


/*
 * engine 2 oil quantity string
 */
MAKE_STRING
(
	engine2_oil_qty_string,
	NULL,
	engine2_oil_qty_string_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	{56, 149},
	{27, 15},
	3,

	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_WHITE,
	RGB(4,4,4),
	CL_WHITE,
	FONT_ARIAL,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_CENTER,
	NULL,
	engine2_oil_qty_string_cb
)

/*
 * engine 1 oil quantity string
 */
MAKE_STRING
(
	engine1_oil_qty_string,
	NULL,
	engine1_oil_qty_string_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	{8, 149},
	{27, 15},
	3,

	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_WHITE,
	RGB(4,4,4),
	CL_WHITE,
	FONT_ARIAL,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_CENTER,
	NULL,
	engine1_oil_qty_string_cb
)

/*
 * engine 2 oil temp string
 */
MAKE_STRING
(
	engine2_oil_temp_string,
	NULL,
	engine2_oil_temp_string_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	{56, 93},
	{27, 15},
	3,

	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_WHITE,
	RGB(4,4,4),
	CL_WHITE,
	FONT_ARIAL,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_CENTER,
	NULL,
	engine2_oil_temp_string_cb
)

/*
 * engine 1 oil temp string
 */
MAKE_STRING
(
	engine1_oil_temp_string,
	NULL,
	engine1_oil_temp_string_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	{8, 93},
	{27, 15},
	3,

	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_WHITE,
	RGB(4,4,4),
	CL_WHITE,
	FONT_ARIAL,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_CENTER,
	NULL,
	engine1_oil_temp_string_cb
)

/*
 * engine 2 oil pressure string
 */
MAKE_STRING
(
	engine2_oil_press_string,
	NULL,
	engine2_oil_press_string_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	{56, 27},
	{27, 15},
	3,

	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_WHITE,
	RGB(4,4,4),
	CL_WHITE,
	FONT_ARIAL,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_CENTER,
	NULL,
	engine2_oil_press_string_cb
)

/*
 * engine 1 oil pressure string
 */
MAKE_STRING
(
	engine1_oil_press_string,
	NULL,
	engine1_oil_press_string_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	{8, 27},
	{27, 15},
	3,

	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_WHITE,
	RGB(4,4,4),
	CL_WHITE,
	FONT_ARIAL,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_CENTER,
	NULL,
	engine1_oil_press_string_cb
)


/*
 * card background image
 */
MAKE_STATIC
(
    oil_bg,
    BMP_OIL_BG,
    &oil_bg_list,
    NULL,
	IMAGE_USE_ERASE | transparent,
	0,
	0,0
)

/*
 * priority lists
 */
PELEMENT_HEADER oil_bg_list[] =
{
	&engine2_oil_qty_string.header,
	&engine1_oil_qty_string.header,
	&engine2_oil_temp_string.header,
	&engine1_oil_temp_string.header,
	&engine2_oil_press_string.header,
	&engine1_oil_press_string.header,
	&engine2_oil_qty_slider.header,
	&engine1_oil_qty_slider.header,
	&engine2_oil_temp_slider.header,
	&engine1_oil_temp_slider.header,
	&engine2_oil_press_slider.header,
	&engine1_oil_press_slider.header,
	NULL
};


extern PELEMENT_HEADER      oil_list = &oil_bg.header;


/*
 * mouse tooltip stuff
 */

static FLOAT64 FSAPI OilToolTipGetEngine1Temperature(FLOAT64 number, ID id,
	PCSTRINGZ string, MODULE_VAR *source_var, PGAUGEHDR gauge)
{
	return CELSIUSTOFAHRENHEIT(fEngine1OilTemp);
}

static FLOAT64 FSAPI OilToolTipGetEngine2Temperature(FLOAT64 number, ID id,
	PCSTRINGZ string, MODULE_VAR *source_var, PGAUGEHDR gauge)
{
	return CELSIUSTOFAHRENHEIT(fEngine2OilTemp);
}

static FLOAT64 FSAPI OilToolTipGetEngine1Pressure(FLOAT64 number, ID id,
	PCSTRINGZ string, MODULE_VAR *source_var, PGAUGEHDR gauge)
{

	/*
	 * convert PSI to Kilograms-Force/SquareCm
	 */
	return PASCALTOKGFSQCM(PSITOPASCAL(fEngine1OilPress));
}

static FLOAT64 FSAPI OilToolTipGetEngine2Pressure(FLOAT64 number, ID id,
	PCSTRINGZ string, MODULE_VAR *source_var, PGAUGEHDR gauge)
{
	/*
	 * convert PSI to Kilograms-Force/SquareCm
	 */
	return PASCALTOKGFSQCM(PSITOPASCAL(fEngine2OilPress));
}



MOUSE_TOOLTIP_ARGS (OilToolTipEngine1Temperature)
	MOUSE_TOOLTIP_ARG (MODULE_VAR_NONE, 0, NULL, NULL, NULL, OilToolTipGetEngine1Temperature, NULL, NULL)
MOUSE_TOOLTIP_ARGS_END

MOUSE_TOOLTIP_ARGS (OilToolTipEngine2Temperature)
	MOUSE_TOOLTIP_ARG (MODULE_VAR_NONE, 0, NULL, NULL, NULL, OilToolTipGetEngine2Temperature, NULL, NULL)
MOUSE_TOOLTIP_ARGS_END

MOUSE_TOOLTIP_ARGS (OilToolTipEngine1Pressure)
	MOUSE_TOOLTIP_ARG (MODULE_VAR_NONE, 0, NULL, NULL, NULL, OilToolTipGetEngine1Pressure, NULL, NULL)
MOUSE_TOOLTIP_ARGS_END

MOUSE_TOOLTIP_ARGS (OilToolTipEngine2Pressure)
	MOUSE_TOOLTIP_ARG (MODULE_VAR_NONE, 0, NULL, NULL, NULL, OilToolTipGetEngine2Pressure, NULL, NULL)
MOUSE_TOOLTIP_ARGS_END




//

MOUSERECT oil_rect[] =
{
    MOUSE_PARENT_BEGIN( 0, 0, 0, 0, HELP_NONE )

    /*MOUSE_PARENT_BEGIN( 5, 5, 83, 58, HELPID_B737_OIL_PRESSURE )
    MOUSE_PARENT_END
    MOUSE_PARENT_BEGIN( 5, 61, 83, 118, HELPID_B737_OIL_TEMP )
    MOUSE_PARENT_END
    MOUSE_PARENT_BEGIN( 5, 122, 83, 179, HELPID_B737_OIL_QUANT )
    MOUSE_PARENT_END*/

	/*
	 * oil pressure
	 */
    MOUSE_PARENT_BEGIN( 5, 5, 42, 55, HELP_NONE )
		MOUSE_TOOLTIP_TEXT_ID(TOOLTIPTEXT_ENG1_OIL_PRESSURE_KGFSQCM, OilToolTipEngine1Temperature)
    MOUSE_PARENT_END

    MOUSE_PARENT_BEGIN( 47, 5, 42, 55, HELP_NONE )
		MOUSE_TOOLTIP_TEXT_ID(TOOLTIPTEXT_ENG2_OIL_PRESSURE_KGFSQCM, OilToolTipEngine2Temperature)
    MOUSE_PARENT_END


	/*
	 * oil temperature
	 */
    MOUSE_PARENT_BEGIN( 5, 61, 42, 61, HELP_NONE )
		MOUSE_TOOLTIP_TEXT_ID(TOOLTIPTEXT_ENG1_OIL_TEMPERATURE_FARENHEIT, OilToolTipEngine1Pressure)
    MOUSE_PARENT_END

    MOUSE_PARENT_BEGIN( 47, 61, 42, 61, HELP_NONE )
		MOUSE_TOOLTIP_TEXT_ID(TOOLTIPTEXT_ENG2_OIL_TEMPERATURE_FARENHEIT, OilToolTipEngine2Pressure)
    MOUSE_PARENT_END


	/*
	 * oil quantity
	 */
	MOUSE_PARENT_BEGIN( 5, 122, 83, 61, HELPID_B737_OIL_QUANT )
    MOUSE_PARENT_END


    MOUSE_PARENT_END
    { MOUSE_RECT_EOL, { 0, 0, 0, 0 }, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL }
};


#undef		GAUGE_NAME
#undef		GAUGEHDR_VAR_NAME
#undef		GAUGE_W


////////////////////////////////////////////////////////////////////////////////
// gauge initialization proc
////////////////////////////////////////////////////////////////////////////////
void FSAPI oil_gaugeproc( PGAUGEHDR pgauge, int service_id, UINT32 extra_data )
{
	switch(service_id)
	{
	case PANEL_SERVICE_PRE_INSTALL:		// install_routine()
		break;

	case PANEL_SERVICE_PRE_INITIALIZE:	// initialize_routine()
		break;

	case PANEL_SERVICE_PRE_UPDATE:		// update_routine()
		if (bPanelLightOn)	// if panel lights, brighten all elements
		{
			BRIGHT_IMG(pgauge->elements_list[0]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[0]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[1]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[2]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[3]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[4]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[5]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[6]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[7]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[8]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[9]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[10]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[11]);
		}
		else							// otherwise darken them
		{
			DARK_IMG(pgauge->elements_list[0]);	
			DARK_IMG(pgauge->elements_list[0]->next_element[0]);
			DARK_IMG(pgauge->elements_list[0]->next_element[1]);
			DARK_IMG(pgauge->elements_list[0]->next_element[2]);
			DARK_IMG(pgauge->elements_list[0]->next_element[3]);
			DARK_IMG(pgauge->elements_list[0]->next_element[4]);
			DARK_IMG(pgauge->elements_list[0]->next_element[5]);
			DARK_IMG(pgauge->elements_list[0]->next_element[6]);
			DARK_IMG(pgauge->elements_list[0]->next_element[7]);
			DARK_IMG(pgauge->elements_list[0]->next_element[8]);
			DARK_IMG(pgauge->elements_list[0]->next_element[9]);
			DARK_IMG(pgauge->elements_list[0]->next_element[10]);
			DARK_IMG(pgauge->elements_list[0]->next_element[11]);
    	}

		/*
		 * update oil qty variable
		 */
		lookup_var(&engine2_oil_qty);
		fEngine2OilQty = engine2_oil_qty.var_value.n*100/16384;

		lookup_var(&engine1_oil_qty);
		fEngine1OilQty = engine1_oil_qty.var_value.n*100/16384;

		/*
		 * update oil temp variable
		 */
		lookup_var(&engine2_oil_temp);
		fEngine2OilTemp = engine2_oil_temp.var_value.n*140/16384;

		lookup_var(&engine1_oil_temp);
		fEngine1OilTemp = engine1_oil_temp.var_value.n*140/16384;

		/*
		 * update oil temp pressure
		 */
		lookup_var(&engine2_oil_press);
		fEngine2OilPress = engine2_oil_press.var_value.n*55/16384;

		lookup_var(&engine1_oil_press);
		fEngine1OilPress = engine1_oil_press.var_value.n*55/16384;


		break;
	case PANEL_SERVICE_PRE_DRAW:		// draw_routine()
		break;

	case PANEL_SERVICE_PRE_KILL:		// kill_routine()
		break;
	}
}


/*
 * update engine 2 oil qty string
 */
FLOAT64 FSAPI engine2_oil_qty_string_cb(PELEMENT_STRING pelement)
{
	wsprintf(pelement->string,"%0.3d", (int)fEngine2OilQty);
	return fEngine2OilQty;
}

/*
 * update engine 1 oil qty string
 */
FLOAT64 FSAPI engine1_oil_qty_string_cb(PELEMENT_STRING pelement)
{
	wsprintf(pelement->string,"%0.3d", (int)fEngine1OilQty);
	return fEngine1OilQty;
}

/*
 * update engine 2 oil temp string
 */
FLOAT64 FSAPI engine2_oil_temp_string_cb(PELEMENT_STRING pelement)
{
	wsprintf(pelement->string,"%0.3d", (int)fEngine2OilTemp);
	return fEngine2OilTemp;
}

/*
 * update engine 1 oil temp string
 */
FLOAT64 FSAPI engine1_oil_temp_string_cb(PELEMENT_STRING pelement)
{
	wsprintf(pelement->string,"%0.3d", (int)fEngine1OilTemp);
	return fEngine1OilTemp;
}

/*
 * update engine 2 oil pressure string
 */
FLOAT64 FSAPI engine2_oil_press_string_cb(PELEMENT_STRING pelement)
{
	wsprintf(pelement->string,"%0.3d", (int)fEngine2OilPress);
	return fEngine2OilPress;
}

/*
 * update engine 1 oil pressure string
 */
FLOAT64 FSAPI engine1_oil_press_string_cb(PELEMENT_STRING pelement)
{
	wsprintf(pelement->string,"%0.3d", (int)fEngine1OilPress);
	return fEngine1OilPress;
}

/*
 * update engine 1 oil pressure slider
 */
FLOAT64 FSAPI engine1_oil_press_slider_cb(PELEMENT_SLIDER p)
{
	FLOAT64 f = fEngine1OilPress;
	if (f>200)
		f = 200;
	return f;
}

/*
 * update engine 2 oil pressure slider
 */
FLOAT64 FSAPI engine2_oil_press_slider_cb(PELEMENT_SLIDER p)
{
	FLOAT64 f = fEngine2OilPress;
	if (f>200)
		f = 200;
	return f;
}
