/*
 * $Id: omi.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The omi gauge $
 *
 * $Log: omi.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char omi_gauge_name[]	= 	GAUGE_NAME;
extern PELEMENT_HEADER      omi_list;
extern MOUSERECT            omi_rect[];


/*
 * forward declarations
 */

PELEMENT_HEADER omi_bg_list[];
FLOAT64 FSAPI omi_icon_cb(PELEMENT_ICON);

void FSAPI omi_gaugeproc(PGAUGEHDR, int, UINT32);

GAUGE_HEADER_FS700( GAUGE_W, omi_gauge_name, &omi_list, \
					omi_rect, omi_gaugeproc, 0, 0, 0);

FAILURE_RECORD	omi_icon_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};
FAILURE_RECORD	omi_icon_mask_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};


/*
 * omi icon
 */
MAKE_ICON
(
	omi_icon,
	BMP_OMI_ICON_NONE,
	NULL,
	omi_icon_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	0, 0,
	MARKER_BEACON_STATE,
	omi_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	4,
	0.000000,
	0
)


/*
 * card background image
 */
MAKE_STATIC
(
    omi_bg,
    BMP_OMI_BG,
    &omi_bg_list,
    NULL,
	IMAGE_USE_ERASE,
	0,
	0,0
)

/*
 * priority lists
 */
PELEMENT_HEADER omi_bg_list[] =
{
	&omi_icon.header,
	NULL
};


extern PELEMENT_HEADER      omi_list = &omi_bg.header;

MOUSE_BEGIN(omi_rect, HELPID_GAUGE_OMI_LIGHTS, 0, 0 )
	
MOUSE_END


#undef		GAUGE_NAME
#undef		GAUGEHDR_VAR_NAME
#undef		GAUGE_W

/*
 * update omi icon
 */
FLOAT64 FSAPI omi_icon_cb(PELEMENT_ICON pelement)
{
	return pelement->source_var.var_value.n;
}

////////////////////////////////////////////////////////////////////////////////
// gauge initialization proc
////////////////////////////////////////////////////////////////////////////////
void FSAPI omi_gaugeproc( PGAUGEHDR pgauge, int service_id, UINT32 extra_data )
{
	
	switch(service_id)
	{
	case PANEL_SERVICE_PRE_INSTALL:		// install_routine()
		break;

	case PANEL_SERVICE_PRE_INITIALIZE:	// initialize_routine()
		break;

	case PANEL_SERVICE_PRE_UPDATE:		// update_routine()
		if (bPanelLightOn)	// if panel lights, brighten all elements
		{
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]);
		}
		else							// otherwise darken them
		{
			DARK_IMG(pgauge->elements_list[0]->N_E[0]);	
    	}
		break;

	case PANEL_SERVICE_PRE_DRAW:		// draw_routine()
		break;

	case PANEL_SERVICE_PRE_KILL:		// kill_routine()
		break;
	}
}
