// resource file


// utility macros
#define FONT_COURIER "Courier New"
#define FONT_QUARTZ "Quartz"
#define FONT_ARIAL "Arial"
#define GAUGE_WEIGHT_DEFAULT FW_NORMAL

#define FEETTOMETERS 0.3048
#define METERSTOFEET 3.2808
#define RANKINETOCELSIUS(S) ((S-491.67) * 5 / 9)

#define CELSIUSTOFAHRENHEIT(S) ((S * 9 / 5) + 32)

#define PI 3.14159265358980
#define FALSE_TRUE(p) ((0!=p->source_var.var_value.n) ? 0 : 1)
#define TRUE_FALSE(p) ((0!=p->source_var.var_value.n) ? 1 : 0)

#define PSITOPASCAL(S) (S*6894.757)
#define PASCALTOKGFSQCM(S) (S/98066.5)


#define UOM_FEET 0
#define UOM_METERS_ENGLISH 1
#define UOM_METERS 2


#define		ADD_IMAGE_DATA( element , IMAGE_FLAGS )			((element)->image_flags |=IMAGE_FLAGS)
#define		REMOVE_IMAGE_DATA( element , IMAGE_FLAGS )		((element)->image_flags &=~IMAGE_FLAGS)


#define		ATTITUDE_PITCH_LIMIT		50.0		// stop at 50 degrees

#define 	CL_WHITE 	RGB(255,255,255)
#define 	CL_RED		RGB(255,0,0)
#define		CL_YELLOW								RGB( 255, 255,    0 )
#define		CL_BLACK								RGB(   8,   8,   18 )
#define		CL_CRT									RGB(   0,   0,   98 )
#define		CL_LCD									RGB(   8,  70,    8 )
#define		CL_AQUA									0xFFFF00
#define		CL_GREEN								0x008000
#define		CL_LIME									0x00FF00
#define		CL_NAVY									0x800000
#define		CL_BLUE									0xFF0000
#define		CL_FUCHSIA								0xFF00FF
#define		CL_PURPLE								0x800080
#define		CL_BLACK_CRT_BACKGROUND					RGB(8,8,8)
#define		CL_LCD_BACKGROUND						CL_LIME
#define		CL_BLU_BACKGROUND						RGB(0,74,82)
#define		CL_AMBRA								RGB( 243, 174, 7)
#define		CL_SILVER								RGB(189,189,189)

// Shortened macro flags
#define erase			IMAGE_USE_ERASE
#define hidden			IMAGE_USE_HIDDEN
#define hidden_tree		BIT25
#define bright			IMAGE_USE_BRIGHT
#define transparent		IMAGE_USE_TRANSPARENCY
#define string_trans	BIT15
#define anti_alias		BIT7
#define luminous		BIT14
#define p_luminous		BIT15
#define alpha			BIT13
#define no_static		BIT4
#define alpha_mask		BIT12

#define DARK_IMG(p) ((p)->image_flags &= ~bright)
#define BRIGHT_IMG(p) ((p)->image_flags |= bright)

#define N_E next_element
#define SOUND_CLICK									16384
// autopilot
#define BMP_AUTOPILOT_BG							4096
#define BMP_AUTOPILOT_LIGHTS						4098
#define	BMP_AUTOPILOT_MANUAL_SW_OFF					4099
#define	BMP_AUTOPILOT_MANUAL_SW_ON					4100
#define	BMP_AUTOPILOT_SW_OFF						4101
#define	BMP_AUTOPILOT_SW_ON							4102

// airspeed
#define BMP_AIRSPEED_BG								4105
#define BMP_AIRSPEED_CARD							4106
#define BMP_AIRSPEED_SPEED1_0						4110
#define BMP_AIRSPEED_SPEED1_1						4111
#define BMP_AIRSPEED_SPEED1_2						4112
#define BMP_AIRSPEED_SPEED1_3						4113
#define BMP_AIRSPEED_SPEED1_4						4114
#define BMP_AIRSPEED_SPEED1_5						4115
#define BMP_AIRSPEED_SPEED1_6						4116
#define BMP_AIRSPEED_SPEED1_7						4117
#define BMP_AIRSPEED_SPEED1_8						4118
#define BMP_AIRSPEED_SPEED1_9						4119

#define BMP_AIRSPEED_SPEED10_0						4120
#define BMP_AIRSPEED_SPEED10_1						4121
#define BMP_AIRSPEED_SPEED10_2						4122
#define BMP_AIRSPEED_SPEED10_3						4123
#define BMP_AIRSPEED_SPEED10_4						4124
#define BMP_AIRSPEED_SPEED10_5						4125
#define BMP_AIRSPEED_SPEED10_6						4126
#define BMP_AIRSPEED_SPEED10_7						4127
#define BMP_AIRSPEED_SPEED10_8						4128
#define BMP_AIRSPEED_SPEED10_9						4129

#define BMP_AIRSPEED_SPEED100_0						4130
#define BMP_AIRSPEED_SPEED100_1						4131
#define BMP_AIRSPEED_SPEED100_2						4132
#define BMP_AIRSPEED_SPEED100_3						4133
#define BMP_AIRSPEED_SPEED100_4						4134
#define BMP_AIRSPEED_SPEED100_5						4135
#define BMP_AIRSPEED_SPEED100_6						4136
#define BMP_AIRSPEED_SPEED100_7						4137
#define BMP_AIRSPEED_SPEED100_8						4138
#define BMP_AIRSPEED_SPEED100_9						4139
#define BMP_AIRSPEED_AIRSPEED_HOLD_VAR_NEEDLE		4150
#define BMP_AIRSPEED_AIRSPEED						4151
#define BMP_BARBER_POLE_AIRSPEED					4152

// flaps
#define BMP_FLAPS_BG								4200
#define BMP_FLAPS_NEEDLE							4201

// altimeter
#define BMP_ALTIMETER_BG							4210
#define BMP_ALTIMETER_TENTHS_TAPE					4211
#define BMP_ALTIMETER_TENTHS_TAPE_MASK				4212
#define BMP_ALTIMETER_HUND_TAPE						4213
#define BMP_ALTIMETER_HUND_TAPE_MASK				4214

#define BMP_ALTIMETER_1000_0						4220
#define BMP_ALTIMETER_1000_1						4221
#define BMP_ALTIMETER_1000_2						4222
#define BMP_ALTIMETER_1000_3						4223
#define BMP_ALTIMETER_1000_4						4224
#define BMP_ALTIMETER_1000_5						4225
#define BMP_ALTIMETER_1000_6						4226
#define BMP_ALTIMETER_1000_7						4227
#define BMP_ALTIMETER_1000_8						4228
#define BMP_ALTIMETER_1000_9						4229

#define BMP_ALTIMETER_10000_0						4230
#define BMP_ALTIMETER_10000_1						4231
#define BMP_ALTIMETER_10000_2						4232
#define BMP_ALTIMETER_10000_3						4233
#define BMP_ALTIMETER_10000_4						4234
#define BMP_ALTIMETER_10000_5						4235
#define BMP_ALTIMETER_10000_6						4236
#define BMP_ALTIMETER_10000_7						4237
#define BMP_ALTIMETER_10000_8						4238
#define BMP_ALTIMETER_10000_9						4239
#define BMP_ALTIMETER_ALTITUDE_LOCK_VAR				4240
#define BMP_ALTIMETER_NEEDLE						4241

// wiskey compass
#define BMP_WISKEY_COMPASS_BG						5000
#define BMP_WISKEY_COMPASS_SLIDER					5001
#define BMP_WISKEY_COMPASS_MASK						5002

// adi
#define BMP_ADI_BG									5100
#define BMP_ADI_ATTITUDE_SPRITE						5101
#define BMP_ADI_ATTITUDE_SPRITE_MASK				5102
#define BMP_FLIGHT_DIRECTOR_BANK					5103
#define BMP_FLIGHT_DIRECTOR_PITCH					5104
#define BMP_ADI_PLANE_BANK							5105
#define BMP_ADI_PLANE_PITCH_BG						5106
#define BMP_ADI_PLANE_PITCH							5107
#define BMP_ADI_HSI_HORIZONTAL						5108
#define BMP_ADI_HSI_VERTICAL						5109
#define BMP_ADI_HSI_HORIZONTAL_BG					5110
#define BMP_ADI_HSI_VERTICAL_BG						5111

#define BMP_ADI_AP_OFF								5112
#define BMP_ADI_AP_ON								5113
#define BMP_ADI_AT_OFF								5114
#define BMP_ADI_AT_ON								5115
#define BMP_ADI_FD_OFF								5116
#define BMP_ADI_FD_ON								5117

// chronometer
#define BMP_CHRONO_BG								5200

// clock
#define BMP_CLOCK_BG								5202
#define BMP_CLOCK_NEEDLE							5203

// left radio stack
#define BMP_LEFT_RADIO_STACK_BG						5210
#define BMP_RADIO_IDENT_OFF							5211
#define BMP_RADIO_IDENT_ON							5212
#define BMP_RIGHT_RADIO_STACK_BG					5220

#define BMP_EICAS1_BG								6000
#define BMP_EICAS1_NEEDLE							6001

#define BMP_GPS_BG									7000
#define BMP_GPS_SLIDER								7001

// dme
#define BMP_DME_BG									7010
#define BMP_DME1									7011
#define BMP_DME2									7012

// tape altimeter
#define BMP_TAPEALT_BG								7100
#define BMP_TAPEALT_MOVING							7101
#define BMP_TAPEALT_MOVING_MASK						7102

// light manouver switch
#define BMP_WLS_BG									7110
#define BMP_WLS_ICON_ON								7111
#define BMP_WLS_ICON_OFF							7112

// vsi
#define BMP_VSI_BG									7120
#define BMP_VSI_NEEDLE								7121

// lights
#define BMP_LIGHTS_BG								7150
#define BMP_LIGHTS_ICON_OFF							7151
#define BMP_LIGHTS_ICON_ON							7152
#define BMP_ENGINE_STARTER1							7161
#define BMP_ENGINE_STARTER2							7162
#define BMP_ENGINE_STARTER3							7163
#define BMP_ENGINE_STARTER4							7164
#define BMP_ENGINE_STARTER5							7165

// gear lever
#define BMP_GEAR_LEVER_BG							7166
#define BMP_GEAR_LEVER_SLIDER						7167

// gear lights
#define BMP_GEAR_LIGHTS_BG							7170
#define BMP_LEFT_GEAR_LIGHT_OFF						7171
#define BMP_LEFT_GEAR_LIGHT_ON						7172
#define BMP_NOSE_GEAR_LIGHT_OFF						7173
#define BMP_NOSE_GEAR_LIGHT_ON						7174
#define BMP_RIGHT_GEAR_LIGHT_OFF					7175
#define BMP_RIGHT_GEAR_LIGHT_ON						7176

// hsi
/*#define BMP_HSI_BG									8000
#define BMP_HSI_ROSE								8001
#define BMP_HSI_ROSE_MASK							8002
#define BMP_HSI_HORIZONTAL_GS						8003
#define BMP_HSI_CDI									8005
#define BMP_HSI_CDI_MASK							8006
#define BMP_HSI_VOR2_NEEDLE							8007
#define BMP_HSI_HEADING_BUG							8008
#define BMP_HSI_PLANE								8009
#define BMP_HSI_TF_INDICATOR						8010

#define BMP_HSI_ARC_BG								8020
#define BMP_HSI_ARC_SPRITE							8021
#define BMP_HSI_ARC_SPRITE_MASK						8022

#define BMP_HSI_ARC_HORIZONTAL_GS					8023
#define BMP_HSI_ARC_HORIZONTAL_GS_MASK				8024
#define BMP_HSI_ARC_HORIZONTAL_NEEDLE				8025
#define BMP_HSI_ARC_HORIZONTAL_NEEDLE_MASK			8026 */

// nav frequency bg
#define BMP_NAV_BG									8100

// temperature
#define BMP_TEMP_BG									8110
#define BMP_TEMP_ICON_C								8111
#define BMP_TEMP_ICON_F								8112

// RMI
#define BMP_RMI_BG									8120
#define BMP_RMI_CARD_SPRITE							8121
#define BMP_RMI_CARD_SPRITE_MASK					8122
#define BMP_RMI_VOR2_NEEDLE							8123
#define BMP_RMI_ADF_NEEDLE							8124

// fuel
#define BMP_FUEL_BG									8130
#define BMP_FUEL_NUMBER_0_0							8131
#define BMP_FUEL_NUMBER_0_1							8132
#define BMP_FUEL_NUMBER_0_2							8133
#define BMP_FUEL_NUMBER_0_3							8134
#define BMP_FUEL_NUMBER_0_4							8135
#define BMP_FUEL_NUMBER_0_5							8136
#define BMP_FUEL_NUMBER_0_6							8137
#define BMP_FUEL_NUMBER_0_7							8138
#define BMP_FUEL_NUMBER_0_8							8139
#define BMP_FUEL_NUMBER_0_9							8140

#define BMP_FUEL_NUMBER_1_0							8141
#define BMP_FUEL_NUMBER_1_1							8142
#define BMP_FUEL_NUMBER_1_2							8143
#define BMP_FUEL_NUMBER_1_3							8144
#define BMP_FUEL_NUMBER_1_4							8145
#define BMP_FUEL_NUMBER_1_5							8146
#define BMP_FUEL_NUMBER_1_6							8147
#define BMP_FUEL_NUMBER_1_7							8148
#define BMP_FUEL_NUMBER_1_8							8149
#define BMP_FUEL_NUMBER_1_9							8150

// oil
#define BMP_OIL_BG									8170
#define BMP_OIL_1_SLIDER							8171
#define BMP_OIL_2_SLIDER							8172

// omi
#define BMP_OMI_BG									9000
#define BMP_OMI_ICON_NONE							9001
#define BMP_OMI_ICON_OUTER							9002
#define BMP_OMI_ICON_MIDDLE							9003
#define BMP_OMI_ICON_INNER							9004

// spoiler
#define BMP_SPOILER_BG								9010
#define BMP_SPOILER_SLIDER							9011

// engine start
#define BMP_START_BG								9020
#define BMP_START_ICON_OFF							9022
#define BMP_START_ICON_START						9023
#define BMP_START_ICON_GEN							9024

// backup altimeter
#define BMP_BACKUP_ALTIMETER_BG						9100
#define BMP_BACKUP_ALTIMETER_NEEDLE					9101

// backup attitude
#define BMP_BACKUP_ATTITUDE_BG						9120
#define BMP_BACKUP_ATTITUDE_NEEDLE					9121
#define BMP_BACKUP_ATTITUDE_SPRITE					9122
#define BMP_BACKUP_ATTITUDE_SPRITE_MASK				9123

// backup airspeed
#define BMP_BACKUP_AIRSPEED_BG						9200
#define BMP_BACKUP_AIRSPEED_NEEDLE					9201

// eicas 2
#define BMP_EICAS2_BG								10000
#define BMP_NO_SMOKING_ICON_OFF						10001
#define BMP_NO_SMOKING_ICON_ON						10002
#define BMP_FASTEN_SEAT_BELTS_ICON_OFF				10003
#define BMP_FASTEN_SEAT_BELTS_ICON_ON				10004

// throttle
#define BMP_THROTTLE_BG								11000
#define BMP_LEFT_THROTTLE_SLIDER					11001
#define BMP_RIGHT_THROTTLE_SLIDER					11002

// flaps lever
#define BMP_FLAPS_LEVER_BG							11010
#define BMP_FLAPS_LEVER_SLIDER						11012

// trim indicator
#define BMP_TRIM_INDICATOR_BG						11020

// signs
#define BMP_SIGNS_BG								12000
#define BMP_SIGNS_SWITCH_OFF						12001
#define BMP_SIGNS_SWITCH_ON							12002

// eicas 3
#define BMP_EICAS3_BG								13000
#define BMP_EICAS3_HORIZ_SLIDER						13001
#define BMP_EICAS3_VERT_SLIDER						13002

// yoke
#define BMP_YOKE_BG									14000
#define BMP_YOKE_SPRITE								14001
#define BMP_YOKE_SPRITE_MASK						14002

// audio
#define BMP_AUDIO_BG								14020
#define BMP_AUDIO_ICON_OFF							14021
#define BMP_AUDIO_ICON_ON							14022


// autobrake
#define BMP_AUTOBRAKE_BG							14100
#define BMP_AUTOBRAKE_ICON_RTO						14101
#define BMP_AUTOBRAKE_ICON_OFF						14102
#define BMP_AUTOBRAKE_ICON_1						14103
#define BMP_AUTOBRAKE_ICON_2						14104
#define BMP_AUTOBRAKE_ICON_3						14105
#define BMP_AUTOBRAKE_ICON_MAX						14106

// flap lights
#define BMP_FLAP_LIGHTS_BG							14200
#define BMP_FLAP_TRANSIT_OFF						14201
#define BMP_FLAP_TRANSIT_ON							14202
#define BMP_FLAP_EXT_OFF							14203
#define BMP_FLAP_EXT_ON								14204

// panel switch
#define BMP_PANEL_SWITCH_BG							14300
#define BMP_PANEL_SWITCH_OFF						14301
#define BMP_PANEL_SWITCH_ON							14302


#define BMP_SEAT_POSITION_BG						15000
#define BMP_SEAT_POSITION_SLIDER					15001

// hsi switch
#define BMP_HSI_SWITCH_BG							16000
#define BMP_HSI_SWITCH_ARC							16001
#define BMP_HSI_SWITCH_ROSE							16002


// new style hsi
#define BMP_NEW_HSI_BG								17000
#define BMP_NEW_HSI_CARD_ROSE						17001

#define BMP_NEW_HSI_ROSE_SPRITE						17002
#define BMP_NEW_HSI_ROSE_SPRITE_MASK				17003
#define BMP_NEW_HSI_VOR1_NEEDLE						17004
#define BMP_NEW_HSI_CDI								17005
#define BMP_NEW_HSI_CDI_MASK						17006
#define BMP_NEW_HSI_HEADING_BUG						17007
#define BMP_NEW_HSI_VOR2_NEEDLE						17008
#define BMP_NEW_HSI_PLANE							17009
#define BMP_NEW_HSI_TF_INDICATOR					17010
#define BMP_NEW_HSI_ARC_CARD						17020
#define BMP_NEW_HSI_ARC_SPRITE						17021
#define BMP_NEW_HSI_ARC_SPRITE_MASK					17022
#define BMP_NEW_HSI_ARC_VOR1_NEEDLE					17023
#define BMP_NEW_HSI_ARC_VOR1_NEEDLE_MASK			17024
#define BMP_NEW_HSI_ARC_CDI							17025
#define BMP_NEW_HSI_ARC_CDI_MASK					17026
#define BMP_NEW_HSI_ARC_VOR2_NEEDLE					17027
#define BMP_NEW_HSI_ARC_VOR2_NEEDLE_MASK			17028
#define BMP_NEW_HSI_ARC_HEADING_BUG					17029
#define BMP_NEW_HSI_ARC_HEADING_BUG_MASK			17030
#define BMP_NEW_HSI_ARC_PLANE						17031
#define BMP_NEW_HSI_ARC_TF_INDICATOR               	17032
