/*
 * $Id: riterstk.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The right radio stack gauge $
 *
 * $Log: riterstk.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char right_radio_stack_gauge_name[]     = GAUGE_NAME;
extern PELEMENT_HEADER      right_radio_stack_list;
extern MOUSERECT            right_radio_stack_rect[];


/*
 * forward declarations
 */
void FSAPI right_radio_stack_gaugeproc(PGAUGEHDR, int, UINT32);
FLOAT64 FSAPI right_stack_adf_frequency_string_cb(PELEMENT_STRING);
FLOAT64 FSAPI right_stack_xpdr_string_cb(PELEMENT_STRING);
FLOAT64 FSAPI right_stack_adf_ident_icon_cb(PELEMENT_ICON);

GAUGE_HEADER_FS700(GAUGE_W, right_radio_stack_gauge_name, &right_radio_stack_list, \
                        right_radio_stack_rect, right_radio_stack_gaugeproc, 0, 0, 0);

FAILURE_RECORD	right_stack_adf_frequency_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_ADF, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD	xpdr_freq_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_TRANSPONDER, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};


// 3,2

/*
 * adf ident toggle
 */
MAKE_ICON
(
	right_stack_adf_ident_icon,
	BMP_RADIO_IDENT_OFF,
	NULL,
	NULL,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY | IMAGE_USE_BRIGHT,
	0,
	3, 2,
	ADF_MORSE_IDENT,
	right_stack_adf_ident_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)

/*
 * the adf frequency string
 */
MAKE_STRING
(
	right_stack_adf_frequency_string,
	NULL,
	right_stack_adf_frequency_string_fail,
	IMAGE_USE_ERASE | transparent | IMAGE_USE_BRIGHT,
	0,
	{25, 5},
	{48, 18},
	6,

	ADF_FREQUENCY,
	ADF_EXTENDED_FREQUENCY,
	MODULE_VAR_NONE,
	CL_LIME,
	RGB(4,4,4),
	CL_WHITE,
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_LEFT,
	NULL,
	right_stack_adf_frequency_string_cb
)

/*
 * the transponder string
 */
MAKE_STRING
(
	right_stack_xpdr_string,
	NULL,
	xpdr_freq_string_fail,
	IMAGE_USE_ERASE | transparent | IMAGE_USE_BRIGHT,
	0,
	{29, 25},
	{32, 18},
	4,

	TRANSPONDER_CODE,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_LIME,
	RGB(4,4,4),
	RGB(255,255, 255),
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE,
	NULL,
	right_stack_xpdr_string_cb
)


PELEMENT_HEADER right_radio_stack_bg_list[] =
{
	&right_stack_adf_frequency_string.header,
	&right_stack_xpdr_string.header,
	&right_stack_adf_ident_icon.header,
	NULL
};

/*
 * card background image
 */
MAKE_STATIC
(
    right_radio_stack_background,
    BMP_RIGHT_RADIO_STACK_BG,
    &right_radio_stack_bg_list,
    NULL,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY,
	0,
	0,0
)


////////////////////////////////////////////////////////////////////////////////
// header
////////////////////////////////////////////////////////////////////////////////
PELEMENT_HEADER     right_radio_stack_list   = &right_radio_stack_background.header;


////////////////////////////////////////////////////////////////////////////////
MOUSERECT right_radio_stack_rect[] =
{
	MOUSE_PARENT_BEGIN( 0, 0, 0, 0, HELP_NONE )

		MOUSE_PARENT_BEGIN( 0, 0, 11, 8, HELP_NONE )  // adf
			MOUSE_CHILD_EVENT( 0, 0, 11, 8, CURSOR_HAND, \
					MOUSE_LEFTSINGLE, KEY_RADIO_ADF_IDENT_TOGGLE )
		MOUSE_PARENT_END

		// adf frequency regulator
		MOUSE_PARENT_BEGIN( 25, 3, 48, 20, HELPID_RADIO_ADF_RADIO )
			MOUSE_CHILD_EVENT( 0, 0, 11, 20, CURSOR_UPARROW,
					MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, KEY_ADF_100_INC )
			MOUSE_CHILD_EVENT( 12, 0, 11, 20, CURSOR_UPARROW,
					MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, KEY_ADF_10_INC )
			MOUSE_CHILD_EVENT( 24, 0, 11, 20, CURSOR_UPARROW,
					MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, KEY_ADF_1_INC )
			MOUSE_CHILD_EVENT( 36, 0, 11, 20, CURSOR_UPARROW,
					MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, KEY_ADF1_RADIO_TENTHS_INC )
		MOUSE_PARENT_END

		// transponder regulator
		MOUSE_PARENT_BEGIN( 29, 25, 32, 20, HELPID_RADIO_TRANSPONDER )
			MOUSE_CHILD_EVENT( 0, 0, 7, 20, CURSOR_DOWNARROW,
				MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, KEY_XPNDR_1000_INC )
			MOUSE_CHILD_EVENT( 8, 0, 7, 20, CURSOR_DOWNARROW,
				MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, KEY_XPNDR_100_INC )
			MOUSE_CHILD_EVENT( 16, 0, 7, 20, CURSOR_DOWNARROW,
				MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, KEY_XPNDR_10_INC )
			MOUSE_CHILD_EVENT( 24, 0, 7, 20, CURSOR_DOWNARROW,
					MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, KEY_XPNDR_1_INC )
		MOUSE_PARENT_END


	MOUSE_PARENT_END
	{
		MOUSE_RECT_EOL, { 0, 0, 0, 0 }, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL
	}
};


////////////////////////////////////////////////////////////////////////////////
// gauge initialization proc
////////////////////////////////////////////////////////////////////////////////
void FSAPI right_radio_stack_gaugeproc( PGAUGEHDR pgauge, int service_id, UINT32 extra_data )
{
	switch(service_id)
	{
	case PANEL_SERVICE_PRE_INSTALL: /* "install_routine()" */
		break;

	case PANEL_SERVICE_PRE_INITIALIZE:	/* "initialize_routine()" */
		break;

	case PANEL_SERVICE_PRE_UPDATE: /* "update_routine()" */
        /*lookup_var(&avlights);
		if (avlights.var_value.n!=0)	// if panel lights, brighten all elements
		{
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[0]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[1]);
		}
		else
		{
			DARK_IMG(pgauge->elements_list[0]->next_element[0]);
			DARK_IMG(pgauge->elements_list[0]->next_element[1]);
		}*/
		break;

	case PANEL_SERVICE_PRE_DRAW: /* "draw_routine()" */
		break;

	case PANEL_SERVICE_PRE_KILL: /* "kill_routine()" */
		break;
	}
}



#undef GAUGE_NAME
#undef GAUGEHDR_VAR_NAME
#undef GAUGE_W


/*
 * update adf frequency
 */
FLOAT64 FSAPI right_stack_adf_frequency_string_cb(PELEMENT_STRING pelement)
{
	UINT32 digits = (UINT32)pelement->source_var[0].var_value.d;
	UINT32 dec = (UINT32)pelement->source_var[1].var_value.d;
	UINT32 hi = 0;
	if (dec>255)
	{
		hi=1;
		dec-=256;
	}
	wsprintf(pelement->string, "%d%d%d%d.%d", hi, (digits >> 8) & 0x0f,
			(digits >> 4) & 0x0f, digits & 0x0f, dec );
	return  (FLOAT64)pelement->source_var[0].var_value.d;
}

/*
 * update transponder
 */
FLOAT64 FSAPI right_stack_xpdr_string_cb(PELEMENT_STRING pelement)
{
	UINT32 nFreq = (UINT32)pelement->source_var[0].var_value.d;

	// conversion
	wsprintf(pelement->string, "%0.4x", nFreq);
	return (FLOAT64)nFreq;
}

/*
 * adf update
 */
FLOAT64 FSAPI right_stack_adf_ident_icon_cb(PELEMENT_ICON pelement)
{
	return (0!=pelement->source_var.var_value.n) ? 1 : 0;
}



