/*
 * $Id: rmi.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The dual needle rmi gauge $
 *
 * $Log: rmi.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char rmi_gauge_name[]	= 	GAUGE_NAME;
extern PELEMENT_HEADER      rmi_list;
extern MOUSERECT            rmi_rect[];


/*
 * forward declarations
 */
void FSAPI rmi_gaugeproc(PGAUGEHDR, int, UINT32);
FLOAT64 FSAPI rmi_sprite_cb(PELEMENT_SPRITE);
FLOAT64 FSAPI rmi_vor2_needle_cb(PELEMENT_NEEDLE);
FLOAT64 FSAPI rmi_adf_needle_cb(PELEMENT_NEEDLE);
FLOAT64 FSAPI rmi_dme_distance_string_cb(PELEMENT_STRING);

PELEMENT_HEADER rmi_vor2_needle_list[];
PELEMENT_HEADER rmi_adf_needle_list[];
PELEMENT_HEADER rmi_card_sprite_list[];
PELEMENT_HEADER rmi_bg_list[];


GAUGE_HEADER_FS700( GAUGE_W, rmi_gauge_name, &rmi_list, \
					rmi_rect, rmi_gaugeproc, 0, 0, 0);


/*
 * failure lists
 */
FAILURE_RECORD rmi_card_sprite_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_GYRO_HEADING, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD  rmi_vor2_needle_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_NAVIGATION_VOR2, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD  rmi_adf_needle_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_ADF, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};


/*
 * dme 2 distance string
 */
MAKE_STRING
(
	rmi_dme_distance_string,
	NULL,
	NULL,
	IMAGE_USE_ERASE | transparent,
	0,
	{4, 0},
	{72, 42},
	4,

	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_AMBRA,
	RGB(4,4,4),
	CL_WHITE,
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_CENTER,
	NULL,
	rmi_dme_distance_string_cb
)



/*
 * vor2 needle
 */
MAKE_NEEDLE
(
	rmi_vor2_needle,
	BMP_RMI_VOR2_NEEDLE,
	&rmi_vor2_needle_list,
	rmi_vor2_needle_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 149, 191 },
	{ 128, 21  },

	MODULE_VAR_NONE,
	rmi_vor2_needle_cb,
	NULL,
	6
)

/*
 * adf needle
 */
MAKE_NEEDLE
(
	rmi_adf_needle,
	BMP_RMI_ADF_NEEDLE,
	&rmi_adf_needle_list,
	rmi_adf_needle_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 149, 191 },
	{ 21, 128  },

	MODULE_VAR_NONE,
	rmi_adf_needle_cb,
	NULL,
	6
)

/*
 * rmi card sprite
 */
MAKE_SPRITE
(
	rmi_card_sprite,
	BMP_RMI_CARD_SPRITE,
	&rmi_card_sprite_list,
	rmi_card_sprite_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
    21, 64,
    149, 191,
	1, 1,

	MODULE_VAR_NONE, NULL, 0,
	MODULE_VAR_NONE, NULL, 0,
	MODULE_VAR_NONE, rmi_sprite_cb, 1
)

               


/*
 * card background image
 */
MAKE_STATIC
(
    rmi_bg,
    BMP_RMI_BG,
    &rmi_bg_list,
    NULL,
	IMAGE_USE_ERASE | transparent,
	0,
	0,0
)

/*
 * priority lists
 */
PELEMENT_HEADER rmi_vor2_needle_list[] =
{
	&rmi_dme_distance_string.header,
	NULL
};

PELEMENT_HEADER rmi_adf_needle_list[] =
{
	&rmi_vor2_needle.header,
	NULL
};

PELEMENT_HEADER rmi_card_sprite_list[] =
{
	&rmi_adf_needle.header,
	NULL
};

PELEMENT_HEADER rmi_bg_list[] =
{
	&rmi_card_sprite.header,
	NULL
};


extern PELEMENT_HEADER      rmi_list = &rmi_bg.header;

MOUSERECT rmi_rect[] =
{
    MOUSE_PARENT_BEGIN( 0, 0, 0, 0, HELPID_GAUGE_RMI)
    MOUSE_PARENT_END
    { MOUSE_RECT_EOL, { 0, 0, 0, 0 }, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL }
};


#undef		GAUGE_NAME
#undef		GAUGEHDR_VAR_NAME
#undef		GAUGE_W


////////////////////////////////////////////////////////////////////////////////
// gauge initialization proc
////////////////////////////////////////////////////////////////////////////////
void FSAPI rmi_gaugeproc( PGAUGEHDR pgauge, int service_id, UINT32 extra_data )
{
	FLOAT64 f;
	switch(service_id)
	{
	case PANEL_SERVICE_PRE_INSTALL:		// install_routine()
		break;

	case PANEL_SERVICE_PRE_INITIALIZE:	// initialize_routine()
		break;

	case PANEL_SERVICE_PRE_UPDATE:		// update_routine()
		uom = GetUnits();
		if (bPanelLightOn)	// if panel lights, brighten all elements
		{
			BRIGHT_IMG(pgauge->elements_list[0]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[0]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[0]->next_element[0]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[0]->next_element[0]->next_element[0]);
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[0]->next_element[0]->next_element[0]->next_element[0]);
		}
		else							// otherwise darken them
		{
			DARK_IMG(pgauge->elements_list[0]);	
			DARK_IMG(pgauge->elements_list[0]->next_element[0]);
			DARK_IMG(pgauge->elements_list[0]->next_element[0]->next_element[0]);
			DARK_IMG(pgauge->elements_list[0]->next_element[0]->next_element[0]->next_element[0]);
			DARK_IMG(pgauge->elements_list[0]->next_element[0]->next_element[0]->next_element[0]->next_element[0]);
    	}


		// calculate rotation of adf needle
		lookup_var(&adf_needle);
		f = adf_needle.var_value.n - (-360);
		if (f<0) f = f + 360;
		fRmiAdfNeedle=f;


		break;
	case PANEL_SERVICE_PRE_DRAW:		// draw_routine()
		break;

	case PANEL_SERVICE_PRE_KILL:		// kill_routine()
		break;
	}
}

/*
 * update rmi sprite
 */
FLOAT64 FSAPI rmi_sprite_cb(PELEMENT_SPRITE pelement)
{
	return fDegreesGyro;
}

FLOAT64 FSAPI rmi_vor2_needle_cb(PELEMENT_NEEDLE pelement)
{
	return fVor2Radial-90;
}

FLOAT64 FSAPI rmi_adf_needle_cb(PELEMENT_NEEDLE pelement)
{
	return fRmiAdfNeedle;
}

FLOAT64 FSAPI rmi_dme_distance_string_cb(PELEMENT_STRING pelement)
{
	FLOAT64 f;
	lookup_var(&dme2_distance);
	f = dme2_distance.var_value.n;
	if (f<0.0)
		*pelement->string='\0';
	else
	{
		if (f>=100)
			wsprintf( pelement->string,"%0.4d", (int)f);
		else if (f>=10)
			sprintf( pelement->string,"%0.1f",f);
		else
			sprintf( pelement->string,"%0.2f",f);
	}
	return f;
}

