/*
 * $Id: seatpos.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The seat poistion gauge $
 *
 * $Log: seatpos.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char seat_position_gauge_name[]	= 	GAUGE_NAME;
extern PELEMENT_HEADER      seat_position_list;
extern MOUSERECT            seat_position_rect[];


UINT32 nSeatPosition = 4;

FLOAT64 FSAPI seat_position_slider_cb(PELEMENT_SLIDER pelement)
{
	return (FLOAT64)nSeatPosition-4;
}

GAUGE_HEADER_FS700( GAUGE_W, seat_position_gauge_name, &seat_position_list, \
					seat_position_rect, NULL, 0, 0, 0);





/*
 * pitch slider
 */
MAKE_SLIDER
(    
	seat_position_slider,
    BMP_SEAT_POSITION_SLIDER,
	NULL,
	NULL,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 10, 20 },
	MODULE_VAR_NONE, NULL, 0.000000,
	MODULE_VAR_NONE, seat_position_slider_cb, 3.8
)

PELEMENT_HEADER seat_position_card_list[] =
{
	&seat_position_slider.header,
	NULL
};


/*
 * card background image
 */
MAKE_STATIC
(
    seat_position_bg,
    BMP_SEAT_POSITION_BG,
    &seat_position_card_list,
    NULL,
	IMAGE_USE_ERASE,
	0,
	0,0
)


extern PELEMENT_HEADER      seat_position_list = &seat_position_bg.header;

BOOL FSAPI IncreaseSeatPos(PPIXPOINT relative_point, FLAGS32 flags)
{
	if (nSeatPosition<8)
	{
		nSeatPosition++;
		trigger_key_event(KEY_EYEPOINT_UP,1);
	}
	return FALSE;
}

BOOL FSAPI DecreaseSeatPos(PPIXPOINT relative_point, FLAGS32 flags)
{

	if (nSeatPosition > 0)
	{
		nSeatPosition--;
		trigger_key_event(KEY_EYEPOINT_DOWN,1);
	}
	return FALSE;
}

/*
 * flaps mouse rect
 */
MOUSERECT seat_position_rect[] =
{
    MOUSE_PARENT_BEGIN( 0, 0, 0, 0, HELP_NONE )
		MOUSE_CHILD_FUNCT( 19, 6, 35, 24, CURSOR_UPARROW, MOUSE_LEFTSINGLE, IncreaseSeatPos )
		MOUSE_CHILD_FUNCT( 19, 31, 35, 24, CURSOR_DOWNARROW, MOUSE_LEFTSINGLE, DecreaseSeatPos )
    MOUSE_PARENT_END
    { MOUSE_RECT_EOL, { 0, 0, 0, 0 }, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL }
};


#undef		GAUGE_NAME
#undef		GAUGEHDR_VAR_NAME
#undef		GAUGE_W

