/*
 * $Id: signs.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The signs gauge $
 *
 * $Log: signs.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char signs_gauge_name[]	= 	GAUGE_NAME;
extern PELEMENT_HEADER      signs_list;
extern MOUSERECT            signs_rect[];


/*
 * forward declarations
 */
PELEMENT_HEADER signs_bg_list[];

FLOAT64 FSAPI signs_no_smoking_icon_cb(PELEMENT_ICON);
FLOAT64 FSAPI signs_fasten_seat_belts_icon_cb(PELEMENT_ICON);

GAUGE_HEADER_FS700( GAUGE_W, signs_gauge_name, &signs_list, \
					signs_rect, NULL, 0, 0, 0);


/*
 * no smoking icon
 */
MAKE_ICON
(
	signs_no_smoking_icon,
	BMP_SIGNS_SWITCH_OFF,
	NULL,
	NULL,
	IMAGE_USE_ERASE | transparent,
	0,
	22, 28,
	MODULE_VAR_NONE,
	signs_no_smoking_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)

/*
 * fasten seat belts icon
 */
MAKE_ICON
(
	signs_fasten_seat_belts_icon,
	BMP_SIGNS_SWITCH_OFF,
	NULL,
	NULL,
	IMAGE_USE_ERASE | transparent,
	0,
	79, 28,
	MODULE_VAR_NONE,
	signs_fasten_seat_belts_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)


/*
 * card background image
 */
MAKE_STATIC
(
    signs_bg,
    BMP_SIGNS_BG,
    &signs_bg_list,
    NULL,
	IMAGE_USE_ERASE | transparent,
	0,
	0,0
)

/*
 * priority lists
 */
PELEMENT_HEADER signs_bg_list[] =
{
	&signs_no_smoking_icon.header,
	&signs_fasten_seat_belts_icon.header,
	NULL
};


extern PELEMENT_HEADER      signs_list = &signs_bg.header;

BOOL FSAPI SignSwitchNoSmoking(PPIXPOINT p, FLAGS32 flags)
{
	NoSmokingSign=!NoSmokingSign;
	MFSSoundResPlay(main_sound, FALSE);
	return FALSE;
}
BOOL FSAPI SignSwitchFastenSeatBelts(PPIXPOINT p, FLAGS32 flags)
{
	FastenSeatBelts=!FastenSeatBelts;
	MFSSoundResPlay(main_sound, FALSE);
	return FALSE;
}


MOUSE_BEGIN(signs_rect, HELP_NONE, 0, 0 )
	MOUSE_CHILD_FUNCT( 22, 29, 21, 49, CURSOR_HAND, MOUSE_LEFTSINGLE, SignSwitchNoSmoking )
	MOUSE_CHILD_FUNCT( 79, 22, 21, 49, CURSOR_HAND, MOUSE_LEFTSINGLE, SignSwitchFastenSeatBelts )
MOUSE_END


#undef		GAUGE_NAME
#undef		GAUGEHDR_VAR_NAME
#undef		GAUGE_W

FLOAT64 FSAPI signs_no_smoking_icon_cb(PELEMENT_ICON pelement)
{
	return NoSmokingSign ? 1 : 0;
}

FLOAT64 FSAPI signs_fasten_seat_belts_icon_cb(PELEMENT_ICON pelement)
{
	return FastenSeatBelts ? 1 : 0;
}
