/*
 * $Id: spoiler.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The spoiler gauge $
 *
 * $Log: spoiler.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char spoiler_gauge_name[]	= 	GAUGE_NAME;
extern PELEMENT_HEADER      spoiler_list;
extern MOUSERECT            spoiler_rect[];


/*
 * forward declarations
 */

PELEMENT_HEADER spoiler_bg_list[];
void FSAPI spoiler_gaugeproc(PGAUGEHDR, int, UINT32);

GAUGE_HEADER_FS700( GAUGE_W, spoiler_gauge_name, &spoiler_list, \
					spoiler_rect, spoiler_gaugeproc, 0, 0, 0);



MAKE_SLIDER
(    
	spoiler_slider,
    BMP_SPOILER_SLIDER,
	NULL,
	NULL,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 0, 0 },
	MODULE_VAR_NONE, NULL, 0.000000,
	SPOILERS_HANDLE_POS, NULL, 0.001500 
)


/*
 * card background image
 */
MAKE_STATIC
(
    spoiler_bg,
    BMP_SPOILER_BG,
    &spoiler_bg_list,
    NULL,
	transparent,
	0,
	0,0
)

/*
 * priority lists
 */
PELEMENT_HEADER spoiler_bg_list[] =
{
	&spoiler_slider.header,
	NULL
};


extern PELEMENT_HEADER      spoiler_list = &spoiler_bg.header;

BOOL FSAPI SetSpoiler(PPIXPOINT relative_point, FLAGS32 mouse_flags)
{
	int i = relative_point->y;
	if (i>99)
		i=99;
	else if (i<0)
		i=0;
	trigger_key_event(KEY_SPOILERS_SET, (i*16383)/100);
	return FALSE;
}


MOUSE_BEGIN( spoiler_rect, HELPID_GAUGE_SPOILER, 0, 0 )
//	
	MOUSE_CHILD_FUNCT( 0, 0, 40, 100, CURSOR_HAND, MOUSE_LEFTSINGLE | MOUSE_LEFTDRAG, SetSpoiler )


MOUSE_END


#undef		GAUGE_NAME
#undef		GAUGEHDR_VAR_NAME
#undef		GAUGE_W


////////////////////////////////////////////////////////////////////////////////
// gauge initialization proc
////////////////////////////////////////////////////////////////////////////////
void FSAPI spoiler_gaugeproc( PGAUGEHDR pgauge, int service_id, UINT32 extra_data )
{
	
	switch(service_id)
	{
	case PANEL_SERVICE_PRE_INSTALL:		// install_routine()
		break;

	case PANEL_SERVICE_PRE_INITIALIZE:	// initialize_routine()
		break;

	case PANEL_SERVICE_PRE_UPDATE:		// update_routine()
		break;

	case PANEL_SERVICE_PRE_DRAW:		// draw_routine()
		break;

	case PANEL_SERVICE_PRE_KILL:		// kill_routine()
		break;
	}
}
