/*
 * $Id: start.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The engine start gauge $
 *
 * $Log: start.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char start_gauge_name[]	= 	GAUGE_NAME;
extern PELEMENT_HEADER      start_list;
extern MOUSERECT            start_rect[];


MODULE_VAR generator1_active = {GENERAL_ENGINE1_GENERATOR_ACTIVE};
MODULE_VAR generator2_active = {GENERAL_ENGINE2_GENERATOR_ACTIVE};

/*
 * forward declarations
 */

PELEMENT_HEADER start_bg_list[];
FLOAT64 FSAPI start_engine1_icon_cb(PELEMENT_ICON);
FLOAT64 FSAPI start_engine2_icon_cb(PELEMENT_ICON);

void FSAPI start_gaugeproc(PGAUGEHDR, int, UINT32);

GAUGE_HEADER_FS700( GAUGE_W, start_gauge_name, &start_list, \
					start_rect, start_gaugeproc, 0, 0, 0);

/*
 * engine 2 starter icon
 */
MAKE_ICON
(      
	start_engine2_icon,
	BMP_START_ICON_OFF,
	NULL,
	NULL,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 131, 9 },
	GENERAL_ENGINE2_STARTER, start_engine2_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	3,
	0,
	0
)

/*
 * engine 1 starter icon
 */
MAKE_ICON
(      
	start_engine1_icon,
	BMP_START_ICON_OFF,
	NULL,
	NULL,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 0, 9 },
	GENERAL_ENGINE1_STARTER, start_engine1_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	3,
	0,
	0
)

/*
 * card background image
 */
MAKE_STATIC
(
    start_bg,
    BMP_START_BG,
    &start_bg_list,
    NULL,
	transparent | IMAGE_NO_STATIC_BLENDING,
	0,
	0,0
)

/*
 * priority lists
 */
PELEMENT_HEADER start_bg_list[] =
{
	&start_engine1_icon.header,
	&start_engine2_icon.header,
	NULL
};


extern PELEMENT_HEADER      start_list = &start_bg.header;

MOUSERECT start_rect[] =
{
    MOUSE_PARENT_BEGIN( 0, 0, 0, 0, HELP_NONE )
	    MOUSE_PARENT_BEGIN( 0, 0, 107, 59, HELPID_GAUGE_STARTER_LEFT )
		    MOUSE_CHILD_EVENT( 47, 0, 60, 20, CURSOR_HAND, MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, 66363 )
			MOUSE_CHILD_EVENT( 47, 20, 60, 20, CURSOR_HAND, MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, 66363 )
			MOUSE_CHILD_EVENT( 47, 40, 60, 20, CURSOR_HAND, MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, 66300 )
		MOUSE_PARENT_END
		MOUSE_PARENT_BEGIN( 129, 0, 107, 59, HELPID_GAUGE_STARTER_RIGHT )
			MOUSE_CHILD_EVENT( 47, 0, 60, 20, CURSOR_HAND, MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, 66364 )
			MOUSE_CHILD_EVENT( 47, 20, 60, 20, CURSOR_HAND, MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, 66364 )
			MOUSE_CHILD_EVENT( 47, 40, 60, 20, CURSOR_HAND, MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, 66301 )
		MOUSE_PARENT_END
	MOUSE_PARENT_END
    { MOUSE_RECT_EOL, { 0, 0, 0, 0 }, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL }
};




#undef		GAUGE_NAME
#undef		GAUGEHDR_VAR_NAME
#undef		GAUGE_W


////////////////////////////////////////////////////////////////////////////////
// gauge initialization proc
////////////////////////////////////////////////////////////////////////////////
void FSAPI start_gaugeproc( PGAUGEHDR pgauge, int service_id, UINT32 extra_data )
{
	
	switch(service_id)
	{
	case PANEL_SERVICE_PRE_INSTALL:		// install_routine()
		break;

	case PANEL_SERVICE_PRE_INITIALIZE:	// initialize_routine()
		initialize_var(&generator1_active);
		initialize_var(&generator2_active);
		break;

	case PANEL_SERVICE_PRE_UPDATE:		// update_routine()

		if (bPanelLightOn)	// if panel lights, brighten all elements
		{
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[1]);
		}
		else							// otherwise darken them
		{
			DARK_IMG(pgauge->elements_list[0]->N_E[0]);	
			DARK_IMG(pgauge->elements_list[0]->N_E[1]);	
    	}
		break;

	case PANEL_SERVICE_PRE_DRAW:		// draw_routine()
		break;

	case PANEL_SERVICE_PRE_KILL:		// kill_routine()
		break;
	}
}

/*
 * update engine 1 icon
 */
FLOAT64 FSAPI start_engine1_icon_cb(PELEMENT_ICON pelement)
{
	lookup_var(&generator1_active);
	if (generator1_active.var_value.n)
		return 2;
	else
		return pelement->source_var.var_value.n;
}


/*
 * update engine 2 icon
 */
FLOAT64 FSAPI start_engine2_icon_cb(PELEMENT_ICON pelement)
{
	lookup_var(&generator2_active);
	if (generator2_active.var_value.n)
		return 2;
	else
		return pelement->source_var.var_value.n;
}


