/*
 * $Id: tapealt.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The tape altimeter gauge $
 *
 * $Log: tapealt.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char tapealt_gauge_name[]	= 	GAUGE_NAME;
extern PELEMENT_HEADER      tapealt_list;
extern MOUSERECT            tapealt_rect[];

/*
 * forward declarations
 */
void FSAPI tapealt_gaugeproc(PGAUGEHDR, int, UINT32 );
FLOAT64 FSAPI tapealt_moving_cb(PELEMENT_MOVING_IMAGE);
GAUGE_HEADER_FS700( GAUGE_W, tapealt_gauge_name, &tapealt_list, \
					tapealt_rect, tapealt_gaugeproc, 0, 0, 0);




FAILURE_RECORD	tapealt_moving_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_FREEZE},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};


/*
 * radar altimeter tape
 */
MAKE_MOVING
( 
	tapealt_moving,
	BMP_TAPEALT_MOVING,
	NULL,
	tapealt_moving_fail,
	IMAGE_USE_ERASE,
	0,
	0,0,
	MODULE_VAR_NONE, NULL,
	0, 0,
	PLANE_ALTITUDE, tapealt_moving_cb,
	1500.0,0.0
)

/*
 * priority lists
 */
PELEMENT_HEADER tapealt_bg_list[] =
{
	&tapealt_moving.header,
	NULL
};



/*
 * background image
 */
MAKE_STATIC
(
    tapealt_bg,
    BMP_TAPEALT_BG,
    &tapealt_bg_list,
    NULL,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	0,0
)



extern PELEMENT_HEADER      tapealt_list = &tapealt_bg.header;

////////////////////////////////////////////////////////////////////////////////
// gauge initialization proc
////////////////////////////////////////////////////////////////////////////////
void FSAPI tapealt_gaugeproc( PGAUGEHDR pgauge, int service_id, UINT32 extra_data )
{
	switch(service_id)
	{
	case PANEL_SERVICE_PRE_INSTALL:		// install_routine()
		break;

	case PANEL_SERVICE_PRE_INITIALIZE:	// initialize_routine()
		break;

	case PANEL_SERVICE_PRE_UPDATE:		// update_routine()
		if (bPanelLightOn)	// if panel lights, brighten all elements
		{
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]);																					// attitude sprite
		}
		else							// otherwise darken them
		{
			DARK_IMG(pgauge->elements_list[0]->N_E[0]);																					// attitude sprite
    	}

		break;
	case PANEL_SERVICE_PRE_DRAW:		// draw_routine()
		break;

	case PANEL_SERVICE_PRE_KILL:		// kill_routine()
		break;
	}
}


MOUSERECT tapealt_rect[] =
{
    MOUSE_PARENT_BEGIN( 0, 0, 0, 0, HELP_NONE )
    MOUSE_PARENT_END
    { MOUSE_RECT_EOL, { 0, 0, 0, 0 }, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL }
};


#undef		GAUGE_NAME
#undef		GAUGEHDR_VAR_NAME
#undef		GAUGE_W

/*
 * update altimeter tape
 */
FLOAT64 FSAPI tapealt_moving_cb(PELEMENT_MOVING_IMAGE pelement)
{
	// source var is in AGL
	FLOAT64 f = pelement->source_var_y.var_value.n * METERSTOFEET;
	if (f>1500)
		f=1500;
	else if (f<0)
		f=0;
	return f;
}