/*
 * $Id: throttle.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The throttle gauge $
 *
 * $Log: throttle.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char throttle_gauge_name[]    = GAUGE_NAME;
extern PELEMENT_HEADER      throttle_list;
extern MOUSERECT            throttle_rect[];

/*
 * forward declarations
 */
PELEMENT_HEADER      throttle_bg_list[];

void FSAPI throttle_gaugeproc(PGAUGEHDR, int, UINT32);

GAUGE_HEADER_FS700( GAUGE_W, throttle_gauge_name, &throttle_list, \
					throttle_rect, throttle_gaugeproc, 0, 0, 0);

FAILURE_RECORD throttle_left_slider_fail[] =
{
   {FAIL_SYSTEM_ENGINE, FAIL_ACTION_NONE},
   {FAIL_NONE, FAIL_ACTION_NONE}
};

FAILURE_RECORD throttle_right_slider_fail[] =
{
   {FAIL_SYSTEM_ENGINE, FAIL_ACTION_NONE},
   {FAIL_NONE, FAIL_ACTION_NONE}
};


/*
 * right engine lever
 */
MAKE_SLIDER
(    
	throttle_right_slider,
	BMP_RIGHT_THROTTLE_SLIDER,
	NULL,
	throttle_right_slider_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 67, 130 },
	MODULE_VAR_NONE, NULL, 0.000000,
	ENGINE2_THROTTLE_LEVER_POS, NULL, -0.00354
)

/*
 * left engine lever
 */
MAKE_SLIDER
(    
	throttle_left_slider,
	BMP_LEFT_THROTTLE_SLIDER,
	NULL,
	throttle_left_slider_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 0, 130 },
	MODULE_VAR_NONE, NULL, 0.000000,
	ENGINE1_THROTTLE_LEVER_POS, NULL, -0.00354
)


/*
 * card background image
 */
MAKE_STATIC
(
    throttle_bg,
    BMP_THROTTLE_BG,
    &throttle_bg_list,
    NULL,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	0,0
)


/*
 * priority lists
 */
PELEMENT_HEADER      throttle_bg_list[] =
{
	&throttle_left_slider.header,
	&throttle_right_slider.header,
	NULL
};

extern PELEMENT_HEADER      throttle_list = &throttle_bg.header;

BOOL FSAPI SetLeftThrustLever(PPIXPOINT relative_point, FLAGS32 mouse_flags)
{
	int i = relative_point->y;
	if (i>195)
		i=195;
	else if (i<0)
		i=0;
	trigger_key_event(KEY_THROTTLE1_SET, 16383-((i*16383)/195));
	return FALSE;
}

BOOL FSAPI SetRightThrustLever(PPIXPOINT relative_point, FLAGS32 mouse_flags)
{
	int i = relative_point->y;
	if (i>195)
		i=195;
	else if (i<0)
		i=0;
	trigger_key_event(KEY_THROTTLE2_SET, 16383-((i*16383)/195));
	return FALSE;
}

MOUSERECT throttle_rect[] =
{

    MOUSE_PARENT_BEGIN( 0, 0, 0, 0, HELPID_GAUGE_THRUST_LEVERS )
        MOUSE_CHILD_FUNCT( 0, 0, 65, 195, CURSOR_HAND, MOUSE_LEFTSINGLE | MOUSE_LEFTDRAG, 
			SetLeftThrustLever )
        MOUSE_CHILD_FUNCT( 65, 0, 65, 195, CURSOR_HAND, MOUSE_LEFTSINGLE | MOUSE_LEFTDRAG, 
			SetRightThrustLever )
	MOUSE_PARENT_END
	{
		MOUSE_RECT_EOL, { 0, 0, 0, 0 }, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL
	}
};

/*
 * gauge initialization proc
 */
void FSAPI throttle_gaugeproc( PGAUGEHDR pgauge, int service_id, UINT32 extra_data )
{
	switch(service_id)
	{
	case PANEL_SERVICE_PRE_INSTALL:		// install_routine()
		break;

	case PANEL_SERVICE_PRE_INITIALIZE:	// initialize_routine()
		break;

	case PANEL_SERVICE_PRE_UPDATE:		// update_routine()
		break;

	case PANEL_SERVICE_PRE_DRAW:		// draw_routine()
		break;

	case PANEL_SERVICE_PRE_KILL:		// kill_routine()
		break;
	}
}

#undef GAUGE_NAME
#undef GAUGEHDR_VAR_NAME
#undef GAUGE_W

