/*
 * $Id: trim.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The trim indicator gauge $
 *
 * $Log: trim.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char trim_indicator_gauge_name[]    = GAUGE_NAME;
extern PELEMENT_HEADER      trim_indicator_list;
extern MOUSERECT            trim_indicator_rect[];

/*
 * forward declarations
 */
PELEMENT_HEADER      trim_indicator_bg_list[];

void FSAPI trim_indicator_gaugeproc(PGAUGEHDR, int, UINT32);


GAUGE_HEADER_FS700( GAUGE_W, trim_indicator_gauge_name, &trim_indicator_list, \
					trim_indicator_rect, trim_indicator_gaugeproc, 0, 0, 0);

FLOAT64 FSAPI trim_indicator_string_cb(PELEMENT_STRING);


FAILURE_RECORD trim_indicator_string_fail[] =
{
   {FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
   {FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
   {FAIL_NONE, FAIL_ACTION_NONE}
};



/*
 * trim indicator string
 */
MAKE_STRING
(
	trim_indicator_string,
	NULL,
	trim_indicator_string_fail,
	IMAGE_USE_ERASE | transparent,
	0,
	{5, 5},
	{90, 29},
	5,

	
	ELEVATOR_TRIM,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_RED,
	RGB(4,4,4),
	CL_WHITE,
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_CENTER,
	NULL,
	trim_indicator_string_cb
)


/*
 * card background image
 */
MAKE_STATIC
(
    trim_indicator_bg,
    BMP_TRIM_INDICATOR_BG,
    &trim_indicator_bg_list,
    NULL,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	0,0
)


/*
 * priority lists
 */
PELEMENT_HEADER      trim_indicator_bg_list[] =
{
	&trim_indicator_string.header,
	NULL
};

extern PELEMENT_HEADER      trim_indicator_list = &trim_indicator_bg.header;


MOUSERECT trim_indicator_rect[] =
{

    MOUSE_PARENT_BEGIN( 0, 0, 0, 0, HELPID_GAUGE_PITCH_TRIM_INDICATOR )
    MOUSE_PARENT_END
    { MOUSE_RECT_EOL, { 0, 0, 0, 0 }, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL }
};

#undef GAUGE_NAME
#undef GAUGEHDR_VAR_NAME
#undef GAUGE_W



/*
 * update trim indicator string
 */
FLOAT64 FSAPI trim_indicator_string_cb(PELEMENT_STRING pelement)
{
	FLOAT64 f = pelement->source_var[0].var_value.n * 180 / PI;

	FLOAT64 b = f;

	if (f<0)
	{
		b = -b;
		wsprintf(pelement->string,"-%0.2d.%0.1d",
			(int)b, (int)((b-(int)b)*10) );

	}
	else
	{
		wsprintf(pelement->string,"+%0.2d.%0.1d",
			(int)b, (int)((b-(int)b)*10) );
	}
	return f;
}



////////////////////////////////////////////////////////////////////////////////
// gauge initialization proc
////////////////////////////////////////////////////////////////////////////////
void FSAPI trim_indicator_gaugeproc( PGAUGEHDR pgauge, int service_id, UINT32 extra_data )
{
	switch(service_id)
	{
	case PANEL_SERVICE_PRE_INSTALL: /* "install_routine()" */
		break;

	case PANEL_SERVICE_PRE_INITIALIZE:	/* "initialize_routine()" */
		break;

	case PANEL_SERVICE_PRE_UPDATE: /* "update_routine()" */
		if (bPanelLightOn)	// if panel lights, brighten all elements
		{
			BRIGHT_IMG(pgauge->elements_list[0]->next_element[0]);
		}
		else
		{
			DARK_IMG(pgauge->elements_list[0]->next_element[0]);
		}
		break;

	case PANEL_SERVICE_PRE_DRAW: /* "draw_routine()" */
		break;

	case PANEL_SERVICE_PRE_KILL: /* "kill_routine()" */
		break;
	}
}
