/*
 * $Id: winglite.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The wing lights switch gauge $
 *
 * $Log: winglite.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char wls_gauge_name[]	= 	GAUGE_NAME;
extern PELEMENT_HEADER      wls_list;
extern MOUSERECT            wls_rect[];


/*
 * forward declarations
 */
FLOAT64 FSAPI wls_icon_cb(PELEMENT_ICON);
PELEMENT_HEADER wls_bg_list[];
GAUGE_HEADER_FS700( GAUGE_W, wls_gauge_name, &wls_list, \
					wls_rect, NULL, 0, 0, 0);



FAILURE_RECORD	wls_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NONE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};




/*
 * flight director icon
 */
MAKE_ICON
(
	wls_icon,
	BMP_WLS_ICON_ON,
	NULL,
	NULL,
	IMAGE_USE_ERASE | transparent,
	0,
	0, 0,
	WING_LIGHTS,
	wls_icon_cb,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	2,
	0.000000,
	0
)



/*
 * card background image
 */
MAKE_STATIC
(
    wls_bg,
    BMP_WLS_BG,
    &wls_bg_list,
    NULL,
	IMAGE_USE_ERASE | transparent,
	0,
	0,0
)

/*
 * priority lists
 */
PELEMENT_HEADER wls_bg_list[] =
{
	&wls_icon.header,
	NULL
};


extern PELEMENT_HEADER      wls_list = &wls_bg.header;

MOUSERECT wls_rect[] =
{
    MOUSE_PARENT_BEGIN( 0, 0, 0, 0, HELPID_GAUGE_LIGHT_SWITCH_WING )
		MOUSE_CHILD_EVENT( 0, 0, 33, 40, CURSOR_HAND, \
					MOUSE_LEFTSINGLE, KEY_TOGGLE_WING_LIGHTS )
    MOUSE_PARENT_END
    { MOUSE_RECT_EOL, { 0, 0, 0, 0 }, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL }
};


#undef		GAUGE_NAME
#undef		GAUGEHDR_VAR_NAME
#undef		GAUGE_W

FLOAT64 FSAPI wls_icon_cb(PELEMENT_ICON pelement)
{ 
	return pelement->source_var.var_value.n==1 ? 1 : 0;
}