/*
 * $Id: wiskey.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The wiskey compass gauge $
 *
 * $Log: wiskey.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char wiskey_gauge_name[]	= 	GAUGE_NAME;
extern PELEMENT_HEADER      wiskey_list;
extern MOUSERECT            wiskey_rect[];


/*
 * forward declarations
 */
void FSAPI wiskeygaugeproc(PGAUGEHDR, int, UINT32 );

GAUGE_HEADER_FS700( GAUGE_W, wiskey_gauge_name, &wiskey_list, \
					wiskey_rect, wiskeygaugeproc, 0, 0, 0);

FLOAT64 FSAPI wiskey_slider_x_cb(PELEMENT_MOVING_IMAGE pelement);
FLOAT64 FSAPI wiskey_slider_y_cb(PELEMENT_MOVING_IMAGE pelement);

FAILURE_RECORD wiskey_compass_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_MAGNETIC_COMPASS, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};


MAKE_MOVING
(
	wiskey_slider,
	BMP_WISKEY_COMPASS_SLIDER,
	NULL,
	wiskey_compass_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	{ 22, 41 },
	WHISKEY_COMPASS_DEGREES, wiskey_slider_x_cb, 0.000000, 360.000000,
	MODULE_VAR_NONE, wiskey_slider_y_cb, 0.000000, 0.000000
)


PELEMENT_HEADER wiskey_bg_list[] =
{
	&wiskey_slider.header,
	NULL
};


/*
 * card background image
 */
MAKE_STATIC
(
    wiskey_bg,
    BMP_WISKEY_COMPASS_BG,
    &wiskey_bg_list,
	NULL,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
	0,
	0,0
)

MOUSERECT wiskey_rect[] =
{
    MOUSE_PARENT_BEGIN( 0, 0, 0, 0, HELPID_GAUGE_WHISKEY_COMPASS )
    MOUSE_PARENT_END
    { MOUSE_RECT_EOL, { 0, 0, 0, 0 }, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL }
};


extern PELEMENT_HEADER      wiskey_list = &wiskey_bg.header;


////////////////////////////////////////////////////////////////////////////////
// gauge initialization proc
////////////////////////////////////////////////////////////////////////////////
void FSAPI wiskeygaugeproc( PGAUGEHDR pgauge, int service_id, UINT32 extra_data )
{
	switch(service_id)
	{
	case PANEL_SERVICE_PRE_INSTALL:		// install_routine()
		break;

	case PANEL_SERVICE_PRE_INITIALIZE:	// initialize_routine()
		break;

	case PANEL_SERVICE_PRE_UPDATE:		// update_routine()

		if (bPanelLightOn)	// if panel lights, brighten all elements
		{
			BRIGHT_IMG(pgauge->elements_list[0]);
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]);
		}
		else							// otherwise darken them
		{
			DARK_IMG(pgauge->elements_list[0]);
			DARK_IMG(pgauge->elements_list[0]->N_E[0]);
    	}
		break;
	case PANEL_SERVICE_PRE_DRAW:		// draw_routine()
		break;

	case PANEL_SERVICE_PRE_KILL:		// kill_routine()
		break;
	}
}



#undef		GAUGE_NAME
#undef		GAUGEHDR_VAR_NAME
#undef		GAUGE_W

/*
 * wiskey slider x-axis callback
 */
FLOAT64 FSAPI wiskey_slider_x_cb(PELEMENT_MOVING_IMAGE pelement)
{
	FLOAT64		val = 360.0 - pelement->source_var_x.var_value.n;
	if( val >= 0 && val <= 360 )
		return val;
	else
		return 0;
}

/*
 * wiskey slider x-axis callback
 */
FLOAT64 FSAPI wiskey_slider_y_cb(PELEMENT_MOVING_IMAGE pelement)
{
	return 0.0;
}

