/*
 * $Id: xpdrfreq.c,v 1.1 2004/09/16 16:43:31 alexanto Exp Alessandro $
 *
 * $Boeing 767 Gauge Pack - (C) 2004 Alessandro Antonini, Central Park Informatica $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: The transponder frequency regulator $
 *
 * $Log: xpdrfreq.c,v $
 * Revision 1.1  2004/09/16 16:43:31  alexanto
 * Initial revision
 *
 */

/*
 *  Set up gauge header
 */
char xpdr_freq_gauge_name[]	= 	GAUGE_NAME;
extern PELEMENT_HEADER      xpdr_freq_list;
extern MOUSERECT            xpdr_freq_rect[];


/*
 * forward declarations
 */
void FSAPI xpdrfreq_gaugeproc(PGAUGEHDR, int, UINT32);
FLOAT64 FSAPI xpdr_freq_string_cb(PELEMENT_STRING pelement);
PELEMENT_HEADER xpdr_freq_bg_list[];
GAUGE_HEADER_FS700( GAUGE_W, xpdr_freq_gauge_name, &xpdr_freq_list, \
					xpdr_freq_rect, xpdrfreq_gaugeproc, 0, 0, 0);

FAILURE_RECORD	xpdr_freq_string_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_NO_DRAW},
	{FAIL_SYSTEM_ELECTRICAL_AVIONICS, FAIL_ACTION_NO_DRAW},
	{FAIL_GAUGE_TRANSPONDER, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};



/*
 * the nav1 frequency string
 */
MAKE_STRING
(
	xpdr_freq_string,
	NULL,
	xpdr_freq_string_fail,
	IMAGE_USE_ERASE,
	0,
	{0, 0},
	{32, 18},
	4,

	TRANSPONDER_CODE,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	CL_LIME,
	RGB(4,4,4),
	CL_WHITE,
	FONT_QUARTZ,
	GAUGE_WEIGHT_DEFAULT,
	DEFAULT_CHARSET,
	0,
	DT_VCENTER | DT_SINGLELINE | DT_LEFT,
	NULL,
	xpdr_freq_string_cb
)



/*
 * card background image
 */
MAKE_STATIC
(
    xpdr_freq_bg,
    BMP_NAV_BG,
    &xpdr_freq_bg_list,
    NULL,
	IMAGE_USE_ERASE | transparent,
	0,
	0,0
)

/*
 * priority lists
 */
PELEMENT_HEADER xpdr_freq_bg_list[] =
{
	&xpdr_freq_string.header,
	NULL
};


extern PELEMENT_HEADER      xpdr_freq_list = &xpdr_freq_bg.header;

MOUSERECT xpdr_freq_rect[] =
{
    MOUSE_PARENT_BEGIN( 0, 0, 0, 0, HELP_NONE )

		// transponder regulator
		MOUSE_PARENT_BEGIN( 0, 0, 40, 20, HELPID_RADIO_TRANSPONDER )
			MOUSE_CHILD_EVENT( 0, 0, 10, 20, CURSOR_UPARROW,
				MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, KEY_XPNDR_1000_INC )
			MOUSE_CHILD_EVENT( 10, 0, 10, 20, CURSOR_UPARROW,
				MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, KEY_XPNDR_100_INC )
			MOUSE_CHILD_EVENT( 20, 0, 10, 20, CURSOR_UPARROW,
				MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, KEY_XPNDR_10_INC )
			MOUSE_CHILD_EVENT( 30, 0, 10, 20, CURSOR_UPARROW,
					MOUSE_DOWN_REPEAT | MOUSE_LEFTSINGLE, KEY_XPNDR_1_INC )
		MOUSE_PARENT_END


    MOUSE_PARENT_END
    { MOUSE_RECT_EOL, { 0, 0, 0, 0 }, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL }
};


#undef		GAUGE_NAME
#undef		GAUGEHDR_VAR_NAME
#undef		GAUGE_W

/*
 * update transponder string
 */
FLOAT64 FSAPI xpdr_freq_string_cb(PELEMENT_STRING pelement)
{ 
	UINT32 nFreq = (UINT32)pelement->source_var[0].var_value.d;

	// conversion
	wsprintf(pelement->string, "%0.4x", nFreq);
	return (FLOAT64)nFreq;

}


////////////////////////////////////////////////////////////////////////////////
// gauge initialization proc
////////////////////////////////////////////////////////////////////////////////
void FSAPI xpdrfreq_gaugeproc( PGAUGEHDR pgauge, int service_id, UINT32 extra_data )
{
	switch(service_id)
	{

	case PANEL_SERVICE_PRE_INSTALL:		// install_routine()
		break;

	case PANEL_SERVICE_PRE_INITIALIZE:	// initialize_routine()
		break;

	case PANEL_SERVICE_PRE_UPDATE:		// update_routine()
		if (bPanelLightOn)	// if panel lights, brighten all elements
		{
			BRIGHT_IMG(pgauge->elements_list[0]->N_E[0]);
		}
		else							// otherwise darken them
		{
			DARK_IMG(pgauge->elements_list[0]->N_E[0]);	
    	}
		break;

	case PANEL_SERVICE_PRE_DRAW:		// draw_routine()
		break;

	case PANEL_SERVICE_PRE_KILL:		// kill_routine()
		break;
	}
}
